//@charset "utf-8";
function Searcher(datas, container, that){

    this.datas = datas;
    
    this.$input = container;
    
    this.curIdx = 0; //记录当前位数
    this.that = that; //注入当前回调对象
    this.init = function(){
    
        this.render();
        
        this.addEventListener();
		
		return this;
    };
    
    
    this.render = function(){
        var div = '<div id="sea_content" ></div>';
//        var left = this.$input.position().left;
//        var top = this.$input.position().top + this.$input.height() - 5;
        //var width = this.$input.width();
        
        $('body').append(div);
        
        $('#sea_content').css({
            'position': 'absolute',
            'width': '155px',
            'overflow-x': 'hidden',
            'border': '1px solid #99BEE6',
            'z-index': '999',
            'display': 'none',
            'top': 100,
            'left': 15
        });
        
        
        
        
    };
    
    this.addEventListener = function(){
        var self = this;
//        this.$input.blur(function(){
//            $(this).val('搜索联系人');
//        });
        
        this.$input.click(function(){
            self.$input.focus(function(){
                $(this).val('');
            });
        });
        
        this.$input.focus(function(){
            $(this).val('');
            return false;
        });
        
        this.$input.keyup(function(event){
            var keyNum = event.which || event.keyCode;
            
            if (keyNum == 13) {
                var imid = $('#sea_content').find('span').eq(self.curIdx).attr('imid');
                self.that.seachClick(imid);
//                self.$input.blur();
                return;
            }
            
            if (keyNum == 38 || keyNum == 40) {
                return;
            }
            
            self.curIdx = 0;
            var keyWord = $(this).val();
            if (!$.trim(keyWord)) {
                $('#sea_content').hide();
                return;
            }
            var arr = [];
			            
            $.each(self.datas, function(key, val){
                if (val.indexOf(keyWord) > -1) {
                    arr.push({'imid':key,'name':val});
                }
            });
			
            if (arr.length * 20 > 200) {
                $('#sea_content').height(200);
                $('#sea_content').css('overflow-y', 'scroll');
            }
            else {
                $('#sea_content').height(arr.length * 20);
                
                $('#sea_content').css('overflow-y', 'hidden');
            }
            $('#sea_content').show();
            
            self.renderUL(arr);
            
        });
        
        $('body').keydown(function(event){
            if (self.noPerson) {
                return;
            }
            
            var keyNum = event.which || event.keyCode;
            
            if (keyNum == 38) { //up
                if (self.curIdx % 2 == 0) {
                    $('#sea_content').find('span').eq(self.curIdx).css({
                        'background': '#EEEEEE',
                        'color': 'black',
                        'display': 'block'
                    });
                }
                else {
                    $('#sea_content').find('span').eq(self.curIdx).css({
                        'background': '',
                        'color': 'black',
                        'display': 'block'
                    });
                }
                if (--self.curIdx < 0) {
                    self.curIdx = 0;
                }
                $('#sea_content').find('span').eq(self.curIdx).css({
                    'background': '#3394b7',
                    'color': 'white'
                });
                if ($('#sea_content').find('span').eq(self.curIdx).position().top < 0) {
                    $('#sea_content').scrollTop($('#sea_content').scrollTop() - 20);
                }
            }
            else 
                if (keyNum == 40) { //down
                    if (self.curIdx % 2 == 0) {
                        $('#sea_content').find('span').eq(self.curIdx).css({
                            'background': '#EEEEEE',
                            'color': 'black',
                            'display': 'block'
                        });
                    }
                    else {
                        $('#sea_content').find('span').eq(self.curIdx).css({
                            'background': '',
                            'color': 'black',
                            'display': 'block'
                        });
                    }
                    if (++self.curIdx >= $('#sea_content').find('span').length) {
                        self.curIdx = $('#sea_content').find('span').length - 1;
                    }
                    $('#sea_content').find('span').eq(self.curIdx).css({
                        'background': '#3394b7',
                        'color': 'white',
                        'display': 'block'
                    });
                    if ($('#sea_content').find('span').eq(self.curIdx).position().top > 180) {
                        $('#sea_content').scrollTop($('#sea_content').scrollTop() + 20);
                    }
                }
            
            if (keyNum == 13) {
                var imid = $('#sea_content').find('span').eq(self.curIdx).attr('imid');
                var text = $('#sea_content').find('span').eq(self.curIdx).text();
                
                if (!self.noPerson) {
                    self.$input.unbind('focus');
                    self.$input.val(text);
                    $('#sea_content').hide();
                }
                
            }
            
        });
        
        
        $('#sea_content').find('span').live('hover', function(){
            $('#sea_content').find('span').eq(self.curIdx).css({
                'background': '',
                'color': 'black',
                'display': 'block'
            });
            self.curIdx = $(this).index();
            $('#sea_content').find('span').eq(self.curIdx).css({
                'background': '#3394b7',
                'color': 'white'
            });
        }, function(){
            $('#sea_content').find('span').eq(self.curIdx).css({
                'background': '',
                'color': 'black',
                'display': 'block'
            });
            
        });
        
        $('#sea_content').find('span').live('dblclick', function(event){
            var imid = $(this).attr('imid');
            var text = $(this).text();
            
            if (!self.noPerson) {
                self.$input.unbind('focus');
                self.$input.val(text);
                self.$input.focus();
                $('#sea_content').hide();
            }
            event.preventDefault();
            window.event.cancelBubble = true;
            return false;
        });
        
		$('body').click(function(event){
			if(event.target.napster == 'zxj'){
				return;
			}
			$('#sea_content').hide();
		});
        
    };
    
    this.renderUL = function(arr){
        var htmlArr = [];
        
        for (var i = 0; i < arr.length; i++) {
            if (i == 0) {
                htmlArr.push('<span napster="zxj" imid="' + arr[i]['imid'] + '" class="spanCls" style="background:#3394b7; color:white; display:block">' + arr[i]['name'] + '</span>');
            }
            else 
                if (i % 2 == 0) {
                    htmlArr.push('<span napster="zxj" imid="' + arr[i]['imid'] + '" class="spanCls">' + arr[i]['name'] + '</span>');
                }
                else 
                    if (i % 2 == 1) {
                        htmlArr.push('<span napster="zxj"  imid="' + arr[i]['imid'] + '">' + arr[i]['name'] + '</span>');
                    }
        }
        this.noPerson = false;
        if (arr.length == 0) {
            htmlArr.push('<span style="background:#EEEEEE; display:block;">无此人</span>');
            $('#sea_content').height(20);
            this.noPerson = true;
        }
        
        $('#sea_content').html(htmlArr.join(''));
        
    };
    
    this.changeDatas = function(datas){
        this.datas = datas;
    };
	
	this.showNoDiv = function(){
		var htmlArr = [];
		htmlArr.push('<span style="background:#EEEEEE; display:block;">无此人</span>');
        $('#sea_content').height(20);
        this.noPerson = true;
		$('#sea_content').html(htmlArr.join(''));
	};
    
}
