/**
 * 基础类
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2013-11-26
 */
var Base = Class.extend({

	init: function(cfg){
		for(var attr in cfg){
			if( cfg[attr] == undefined ){
				cfg[attr] = null;
			}
			this[attr] = cfg[attr];
		}
	},
	
	set: function(key, value){
		if(!key){
			return null;
		}
		if( value == undefined ){
			value = null;
		}
		this[key] = value;
	},
	
	get: function(key){
		if(!key){
			return null;
		}
		var value = this[key];
		if( value == undefined ){
			value = null;
		}
		return value;
	}
});