// @charset "utf-8";
/**
 * 获取行情后渲染页面1
 */
// 开始时间276
// 截止时间277
// 价格下限70
// 价格上限69
// 冷静期参考价51
// 现价10
// 买一 24
// 卖一 30
// 买一量 25
// 卖一量 31
// 参考不平衡成交量 278

var getUrlParam = function(item) {
	var value = location.search.match(new RegExp("[\?\&]" + item + "=([^\&]*)(\&?)", "i"));
	//return 'HK0001';
	return value ? value[1] : value;
};
var thsQuote = '';
var pageCode = getUrlParam('code');
var pageCodes = [pageCode,'HSI'];

var quotes = ['282', '10', '276', '277', '69', '70', '24', '30', '25', '31', '278','271','49'];
var hqrequest = new ComHqData({stocks:pageCodes, quote:quotes, callback:renderRequestHq, pushcallback: renderPushHq});
hqrequest.create();
setInterval(function(){
	hqrequest.create();
},'3000');

function renderRequestHq(data){
	var $referenceprice = $('#view_span_referenceprice');//参考价
	var $tradingsession = $('#view_span_tradingsession');
	var $priceceiling = $('#view_span_priceceiling');
	var $presentprice = $('#view_span_presentprice');//最新价

	var $pricelower = $('#view_span_pricelower');
	var $equilibriumprice = $('#view_span_equilibriumprice');//参考平衡价
	var $direction = $('#view_span_direction');
	var $volume = $('#view_span_volume');
	var $unbalancenum = $('#view_span_unbalancenum');

	var marketStatus = string(data['HSI']['282']);

	var equilibriumprice = '--',
		volume = '--',
		referenceprice = '--',
		presentprice = '--',
		priceceiling = '--',
		pricelower = '--',
		direction = '--',
		unbalancenum = '--',
		directionText = '--',
		unbalancenum = '--';

	var theMarketStatus = '--';
	if (!marketStatus && marketStatus != 0) {
		equilibriumprice = '--';
		volume = '--';
	} else {

		// 交易时段
		var marketStatusObj = {
			"4": '买卖盘配对',
			"5": '输入买卖盘',
			"105": '参考定价',
			"106": '不可取消',
			"107": '随机收盘',
			"0": '收盘'
		};
		
		theMarketStatus = marketStatusObj[marketStatus];
		
		var buy = data[pageCode]['24'] == 'NUL' ? '--' : data[pageCode]['24'],
			sell = data[pageCode]['30'] == 'NUL' ? '--' : data[pageCode]['30'],
			buynum = data[pageCode]['25'] == 'NUL' ? '--' : data[pageCode]['25'],
			sellnum = data[pageCode]['31'] == 'NUL' ? '--' : data[pageCode]['31'],
			xianshou = data[pageCode]['49'] == 'NUL' ? '--' : data[pageCode]['49'];
		
		var marks = data[pageCode]['271'];

		var marksyu = marks&4;
		if (marketStatus == 105 || marketStatus == 106 || marketStatus == 5) {
			referenceprice = data[pageCode]['10'] == 'NUL' ? '--' : data[pageCode]['10'];
			presentprice = data[pageCode]['10'] == 'NUL' ? '--' : data[pageCode]['10'];
		} else {
			referenceprice = '--';
			presentprice = data[pageCode]['10'] == 'NUL' ? '--' : data[pageCode]['10'];
		}

		if (marketStatus == 107 || marketStatus == 0|| marketStatus == 4|| marketStatus == 5|| marketStatus == 106|| marketStatus == 105) {
			if (buy == sell && marksyu == 4 && (buy != '--' || sell != '--') ) {
				if(buynum >= sellnum){
					volume = sellnum;
				}else {
					volume = buynum;
				}
				equilibriumprice = buy;
				referenceprice = '--';
				
			} else if(marketStatus == 0 && marksyu == 4){
				volume = xianshou;
				equilibriumprice = buy;
				referenceprice = '--';
			}else{
				equilibriumprice = '--';
				//referenceprice = presentprice;
				volume = '--';
			}
		}

		

		priceceiling = data[pageCode]['69'] == 'NUL' ? '--' : data[pageCode]['69'];
		pricelower = data[pageCode]['70']== 'NUL' ? '--' : data[pageCode]['70'];
		var directionValue = data[pageCode]['278'] == 'NUL' ? '--' : data[pageCode]['278'];

		if (directionValue > 0) {
			directionText = '买盘大于卖盘';
		} else if (directionValue < 0) {
			directionText = '卖盘大于买盘';
		} else if (directionValue == 0) {
			directionText = '卖盘等于买盘';
		} else {
			directionText = '--';
		}
		if (isNaN(parseFloat(directionValue))) {
			unbalancenum = '--';
		} else {
			unbalancenum = Math.abs(parseFloat(directionValue));
		}

	}

	$referenceprice.text(referenceprice);
	if (theMarketStatus == undefined || theMarketStatus == 'undefined') {
		$tradingsession.text('--');
	}
	$tradingsession.text(theMarketStatus);
	$priceceiling.text(priceceiling);
	$presentprice.text(presentprice);
	$pricelower.text(pricelower);
	$equilibriumprice.text(equilibriumprice);
	$direction.text(directionText);
	$volume.text(volume);

	$unbalancenum.text(unbalancenum);

};


function renderPushHq(data){
	var referenceprice = data[pageCode]['new'] == 'NUL' ? '--' : data[pageCode]['new'];
	$('#view_span_presentprice').html(referenceprice);
}

function string(str){
	var str3 = str.substring(0,3);
	return str3;
}

	