//@charset "utf-8";
define("./dist/app" ,["C:/gulp/customplates/js/static/lib/common.js","C:/gulp/customplates/js/static/views/platelist.js","C:/gulp/customplates/js/static/views/search.js","C:/gulp/customplates/js/static/views/content.js","C:/gulp/customplates/js/static/views/form.js"], function(require , exports , module){
	try {
		//require('../static/views/userguide');
		
		var commonMethod = require("C:/gulp/customplates/js/static/lib/common.js");
		commonMethod.init();

		var PlateListView = require("C:/gulp/customplates/js/static/views/platelist.js");
		new PlateListView();

		require("C:/gulp/customplates/js/static/views/search.js");
		require("C:/gulp/customplates/js/static/views/content.js");

	    var FormView = require("C:/gulp/customplates/js/static/views/form.js");
		var formView = new FormView();
		formView.bind();
	} catch (e) {
		alert(e.message);
	}
});

// @charset "utf-8";
define("C:/gulp/customplates/js/static/lib/common.js" ,[], function(require , exports , module){
	
	var CommonMethod = function(){
		// 全局初始化
		this.init = function(){  
			// 禁止右击菜单
			document.oncontextmenu=function(event) {  
			    if (document.all) { 
			        window.event.returnValue = false;}// for IE  
			    else {  
			        event.preventDefault();
			      }  
			}; 
		};
		// 查询数组中val的index
		this.arrIndexOf = function(arr, val){
			for(var i = 0; i < arr.length; i++){
				if(arr[i] === val) {return i;}
			}
			return -1;
		};
		// 删除数组中某一个val
		this.arrRemove = function(arr,val) {
			var index = this.arrIndexOf(arr,val);
			if(index > -1){
				arr.splice(index,1);
			}
			return arr;
		};
		// input转义字符处理,不要添加其他
		this.escapeHtml = function(string){
			var entityMap = {
				"<" : "&lt;",
				">" : "&gt;"
			};
			return String(string).replace(/[<>]/g,function(s){
				return entityMap[s];
			});
		};

	};

	module.exports = new CommonMethod();
});
//@charset "utf-8";
define("C:/gulp/customplates/js/static/views/platelist.js" ,["_","C:/gulp/customplates/js/static/models/platelist.js","C:/gulp/customplates/js/static/models/querysearch.js","C:/gulp/customplates/js/static/lib/common.js","C:/gulp/customplates/js/static/models/codelist.js","C:/gulp/customplates/js/static/views/base.js"], function(require , exports , module){
	var _ = require('_');
	var plateListModel = require("C:/gulp/customplates/js/static/models/platelist.js");
	var QuerySearchModel = require("C:/gulp/customplates/js/static/models/querysearch.js");
	var commonMethod = require("C:/gulp/customplates/js/static/lib/common.js");
	var CodeListModel = require("C:/gulp/customplates/js/static/models/codelist.js");
	var BaseView = require("C:/gulp/customplates/js/static/views/base.js");
	var PlateListView = BaseView.extend({
		el: '#sidebarbox, .tip-win-plate',
		plateTemplate: _.template($('#template_plate').html()),
		plateNames:[],
		stockList:[],
		events: {
			'mouseenter .items' : 'hoverItems',
			'mouseleave .items' : 'hideItems',
			'click .items-name': 'jumpPlate',
			'click #new-plate' : 'showNewPlate',
			'click #span-cancel-add-plate' : 'hideAddPlate',
			'click .span-plate-delete' : 'showTipWinDetelePlate',
			'click #tip_win_submit' : 'deletePlate',
			'click #tip_win_cancel' : 'cancelDelete',
			'click .span-plate-rename' : 'showTipWinRenamePlate',
			'click .span-plate-rename-realtime' : 'showTipWinRenamePlateRealtime',
			'click #rename_win_cancel' : 'hideRenamePlateWin',
			'click #rename_win_submit' : 'savePlateRename',
			'change #input-add-plate-content' : 'changeAddPlateContent',
			'click #span-submit-add-plate' : 'addPlateCreate',
			'click #span-submit-add-dynamic-plate' : 'addDynamicPlate',
			'click #span-cancel-add-dynamic-plate' : 'hideAddPlate',
			'click .items-update-click' : 'modifyNeedUpdate',
			'click #rename_win_cancel_realtime' : 'hideRenamePlateWinRealtime',
			'click #rename_win_submit_realtime' : 'savePlateRenameRealtime'
		},
		initialize: function(){
			var self = this;

			self.requestPlateList();

			setInterval(function(){
				//定时同步动态板块的状态，使用定时器代替推送
				self.syncRequestPlateList();
			}, 2000);
			

			// 回车保存
			$('#rename_win_input, #input-add-plate-content').keypress(function(e) {
				e = e || window.event;
				if (e.keyCode == 13) {
					if($(e.currentTarget).attr('status') === 'add') {
						self.savePlateCreate();
					} else {
						self.savePlateRename();
					}
				}
			});
			$('#rename_win_input_realtime').keypress(function(e) {
				e = e || window.event;
				if (e.keyCode == 13) {
					if($(e.currentTarget).attr('status') !== 'add') {
						self.savePlateRenameRealtime();
					}
				}
			});


			// 创建实时更新板块
			$('#view_result_condition_create,#create-stocks').live('click',function(){
				var condition = $('#view_searchinput').val();
				if (condition.replace(/\s/g, '') === $('#view_searchinput').attr('data-placeholder')) {
					return ;
				}
				if($('.view_second_option.selected').length){
					var secondList = [];
					secondList.push(condition);
					$('.view_second_option.selected').each(function () {
						secondList.push($(this).html());
					});
					condition = secondList.join(";");
				}
				self.showAddDynamicPlate(condition);
			});
		},
		requestPlateList : function() {
			var self = this;
			// 渲染板块股
			plateListModel.requestList(function(data){
				var platelistDom = '';
				//alert(JSON.stringify(data));
				$.each(data,function(i,item){
					self.plateNames.push(item.name);
					if(i === 0){
						platelistDom += self.plateTemplate({
							type:'optional', // 自选股板块
							id:item.id,
							num:'(' + item.num + ')',
							showtxt:self.showtxt(item.name), 
							inputtxt:commonMethod.escapeHtml(item.name),
							update : plateListModel.isCustomBlockNeedUpdate(item.id)
						});
						return;
					}
					if(i <= 8){
						platelistDom += self.plateTemplate({
							type:'fixed', // 固定的8个板块
							id:item.id,
							num:'(' + item.num + ')',
							showtxt:self.showtxt(item.name), 
							inputtxt:commonMethod.escapeHtml(item.name),
							update : plateListModel.isCustomBlockNeedUpdate(item.id)							
						});
						return;
					}
					//isSelect这个字段表示什么？
					if(item.isSelect === 0){
						platelistDom += self.plateTemplate({
							type:'default',
							id:item.id,
							num:'(' + item.num + ')',
							showtxt:self.showtxt(item.name), 
							inputtxt:commonMethod.escapeHtml(item.name),
							update : plateListModel.isCustomBlockNeedUpdate(item.id)
						});
					}else if(item.isSelect === 1){
						platelistDom += self.plateTemplate({
							type:'realtime',
							id:item.id,
							num:'(' + item.num + ')',
							showtxt:self.showtxt(item.name), 
							inputtxt:commonMethod.escapeHtml(item.name),
							update : plateListModel.isCustomBlockNeedUpdate(item.id)
						});
					}
				});

				$('#sidebarbox-items').html(platelistDom);
			});

		},
		showTipWinDetelePlate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			$('#div-mask').show();
			$('#tip_win_submit').attr('data-id', dataId);
			$("#tip_win_delete_plate").show();
			TA.log({id : '579099db_308'});
		},
		cancelDelete : function() {
			$('#div-mask').hide();
			$('#tip_win_submit').attr('data-id', '');
			$("#tip_win_delete_plate").hide();
		},
		deletePlate: function(e){
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			this.savePlateDelete(dataId, $('#items-data-id-'+dataId));
			this.cancelDelete();
			TA.log({id : 'cop_581206ee_248'});
		},
		savePlateRename: function(){
			var self = this;
			var newname = $("#rename_win_input").val();
			var plateId = $("#rename_win_data_id").val();
			var oldname = $("#rename_win_oldname").val();

			this.plateNames = commonMethod.arrRemove(this.plateNames, oldname);
			var nameObj = plateListModel.formatPlateName(this.plateNames, newname);
			newname = nameObj.newname;
			this.plateNames = nameObj.platenames;
			plateListModel.requestRename(plateId, newname, function(isOk){
				if(isOk){
					$("#view-a-data-id-"+plateId).attr('title', newname);
					$("#view-a-data-id-"+plateId).text(self.showtxt(newname));
					self.plateNames = nameObj.platenames;
				}else{
					$("#view-a-data-id-"+plateId).attr('title', oldname);
					$("#view-a-data-id-"+plateId).text(self.showtxt(oldname));
					self.plateNames.push(oldname);
				}
			});
			
			self.hideRenamePlateWin();
			TA.log({id : 'cop_5812079a_304'});
		},
		savePlateCreate : function(name, codelist, type){  // 实时板块传参
			var self = this;
			codelist = codelist || '';
			name = name || '';
			var condition = '';
			if(type === 1 && name){  // 创建实时（含板块股）
				condition = $('#input-add-plate-content-dynamic').val();
			}
			name = name || $('#input-add-plate-content').val();
			var nameObj = plateListModel.formatPlateName(this.plateNames, name);
			this.plateNames = nameObj.platenames;
			name = nameObj.newname;
			plateListModel.requestCreate(name, condition, function(id) {
				if(id) {					
					if(codelist.length > 0) {
						self.savePlateAdd(id, codelist);
					}
					self.requestPlateList();
					self.showtip("板块创建成功！");
				}else { //创建失败
					self.showtip("超过板块上限100，创建失败！");
				}
				$('#sidebarbox-items').scrollTop(9999);
			});
			self.hideAddPlate();
		},
		savePlateDelete: function(id, $dom){
			var self = this;

			plateListModel.requestDelete(id,function(isOk){
				if(isOk){
					self.removePlate($dom);
					self.plateNames = plateListModel.removePlateName(self.plateNames, $dom.find('input').val());
				}else {
					self.showtip("板块删除失败！");
				}
			});
		},
		removePlate: function($dom){
			$dom.remove();
		},
		// 板块名显示长度处理
		showtxt: function(txt){
			var len = 0;
			var resultTxt = '';
			for(var i=0; i<txt.length; i++){ // 汉字2字节  7*2
				if(len >= 14){
					resultTxt += '...';
					return resultTxt;
				}
				if(txt.charCodeAt(i)>127 || txt.charCodeAt(i)==94){
					len += 2;
				}else {
					len += 1;
				}
				resultTxt += txt.charAt(i);
			}
			return resultTxt;
		},
		jumpPlate: function(e){
			TA.log({id : '57909a17_618'});
			var $dom = $(e.currentTarget);
			// $dom.find('.ico-update').remove();
			$('.choose').removeClass('choose');
			$dom.addClass('choose');
			plateListModel.jumpPlate($dom.attr('data-id'));
		},
		changeAddPlateContent : function() {
			$('#input-add-plate-content-default').val("")
		},
		showNewPlate : function() {
			$('#div-mask').show();
			$('#input-add-plate-content').val("请输入板块名");
			$('#tip_win_add_plate').show();
			$('#input-add-plate-content').select();
			TA.log({id : '579098d2_466'});
		},
		hideAddPlate : function() {
			$('#div-mask').hide();
			$('#input-add-plate-content').val('');
			$('#tip_win_add_plate').hide();

			//动态板块
			$('#input-add-plate-dynamic-content').val('');
			$('#tip-win-add-dynamic-plate').hide();
		},
		hoverItems : function(e) {
			//鼠标经过效果
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			$("#operate-data-id-"+dataId).show();
			$("#operatemore-data-id-"+dataId).show();
			$("#items-name-data-id-"+dataId).addClass('mouseEnter');
		},
		hideItems : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			$("#operate-data-id-"+dataId).hide();
			$("#operatemore-data-id-"+dataId).hide();
			$("#items-name-data-id-"+dataId).removeClass('mouseEnter');
		},
		showTipWinRenamePlate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			var name = $("#view-a-data-id-"+dataId).attr('title');
			$("#tip_win_rename_plate").show();
			$("#rename_win_data_id").val(dataId);
			$("#rename_win_input").val(name);
			$("#rename_win_oldname").val(name);
			$("#rename_win_input").select();
			$('#div-mask').show();
			TA.log({id : '579099c5_9'});
		},
		hideRenamePlateWin : function() {
			$("#tip_win_rename_plate").hide();
			$("#rename_win_data_id").val('');
			$("#rename_win_input").val('');
			$("#rename_win_oldname").val('');
			$('#div-mask').hide();
		},
		addPlateCreate : function() {
			TA.log({id : 'cop_581200a2_699'});
			var self = this;
			var name = $('#input-add-plate-content').val();
			if ($('#input-add-plate-content-default').val() !== "") {
				name = $('#input-add-plate-content-default').val();
			}
			if (name === '') {
				return ;
			}
			self.savePlateCreate(name);
		},
		showAddDynamicPlate : function(condition) {
			$('#div-mask').show();
			$('#input-add-plate-name-dynamic').val(condition);
			$('#input-add-plate-content-dynamic').val(condition);
			$('#tip-win-add-dynamic-plate').show();
			$('#input-add-plate-name-dynamic').select();
		},
		//修改（冻结/开启）动态更新
		modifyNeedUpdate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			var updateStatus = $dom.attr('update-status');
			updateStatus = updateStatus === '0' ? true : false;
			try{
				plateListModel.enableCustomBlockUpdate(parseInt(dataId), updateStatus);
				if (updateStatus === true) {
					$dom.attr('update-status', 1);
					$dom.removeClass('items-update0');
					$dom.addClass('items-update1');
					$dom.attr("title", "关闭更新状态");
					TA.log({id : 'cop_58120933_193'});
				} else {
					$dom.attr('update-status', 0);
					$dom.removeClass('items-update1');
					$dom.addClass('items-update0');
					$dom.attr("title", "开启更新状态");
					TA.log({id : 'cop_5812094f_730'});
				}
			} catch (e) {
				
			}
		},
		//执行添加动态版块
		addDynamicPlate : function() {
			var self = this;
			var data = QuerySearchModel.get('result').data;
			var codelist = [];
			$.each(data,function(i,obj){
				codelist.push(obj.code);
			});
			var name = $("#input-add-plate-name-dynamic").val();
			self.savePlateCreate(name,codelist,1);
			TA.log({id : '579098fd_342'});
		},
		showTipWinRenamePlateRealtime :function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var dataId = $dom.attr('data-id');
			var name = $("#view-a-data-id-"+dataId).attr('title');
			$("#tip_win_rename_plate_realtime").show();
			$("#rename_win_data_id_realtime").val(dataId);
			$("#rename_win_input_realtime").val(name);
			$("#rename_win_oldname_realtime").val(name);
			$("#rename_win_input_realtime").select();
			$('#div-mask').show();
			TA.log({id : '579099c5_9'});
		},
		hideRenamePlateWinRealtime : function() {
			$("#tip_win_rename_plate_realtime").hide();
			$("#rename_win_data_id_realtime").val('');
			$("#rename_win_input_realtime").val('');
			$("#rename_win_oldname_realtime").val('');
			$('#div-mask').hide();
		},
		savePlateRenameRealtime : function() {
			var self = this;
			var newname = $("#rename_win_input_realtime").val();
			var plateId = $("#rename_win_data_id_realtime").val();
			var oldname = $("#rename_win_oldname_realtime").val();

			this.plateNames = commonMethod.arrRemove(this.plateNames, oldname);
			var nameObj = plateListModel.formatPlateName(this.plateNames, newname);
			newname = nameObj.newname;
			this.plateNames = nameObj.platenames;
			plateListModel.requestRename(plateId, newname, function(isOk){
				if(isOk){
					$("#view-a-data-id-"+plateId).attr('title', newname);
					$("#view-a-data-id-"+plateId).text(self.showtxt(newname));
					self.plateNames = nameObj.platenames;
				}else{
					$("#view-a-data-id-"+plateId).attr('title', oldname);
					$("#view-a-data-id-"+plateId).text(self.showtxt(oldname));
					self.plateNames.push(oldname);
				}
			});
			
			self.hideRenamePlateWinRealtime();
			TA.log({id : 'cop_5812079a_304'});
		},
		//同步板块是否开启动态更新状态
		syncRequestPlateList : function() {
			$(".items-update-click").each(function(){
				var plateId = $(this).attr("data-id");
				var status = plateListModel.isCustomBlockNeedUpdate(plateId);
				if (status != $(this).attr("update-status")) {
					$(this).removeClass("items-update0");
					$(this).removeClass("items-update1");
					$(this).addClass("items-update"+status);
					$(this).attr("update-status", status);
				}
			});
		}
	});

	module.exports = PlateListView;
});
//@charset "utf-8";
define("C:/gulp/customplates/js/static/views/search.js" ,["backbone","C:/gulp/customplates/js/static/lib/jpjl.js","C:/gulp/customplates/js/static/views/content.js","C:/gulp/customplates/js/static/views/querysearch.js","C:/gulp/customplates/js/static/views/stocksearch.js","C:/gulp/customplates/js/static/views/relationquery.js"], function(require , exports , module){
	var Backbone = require('backbone');

	//键盘精灵
	var JpjlModel = require("C:/gulp/customplates/js/static/lib/jpjl.js");

	try {
		var jpjlModel = new JpjlModel({
			inputSelector : '#view_searchinput',
			appendToSelector : '#view_search_options_jpjl',
			//addBtnSelector : '#view_searchbtn',
			showListNum : 3
		});
	    jpjlModel.render({
			left : 0,
			top : 0
		});
	} catch (e) {
		
	}

	var contentView = require("C:/gulp/customplates/js/static/views/content.js");
	var querySearchView = require("C:/gulp/customplates/js/static/views/querysearch.js");
	var stockSearchView = require("C:/gulp/customplates/js/static/views/stocksearch.js");
	var relationQueryView = require("C:/gulp/customplates/js/static/views/relationquery.js");


	var SearchView = Backbone.View.extend({
		el : '#view_div_searchbox',
		// 1 选股  2 联想
		searchType : 1,
		isInputChange : false,
		inputValue : '',
		events : {
			'keyup #view_searchinput' : 'checkInputValue',
			'keydown #view_searchinput' : 'listenInputDown',
			'blur #view_searchinput' : 'blurInputValue',
			'focus #view_searchinput' : 'focusInputValue',
			'click #view_searchbtn' : 'doSearch',
			'click #view_searchinput' : 'hiddenPlateOption'
		},
		initialize : function () {
			// 初始化search样式
			$('#view_searchinput').css('color','#9E9E9E');
			var placeholder = $('#view_searchinput').attr('data-placeholder');
			$('#view_searchinput').val(placeholder);
			$('#view_searchinput').blur();
		},
		listenInputDown : function () {
			if (this.inputValue !== $('#view_searchinput').val()) {
				this.inputValue = $('#view_searchinput').val();
				this.isInputChange = true;
				return ;
			}

			this.isInputChange = false;
		},
		checkInputValue : function (e) {
			e = e || window.event;
			$('#view_search_options_relation').hide();
			var inputValue = $('#view_searchinput').val().replace(/\s/g, '');
			var placeholder = $('#view_searchinput').attr('data-placeholder');
			if (placeholder === inputValue || '' === inputValue) {
				contentView.init();
				return ;
			}

			if (e.keyCode === 13 && this.isInputChange) {
				if ('block' === $('#view_search_options_relation').css('display')) {
					$('#view_searchinput').val($('.active.view_relation_query_item').text());
				}
				this.doSearch();
				return ;
			}

			if (null === jpjlModel.getInputCodeData()) {
				this.doRelationQuery(inputValue);
			}
		},
		focusInputValue : function () {
			TA.log({id : '57909977_357'});
			var placeholder = $('#view_searchinput').attr('data-placeholder');
			var inputValue = $('#view_searchinput').val().replace(/\s/g, '');
			$('#view_div_searchbox').addClass('searchbox-focus');
			$('#view_searchbtn').addClass('searchbtn-focus');

			if (placeholder === inputValue) {
				$('#view_searchinput').val('');
			}
			if(inputValue != '' && placeholder != inputValue){
				$("#view_clearbtn").show();
			}
		},
		blurInputValue : function () {
			var placeholder = $('#view_searchinput').attr('data-placeholder');
			var inputValue = $('#view_searchinput').val().replace(/\s/g, '');
			$('#view_div_searchbox').removeClass('searchbox-focus');
			$('#view_searchbtn').removeClass('searchbtn-focus');

			if ('' === inputValue) {
				$('#view_searchinput').css('color','#9E9E9E');
				$('#view_searchinput').val(placeholder);
				return ;
			}
		},
		doSearch : function () {
			var self = this;
			var placeholder = $('#view_searchinput').attr('data-placeholder');
			var inputValue = $('#view_searchinput').val().replace(/\s/g, '');
			if ('' === inputValue || placeholder === inputValue) {
				return ;
			}
			self.resetTable();
			self.clearSearchResult();
			$('#view_searchinput').css('color','#000');
			this.hideAllResultDiv();

			TA.log({id : '579097f4_415'});
			TA.log({
		        id : 'zx_userput_0002',
		        userput : inputValue
		    });
			if (null === jpjlModel.getInputCodeData()) {
				$('#view_result_condition_second').empty();
				this.doQuerySearch(inputValue);

				return ;
			}

			var stockCode = $('.autocomplete').find('.selected').find('strong').text();
			$('#view_searchinput').val(stockCode);
			
			this.doStockSearch(stockCode);
		},
		resetTable : function () {
			$(".sort").each(function(){
				$(this).html("");
			});
			$(".zdf").each(function(){
				$(this).parent().attr("type", "asc");
				$(this).html("↓");
			});
		},
		doStockSearch : function (str) {
			stockSearchView.request(str);
		},
		doQuerySearch : function (str) {
			querySearchView.request(str);
		},
		doRelationQuery : function (str) {
			relationQueryView.request(str);
		},
		hideAllResultDiv : function () {
			stockSearchView.hideEl();
			querySearchView.hideEl();
			relationQueryView.hideEl();

			$('#defaultView').hide();
			$('#view_result_condition_second').hide();
		},
		//隐藏板块选项
		hiddenPlateOption : function() {
			$("#view_select_option").hide();
		},
		//清理历史搜索结果
		clearSearchResult : function() {
			$("#view_code_list").html("");
			$("#view_result_condition_table_tbody").html("");
			$("#view_select_choose_name").addClass("add-plate-lock");//恢复到初始状态
			$(".selectAll").each(function(){
				$(this).prop("checked", false);
			});
		}
	});

	module.exports = new SearchView();
});
//@charset "utf-8";
// 默认主体
define("C:/gulp/customplates/js/static/views/content.js" ,["backbone","C:/gulp/customplates/js/static/models/hotquery.js","C:/gulp/customplates/js/static/models/historyquery.js","C:/gulp/customplates/js/static/models/platelist.js","C:/gulp/customplates/js/static/views/base.js","C:/gulp/customplates/js/static/models/codelist.js"], function(require , exports , module){
	var Backbone = require('backbone');

	var hotQueryModel = require("C:/gulp/customplates/js/static/models/hotquery.js");
	var historyQueryModel = require("C:/gulp/customplates/js/static/models/historyquery.js");
	var plateModel = require("C:/gulp/customplates/js/static/models/platelist.js");
	var BaseView = require("C:/gulp/customplates/js/static/views/base.js");
	var baseView = new BaseView();
	var CodeListModel = require("C:/gulp/customplates/js/static/models/codelist.js");
	var plateListModel = require("C:/gulp/customplates/js/static/models/platelist.js");

	var ContentView = Backbone.View.extend({
		el : '.contentbox',
		hotquery : '',
		initialize : function () {
			this.init();
		},
		init : function () {
			this.renderHotQuery();
			$('#noResultView').hide();
			$('#resultStockView').hide();
			$('#view_result_condition').hide();

			$("#defaultView").show();
		},
		events : {
			'click .view_lastsearch' : 'doSearch',
			'click .view_hotquery' : 'doHotSearch',
			'click #view_clearbtn' : 'deleteSearchContent',
			'click #view_searchinput' : 'showLastSearch',
			'keyup #view_searchinput' : 'showDeleteSearchBnt',
			'click #view_select_choose' : 'selectChoosePlate',
			'click .view_div_option_plate' : 'selectOptionPlate',
			'mouseenter .view_div_option_plate' : 'enterOptionPlate',
			'mouseleave .view_div_option_plate' : 'leaveOptionPlate'
		},
		showLastSearch : function(e) {
			if($('#view_searchinput').val() == ''){
				this.renderHistoryQuery();
				$('#view_search_options_relation').show();
			}
			$(document).one("click", function(){
				$("#view_search_options_relation").hide();
			});
			e.stopPropagation();
		},
		showDeleteSearchBnt : function() {
			if($('#view_searchinput').val() == ''){
				$('#view_search_options_relation').show();
				$('#view_clearbtn').hide();
				$('#operate').hide();
			} else {
				$('#view_clearbtn').show();
			}
		}, 
		renderHistoryQuery : function () {
			var self = this;
			var html = [];
			var queryList = historyQueryModel.getData();
			//如果不存在历史搜索，则显示火热推荐
			if (false === queryList) {
				queryList = self.hotquery;
				for (var i in queryList) {
					html.push('<p class="view_hotquery" title="'+queryList[i]['query_title']+'">'+queryList[i]['show_title']+'<span>Hot</span></p>');
				}
			} else {
				for (var i in queryList) {
					html.push('<a href="###" view_click_stat="cop_58120aef_245" class="view_lastsearch" title="'+queryList[i]+'">'+queryList[i]+'</a>');
				}
			}
			
			$('#view_search_options_relation').html(html.join(''));

			$('#view_search_options_relation').show();
		},
		renderHotQuery : function () {
			var self = this;
			hotQueryModel.callback = function (data) {
				self.hotquery = data;
				var updateTime = '--';
				updateTime = data[0]['update_time'] || '';
				var dom = '<p class="recommend-title">关注度最高的板块<span class="recommend-time">'+updateTime+'</span></p>';
				$.each(data, function(i, item) {
					var profit = item.profit == undefined ? '--':item.profit;
					dom += '<div class="recommend-div view_hotquery" title="'+item.query_title+'"><span class="recommend-zf">（今日涨幅&nbsp;<span>'+profit+'%</span>）</span><span class="recommend-link">'+item.query_title+'</span></div>'
				});
				$('#hotbox').html(dom);
			};

			hotQueryModel.request();
		},
		doHotSearch : function (e) {
			TA.log({id : '579098b2_977'});
			this.doSearch(e);
		},
		doSearch : function (e) {
			var self = this;
			e = e || window.event;
			var str = $(e.currentTarget).attr('title');
			$('#view_searchinput').val(str);
			$('#view_searchbtn').click();
			self.showDeleteSearchBnt();
		},
		deleteSearchContent : function() {
			$('#view_searchinput').val('');
			$("#view_select_option").hide();
			//$('#view_search_options_relation').show();
			$("#defaultView").show();
			$('#operate').hide();
			$('#resultStockView').hide();
			$('#view_result_condition').hide();
			$('#view_clearbtn').hide();
			$('#noResultView').hide();
			$('#view_search_options_relation').hide();
		},
		renderPlateOption : function() {
			plateModel.requestList(function(data){
				var dom = '';
				// alert(JSON.stringify(data))
				for (var i in data) {
					if (data[i]['isSelect'] === 1) {
						continue;
					}
					dom += '<div class="option view_div_option_plate" value="'+data[i]['id']+'">'+data[i]['name']+'</div>';
				}
				$("#view_select_option").html(dom);
				$('#view_select_option').show();
			});
			
		},
		selectChoosePlate : function(e) {
			var self = this;
			e = e || window.event;
			var $dom = $(e.currentTarget);
			if ($("#view_select_choose_name").hasClass("add-plate-lock")) {
				return ;
			}
			if (!$("#view_select_option").is(':hidden')) {
				$("#view_select_option").hide();
				return;
			}
			
			$(document).on("click", function(){
				$("#view_select_option").hide();
			});
			self.renderPlateOption();
			e.stopPropagation();
		},
		selectOptionPlate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			var plateId = $dom.attr("value");
			var plateName = $dom.html();
			//$('#view_select_choose_name').html(plateName);
			CodeListModel.coverCodeList();
			var codelist = CodeListModel.getCodeListStr();
			if (codelist.length <= 0) {
				baseView.showtip('请选择股票');
				return;
			}
			baseView.savePlateAdd(plateId,codelist,$("#items-data-id-"+plateId));
			TA.log({id:"cop_581207d8_589"});
		},
		enterOptionPlate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			$dom.addClass('selectEnter');
		},
		leaveOptionPlate : function(e) {
			e = e || window.event;
			var $dom = $(e.currentTarget);
			$dom.removeClass('selectEnter');
		}
	});

	module.exports = new ContentView;
});
//@charset "utf-8";
// 表单页面交互
define("C:/gulp/customplates/js/static/views/form.js" ,["C:/gulp/customplates/js/static/models/codelist.js","C:/gulp/customplates/js/static/models/stocksearch.js","C:/gulp/customplates/js/static/views/base.js"], function(require , exports , module){
	var CodeListModel = require("C:/gulp/customplates/js/static/models/codelist.js");
	var StockSearchModel = require("C:/gulp/customplates/js/static/models/stocksearch.js");
	var Util = external.CreateObject('Util');
	var BaseView = require("C:/gulp/customplates/js/static/views/base.js");
	var FormView = BaseView.extend({
		nowPage : 1,
		dataCount : 0,
		el:'body',
		keyCode: false,
		startIndex:undefined,
		dragTipFlag: 0,
		isMove: false, // 是否拖拽中
		events: {
			'mouseup .data-stock': 'clickRow',
			'mousedown .data-stock': 'initdrag',
			'mouseenter .data-stock': 'showDragTip',
			'mouseleave .data-stock': 'hideDragTip',
			'click .selectRows' : 'checkboxSelect',
			'click #close' : 'closeWebDlg',
			'click #title-explain' : 'explain',
			'click [view_click_stat]' : 'statLog'
		},
		bind: function(){
			var self = this;

			// 全选/取消全选
			$('.btn-selectall').live('click',function() {
				if ($(this).is(":checked")) {
					self.selectAll();
				} else {
					self.unselectAll();
				}
				self.checkSelectStock();
			});
		
			$(document).mousemove(function(e){
				self.drap(e);
			}).mouseup(function(e){
				self.undrap(e);
			});

			// 键盘事件判断
			$(document).keydown(function(e){
				self.keyCode = e.keyCode;
			}).keyup(function(e){
				self.keyCode = false;
			});

			$(window).blur(function(){
				self.keyCode = false;
			});

		},
		emptyTable: function(){
			$('table').remove();
		},
		initdrag: function(e){
			if(this.keyCode) {return ;}
			this.isMove = true;
			var codelist = this.getCodeList();
			var $dom = e.target;
			if(!$(e.target).hasClass('data-stock')){
				$dom = $(e.target).parent('.data-stock');
			}
			if(codelist.length === 0){
				var code = $dom.attr('data-stock');
				CodeListModel.setCodeList([code]);
			}
		},
		drap: function(e){
			if(!this.isMove) {return;}
			var $drag = $('#drag-tip');

			// 实时拖拽
			$drag.css({
				top: e.clientY,
				left: e.clientX+5
			});
			$drag.show();
		},
		undrap: function(e){
			var self = this;
			if(!this.isMove) {return;}
			this.isMove = false;
			this.endDragPlate(e);

			var $dom = $(e.target);

			if(!$dom.hasClass('items')){
				$dom = $dom.parents('.items');
			}

			
			if($dom.length) {
				if ($dom.attr('data-type') === 'realtime') {
					self.showtip('无法添加到动态板块');
				} else if ($dom.attr('id') === 'new-plate') {
					$('#new-plate').click();
				} else {
					var plateId = $dom.attr('data-id');
					var codelist = self.getCodeList();
					if (codelist.length <= 0) {
						codelist = CodeListModel.getCodeListStr();
					}
					this.savePlateAdd(plateId,codelist,$dom);
					TA.log({id:"cop_581207d8_589"});
				}
			}
			$('#drag-tip').hide();		
		},
		getCodeList:function(){
			var codelist = [];
			var $domsSelected = $('.data-stock-select');
			$.each($domsSelected,function(i,dom){
				var code = $(dom).attr('data-stock');
				codelist.push(code);
			});
			return codelist;
		},
		clickRow: function(e){
			var self = this;
			var $dom = $(e.target);
			if(!$dom.hasClass('data-stock')){
				$dom = $dom.parents('.data-stock');
			}
			if ($dom.hasClass('data-stock-select')) {
				$dom.removeClass('data-stock-select');
				$dom.find('.selectRows').prop("checked", false);
			} else {
				$dom.addClass('data-stock-select');
				$dom.find('.selectRows').prop("checked", true);
			}
			self.checkSelectStock();
		},
		selectShift: function(clickIndex){
			var startIndex = this.startIndex ;
			this.unselectAll();  // 重置了startindex
			this.startIndex = startIndex;
			startIndex = startIndex || $('.data-stock').eq(0).attr('data-index');

			var doms = '';
			if(startIndex > clickIndex) {
				var startIndexTemp = startIndex;
				startIndex = clickIndex;
				clickIndex = startIndexTemp;
				// startIndex ^= clickIndex;
				// clickIndex ^= startIndex;
				// startIndex ^= clickIndex;
			}
			for(var i=startIndex;i<=clickIndex;i++){
				doms += '.data-stock[data-index='+i+'],';
			}
			
			this.selectRows($(doms));

		},
		selectRows : function($dom){
			
		},
		selectAll:function(){
			var $allRom = $('.data-stock');
			$allRom.addClass('data-stock-select');
			$(".selectRows").each(function(){
				$(this).prop("checked", true);
			});
		},
		unselectAll: function(){
			$('.data-stock-select').removeClass('data-stock-select');
			this.startIndex = undefined;
			CodeListModel.clearCodeList();
			$(".selectRows").each(function(){
				$(this).prop("checked", false);
			});
			CodeListModel.setCodeList([]);
		},
		showDragTip: function(e){
			var $tip = $('#tip');

			$tip.css({
				'top': e.clientY,
				'left': e.clientX
			});

			this.dragTipFlag = setTimeout(function(){
				$tip.show();
			},3000);
		},
		hideDragTip: function(){
			var $tip = $('#tip');

			clearTimeout(this.dragTipFlag);
			$tip.hide();
		},
		checkboxSelect : function(e) {
			var self = this;
			e = e || window.event;
			var $dom = $(e.currentTarget);
			if ($dom.is(":checked")) {
				$dom.prop("checked", false);
			} else {
				$dom.prop("checked", true);
			}
			self.checkSelectStock();
		},
		//关闭窗口
		closeWebDlg : function() {
			external.closeWebDlg();
		},
		//验证是否有选中股票
		checkSelectStock : function() {
			var self = this;
			var codelist = self.getCodeList();
			if (codelist.length > 0) {
				$("#view_select_choose_name").removeClass("add-plate-lock");
			} else {
				$("#view_select_choose_name").addClass("add-plate-lock");
			}
		},
		explain : function() {
			TA.log({id : 'cop_5811fb94_443'});
			Util.openURL('http://sp.10jqka.com.cn/liuyan/index/index/projectid/****/question/自定义板块如何用/', 4);
		},
		statLog : function(e) {
			e = e || window.event;
			var id = $(e.currentTarget).attr('view_click_stat');
			TA.log({id : id});
		}
	});

	module.exports = FormView;
});
// @charset "utf-8";
define("_" ,[], function(require , exports , module){(function(){var n=this,t=n._,r={},e=Array.prototype,u=Object.prototype,i=Function.prototype,a=e.push,o=e.slice,c=e.concat,l=u.toString,f=u.hasOwnProperty,s=e.forEach,p=e.map,h=e.reduce,v=e.reduceRight,d=e.filter,g=e.every,m=e.some,y=e.indexOf,b=e.lastIndexOf,x=Array.isArray,_=Object.keys,j=i.bind,w=function(n){return n instanceof w?n:this instanceof w?(this._wrapped=n,void 0):new w(n)};"undefined"!=typeof exports?("undefined"!=typeof module&&module.exports&&(exports=module.exports=w),exports._=w):n._=w,w.VERSION="1.4.4";var A=w.each=w.forEach=function(n,t,e){if(null!=n)if(s&&n.forEach===s)n.forEach(t,e);else if(n.length===+n.length){for(var u=0,i=n.length;i>u;u++)if(t.call(e,n[u],u,n)===r)return}else for(var a in n)if(w.has(n,a)&&t.call(e,n[a],a,n)===r)return};w.map=w.collect=function(n,t,r){var e=[];return null==n?e:p&&n.map===p?n.map(t,r):(A(n,function(n,u,i){e[e.length]=t.call(r,n,u,i)}),e)};var O="Reduce of empty array with no initial value";w.reduce=w.foldl=w.inject=function(n,t,r,e){var u=arguments.length>2;if(null==n&&(n=[]),h&&n.reduce===h)return e&&(t=w.bind(t,e)),u?n.reduce(t,r):n.reduce(t);if(A(n,function(n,i,a){u?r=t.call(e,r,n,i,a):(r=n,u=!0)}),!u)throw new TypeError(O);return r},w.reduceRight=w.foldr=function(n,t,r,e){var u=arguments.length>2;if(null==n&&(n=[]),v&&n.reduceRight===v)return e&&(t=w.bind(t,e)),u?n.reduceRight(t,r):n.reduceRight(t);var i=n.length;if(i!==+i){var a=w.keys(n);i=a.length}if(A(n,function(o,c,l){c=a?a[--i]:--i,u?r=t.call(e,r,n[c],c,l):(r=n[c],u=!0)}),!u)throw new TypeError(O);return r},w.find=w.detect=function(n,t,r){var e;return E(n,function(n,u,i){return t.call(r,n,u,i)?(e=n,!0):void 0}),e},w.filter=w.select=function(n,t,r){var e=[];return null==n?e:d&&n.filter===d?n.filter(t,r):(A(n,function(n,u,i){t.call(r,n,u,i)&&(e[e.length]=n)}),e)},w.reject=function(n,t,r){return w.filter(n,function(n,e,u){return!t.call(r,n,e,u)},r)},w.every=w.all=function(n,t,e){t||(t=w.identity);var u=!0;return null==n?u:g&&n.every===g?n.every(t,e):(A(n,function(n,i,a){return(u=u&&t.call(e,n,i,a))?void 0:r}),!!u)};var E=w.some=w.any=function(n,t,e){t||(t=w.identity);var u=!1;return null==n?u:m&&n.some===m?n.some(t,e):(A(n,function(n,i,a){return u||(u=t.call(e,n,i,a))?r:void 0}),!!u)};w.contains=w.include=function(n,t){return null==n?!1:y&&n.indexOf===y?n.indexOf(t)!=-1:E(n,function(n){return n===t})},w.invoke=function(n,t){var r=o.call(arguments,2),e=w.isFunction(t);return w.map(n,function(n){return(e?t:n[t]).apply(n,r)})},w.pluck=function(n,t){return w.map(n,function(n){return n[t]})},w.where=function(n,t,r){return w.isEmpty(t)?r?null:[]:w[r?"find":"filter"](n,function(n){for(var r in t)if(t[r]!==n[r])return!1;return!0})},w.findWhere=function(n,t){return w.where(n,t,!0)},w.max=function(n,t,r){if(!t&&w.isArray(n)&&n[0]===+n[0]&&65535>n.length)return Math.max.apply(Math,n);if(!t&&w.isEmpty(n))return-1/0;var e={computed:-1/0,value:-1/0};return A(n,function(n,u,i){var a=t?t.call(r,n,u,i):n;a>=e.computed&&(e={value:n,computed:a})}),e.value},w.min=function(n,t,r){if(!t&&w.isArray(n)&&n[0]===+n[0]&&65535>n.length)return Math.min.apply(Math,n);if(!t&&w.isEmpty(n))return 1/0;var e={computed:1/0,value:1/0};return A(n,function(n,u,i){var a=t?t.call(r,n,u,i):n;e.computed>a&&(e={value:n,computed:a})}),e.value},w.shuffle=function(n){var t,r=0,e=[];return A(n,function(n){t=w.random(r++),e[r-1]=e[t],e[t]=n}),e};var k=function(n){return w.isFunction(n)?n:function(t){return t[n]}};w.sortBy=function(n,t,r){var e=k(t);return w.pluck(w.map(n,function(n,t,u){return{value:n,index:t,criteria:e.call(r,n,t,u)}}).sort(function(n,t){var r=n.criteria,e=t.criteria;if(r!==e){if(r>e||r===void 0)return 1;if(e>r||e===void 0)return-1}return n.index<t.index?-1:1}),"value")};var F=function(n,t,r,e){var u={},i=k(t||w.identity);return A(n,function(t,a){var o=i.call(r,t,a,n);e(u,o,t)}),u};w.groupBy=function(n,t,r){return F(n,t,r,function(n,t,r){(w.has(n,t)?n[t]:n[t]=[]).push(r)})},w.countBy=function(n,t,r){return F(n,t,r,function(n,t){w.has(n,t)||(n[t]=0),n[t]++})},w.sortedIndex=function(n,t,r,e){r=null==r?w.identity:k(r);for(var u=r.call(e,t),i=0,a=n.length;a>i;){var o=i+a>>>1;u>r.call(e,n[o])?i=o+1:a=o}return i},w.toArray=function(n){return n?w.isArray(n)?o.call(n):n.length===+n.length?w.map(n,w.identity):w.values(n):[]},w.size=function(n){return null==n?0:n.length===+n.length?n.length:w.keys(n).length},w.first=w.head=w.take=function(n,t,r){return null==n?void 0:null==t||r?n[0]:o.call(n,0,t)},w.initial=function(n,t,r){return o.call(n,0,n.length-(null==t||r?1:t))},w.last=function(n,t,r){return null==n?void 0:null==t||r?n[n.length-1]:o.call(n,Math.max(n.length-t,0))},w.rest=w.tail=w.drop=function(n,t,r){return o.call(n,null==t||r?1:t)},w.compact=function(n){return w.filter(n,w.identity)};var R=function(n,t,r){return A(n,function(n){w.isArray(n)?t?a.apply(r,n):R(n,t,r):r.push(n)}),r};w.flatten=function(n,t){return R(n,t,[])},w.without=function(n){return w.difference(n,o.call(arguments,1))},w.uniq=w.unique=function(n,t,r,e){w.isFunction(t)&&(e=r,r=t,t=!1);var u=r?w.map(n,r,e):n,i=[],a=[];return A(u,function(r,e){(t?e&&a[a.length-1]===r:w.contains(a,r))||(a.push(r),i.push(n[e]))}),i},w.union=function(){return w.uniq(c.apply(e,arguments))},w.intersection=function(n){var t=o.call(arguments,1);return w.filter(w.uniq(n),function(n){return w.every(t,function(t){return w.indexOf(t,n)>=0})})},w.difference=function(n){var t=c.apply(e,o.call(arguments,1));return w.filter(n,function(n){return!w.contains(t,n)})},w.zip=function(){for(var n=o.call(arguments),t=w.max(w.pluck(n,"length")),r=Array(t),e=0;t>e;e++)r[e]=w.pluck(n,""+e);return r},w.object=function(n,t){if(null==n)return{};for(var r={},e=0,u=n.length;u>e;e++)t?r[n[e]]=t[e]:r[n[e][0]]=n[e][1];return r},w.indexOf=function(n,t,r){if(null==n)return-1;var e=0,u=n.length;if(r){if("number"!=typeof r)return e=w.sortedIndex(n,t),n[e]===t?e:-1;e=0>r?Math.max(0,u+r):r}if(y&&n.indexOf===y)return n.indexOf(t,r);for(;u>e;e++)if(n[e]===t)return e;return-1},w.lastIndexOf=function(n,t,r){if(null==n)return-1;var e=null!=r;if(b&&n.lastIndexOf===b)return e?n.lastIndexOf(t,r):n.lastIndexOf(t);for(var u=e?r:n.length;u--;)if(n[u]===t)return u;return-1},w.range=function(n,t,r){1>=arguments.length&&(t=n||0,n=0),r=arguments[2]||1;for(var e=Math.max(Math.ceil((t-n)/r),0),u=0,i=Array(e);e>u;)i[u++]=n,n+=r;return i},w.bind=function(n,t){if(n.bind===j&&j)return j.apply(n,o.call(arguments,1));var r=o.call(arguments,2);return function(){return n.apply(t,r.concat(o.call(arguments)))}},w.partial=function(n){var t=o.call(arguments,1);return function(){return n.apply(this,t.concat(o.call(arguments)))}},w.bindAll=function(n){var t=o.call(arguments,1);return 0===t.length&&(t=w.functions(n)),A(t,function(t){n[t]=w.bind(n[t],n)}),n},w.memoize=function(n,t){var r={};return t||(t=w.identity),function(){var e=t.apply(this,arguments);return w.has(r,e)?r[e]:r[e]=n.apply(this,arguments)}},w.delay=function(n,t){var r=o.call(arguments,2);return setTimeout(function(){return n.apply(null,r)},t)},w.defer=function(n){return w.delay.apply(w,[n,1].concat(o.call(arguments,1)))},w.throttle=function(n,t){var r,e,u,i,a=0,o=function(){a=new Date,u=null,i=n.apply(r,e)};return function(){var c=new Date,l=t-(c-a);return r=this,e=arguments,0>=l?(clearTimeout(u),u=null,a=c,i=n.apply(r,e)):u||(u=setTimeout(o,l)),i}},w.debounce=function(n,t,r){var e,u;return function(){var i=this,a=arguments,o=function(){e=null,r||(u=n.apply(i,a))},c=r&&!e;return clearTimeout(e),e=setTimeout(o,t),c&&(u=n.apply(i,a)),u}},w.once=function(n){var t,r=!1;return function(){return r?t:(r=!0,t=n.apply(this,arguments),n=null,t)}},w.wrap=function(n,t){return function(){var r=[n];return a.apply(r,arguments),t.apply(this,r)}},w.compose=function(){var n=arguments;return function(){for(var t=arguments,r=n.length-1;r>=0;r--)t=[n[r].apply(this,t)];return t[0]}},w.after=function(n,t){return 0>=n?t():function(){return 1>--n?t.apply(this,arguments):void 0}},w.keys=_||function(n){if(n!==Object(n))throw new TypeError("Invalid object");var t=[];for(var r in n)w.has(n,r)&&(t[t.length]=r);return t},w.values=function(n){var t=[];for(var r in n)w.has(n,r)&&t.push(n[r]);return t},w.pairs=function(n){var t=[];for(var r in n)w.has(n,r)&&t.push([r,n[r]]);return t},w.invert=function(n){var t={};for(var r in n)w.has(n,r)&&(t[n[r]]=r);return t},w.functions=w.methods=function(n){var t=[];for(var r in n)w.isFunction(n[r])&&t.push(r);return t.sort()},w.extend=function(n){return A(o.call(arguments,1),function(t){if(t)for(var r in t)n[r]=t[r]}),n},w.pick=function(n){var t={},r=c.apply(e,o.call(arguments,1));return A(r,function(r){r in n&&(t[r]=n[r])}),t},w.omit=function(n){var t={},r=c.apply(e,o.call(arguments,1));for(var u in n)w.contains(r,u)||(t[u]=n[u]);return t},w.defaults=function(n){return A(o.call(arguments,1),function(t){if(t)for(var r in t)null==n[r]&&(n[r]=t[r])}),n},w.clone=function(n){return w.isObject(n)?w.isArray(n)?n.slice():w.extend({},n):n},w.tap=function(n,t){return t(n),n};var I=function(n,t,r,e){if(n===t)return 0!==n||1/n==1/t;if(null==n||null==t)return n===t;n instanceof w&&(n=n._wrapped),t instanceof w&&(t=t._wrapped);var u=l.call(n);if(u!=l.call(t))return!1;switch(u){case"[object String]":return n==t+"";case"[object Number]":return n!=+n?t!=+t:0==n?1/n==1/t:n==+t;case"[object Date]":case"[object Boolean]":return+n==+t;case"[object RegExp]":return n.source==t.source&&n.global==t.global&&n.multiline==t.multiline&&n.ignoreCase==t.ignoreCase}if("object"!=typeof n||"object"!=typeof t)return!1;for(var i=r.length;i--;)if(r[i]==n)return e[i]==t;r.push(n),e.push(t);var a=0,o=!0;if("[object Array]"==u){if(a=n.length,o=a==t.length)for(;a--&&(o=I(n[a],t[a],r,e)););}else{var c=n.constructor,f=t.constructor;if(c!==f&&!(w.isFunction(c)&&c instanceof c&&w.isFunction(f)&&f instanceof f))return!1;for(var s in n)if(w.has(n,s)&&(a++,!(o=w.has(t,s)&&I(n[s],t[s],r,e))))break;if(o){for(s in t)if(w.has(t,s)&&!a--)break;o=!a}}return r.pop(),e.pop(),o};w.isEqual=function(n,t){return I(n,t,[],[])},w.isEmpty=function(n){if(null==n)return!0;if(w.isArray(n)||w.isString(n))return 0===n.length;for(var t in n)if(w.has(n,t))return!1;return!0},w.isElement=function(n){return!(!n||1!==n.nodeType)},w.isArray=x||function(n){return"[object Array]"==l.call(n)},w.isObject=function(n){return n===Object(n)},A(["Arguments","Function","String","Number","Date","RegExp"],function(n){w["is"+n]=function(t){return l.call(t)=="[object "+n+"]"}}),w.isArguments(arguments)||(w.isArguments=function(n){return!(!n||!w.has(n,"callee"))}),"function"!=typeof/./&&(w.isFunction=function(n){return"function"==typeof n}),w.isFinite=function(n){return isFinite(n)&&!isNaN(parseFloat(n))},w.isNaN=function(n){return w.isNumber(n)&&n!=+n},w.isBoolean=function(n){return n===!0||n===!1||"[object Boolean]"==l.call(n)},w.isNull=function(n){return null===n},w.isUndefined=function(n){return n===void 0},w.has=function(n,t){return f.call(n,t)},w.noConflict=function(){return n._=t,this},w.identity=function(n){return n},w.times=function(n,t,r){for(var e=Array(n),u=0;n>u;u++)e[u]=t.call(r,u);return e},w.random=function(n,t){return null==t&&(t=n,n=0),n+Math.floor(Math.random()*(t-n+1))};var M={escape:{"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#x27;","/":"&#x2F;"}};M.unescape=w.invert(M.escape);var S={escape:RegExp("["+w.keys(M.escape).join("")+"]","g"),unescape:RegExp("("+w.keys(M.unescape).join("|")+")","g")};w.each(["escape","unescape"],function(n){w[n]=function(t){return null==t?"":(""+t).replace(S[n],function(t){return M[n][t]})}}),w.result=function(n,t){if(null==n)return null;var r=n[t];return w.isFunction(r)?r.call(n):r},w.mixin=function(n){A(w.functions(n),function(t){var r=w[t]=n[t];w.prototype[t]=function(){var n=[this._wrapped];return a.apply(n,arguments),D.call(this,r.apply(w,n))}})};var N=0;w.uniqueId=function(n){var t=++N+"";return n?n+t:t},w.templateSettings={evaluate:/<%([\s\S]+?)%>/g,interpolate:/<%=([\s\S]+?)%>/g,escape:/<%-([\s\S]+?)%>/g};var T=/(.)^/,q={"'":"'","\\":"\\","\r":"r","\n":"n","	":"t","\u2028":"u2028","\u2029":"u2029"},B=/\\|'|\r|\n|\t|\u2028|\u2029/g;w.template=function(n,t,r){var e;r=w.defaults({},r,w.templateSettings);var u=RegExp([(r.escape||T).source,(r.interpolate||T).source,(r.evaluate||T).source].join("|")+"|$","g"),i=0,a="__p+='";n.replace(u,function(t,r,e,u,o){return a+=n.slice(i,o).replace(B,function(n){return"\\"+q[n]}),r&&(a+="'+\n((__t=("+r+"))==null?'':_.escape(__t))+\n'"),e&&(a+="'+\n((__t=("+e+"))==null?'':__t)+\n'"),u&&(a+="';\n"+u+"\n__p+='"),i=o+t.length,t}),a+="';\n",r.variable||(a="with(obj||{}){\n"+a+"}\n"),a="var __t,__p='',__j=Array.prototype.join,"+"print=function(){__p+=__j.call(arguments,'');};\n"+a+"return __p;\n";try{e=Function(r.variable||"obj","_",a)}catch(o){throw o.source=a,o}if(t)return e(t,w);var c=function(n){return e.call(this,n,w)};return c.source="function("+(r.variable||"obj")+"){\n"+a+"}",c},w.chain=function(n){return w(n).chain()};var D=function(n){return this._chain?w(n).chain():n};w.mixin(w),A(["pop","push","reverse","shift","sort","splice","unshift"],function(n){var t=e[n];w.prototype[n]=function(){var r=this._wrapped;return t.apply(r,arguments),"shift"!=n&&"splice"!=n||0!==r.length||delete r[0],D.call(this,r)}}),A(["concat","join","slice"],function(n){var t=e[n];w.prototype[n]=function(){return D.call(this,t.apply(this._wrapped,arguments))}}),w.extend(w.prototype,{chain:function(){return this._chain=!0,this},value:function(){return this._wrapped}})}).call(this)});

//@charset "utf-8";
// 板块请求
define("C:/gulp/customplates/js/static/models/platelist.js" ,["C:/gulp/customplates/js/static/models/clientbase.js","C:/gulp/customplates/js/static/lib/common.js"], function(require , exports , module){
    var BaseModel = require("C:/gulp/customplates/js/static/models/clientbase.js");
    var Util = external.CreateObject('Util');
    var Quote = external.CreateObject('Quote');
    var commonMethod = require("C:/gulp/customplates/js/static/lib/common.js");
    var PlateModel = BaseModel.extend({

    //获取列表
    requestList: function(callback){
      var result = Util.getCustomBlockList();
      var res = eval("("+ result +")");
      callback(res); 
    },
    //新建板块 BACL: id  0为创建失败
    requestCreate: function(name,condition,callback){  // 普通板块condition为''

      var result = Util.addCustomBlock(name,condition);
      callback(result); 
    },
    // 判断是否实时板块 BACK:true/false
    requestIsRealtime: function(id,callback){
      var result = Util.isSelectCustomBlock(id);
      callback(result);
    },
    // 重命名板块  BACK:true/false
    requestRename:function(id,newname,callback){
      var result = Util.renameCustomBlock(id,newname);
      callback(result);
    },
    // 增加股票到板块
    requestAdd: function(id,codelist,callback){
      var num = Util.addStockToCustomBlock(id,codelist);
      callback(num);
    },
    // 删除板块 BACK:true/false
    requestDelete: function(id,callback){
      var result = Util.deleteCustomBlock(id);
      callback(result);
    },
    jumpPlate: function(id){
      id = parseInt(id);
	  if (id == 33) {
		Quote.switchPage(392);//33为自选股，产品指定跳转到id为392的页面
	  } else {
		Quote.switchBlock(id);
	  }
    },
    // 处理板块命名
    formatPlateName:function(names,newname){
      newname = $.trim(newname);
      var index = commonMethod.arrIndexOf(names,newname);
      if(index === -1) {names.push(newname);return {newname:newname,platenames:names};}
      // else {names.splice(index,1);}
      var defaultname = this.getRepeatName(newname);
      var reg = new RegExp("^"+defaultname);
      var arrNum = [];
      $.each(names,function(i,name){
        if(reg.test(name)){
            var num = name.replace(defaultname,'');
            if(num.length === 0){
              arrNum[0] = 1;
            }
            num = parseInt(num);
            if(num){
              arrNum[num] = 1;
            }
        }
      });
      if(!arrNum[0]) {
        names.push(defaultname);
        return {newname:defaultname,platenames:names};
      }
      for(var i=1;i<=arrNum.length;i++){
        if(!arrNum[i]){
          names.push(defaultname+i);
          return {newname:defaultname+i,platenames:names};
        }        
      }
    },
    getRepeatName: function(name){
      var lastIndex = name.length-1;
      if(!parseInt(name.substring(lastIndex,lastIndex+1)) ) {return name;}
      for(var i=name.length-2;i>=0;i--){
        if(!Number( name.substring(i,i+1) ) && Number( name.substring(i+1,i+2) )){
          lastIndex = i;
        }
      }
      name = name.substring(0,lastIndex+1);
      return name;
    },
    removePlateName: function(names,deletename){
      var platenames = commonMethod.arrRemove(names,deletename);
      return platenames;
    },
    //判断板块是否能够更新数据（是否能自动执行选股）
    isCustomBlockNeedUpdate : function(id){
      try{
          var status = Util.isCustomBlockNeedUpdate(id);
          if (status === false) {
            return 0;
          }
          return 1;
        } catch (e) {
          alert('该版本不支持');
        }
    },
    //设置板块更新状态
    enableCustomBlockUpdate : function(id, status){
        return Util.enableCustomBlockUpdate(id, status);
    }
  });
  
  module.exports = new PlateModel();
});

//@charset "utf-8";
// 问句 - 数据
define("C:/gulp/customplates/js/static/models/querysearch.js" ,["C:/gulp/customplates/js/static/models/ajaxbase.js","C:/gulp/customplates/js/static/lib/clientquote.js"], function(require , exports , module){
	var AjaxBaseModel = require("C:/gulp/customplates/js/static/models/ajaxbase.js");
	var clientQuote = require("C:/gulp/customplates/js/static/lib/clientquote.js");

	var QuerySearchModel = AjaxBaseModel.extend({
		url : 'http://zx.10jqka.com.cn/i/index/index/app/5/',
		getQueryResult : function (query, callback) {
			var self = this;
			self.set('result', '');

			self.callback = function () {
				self.fixQuoteData(callback);
			};
			self.request({
				w : query
			});
		},
		getQueryResultStr : function (tag) {
			var result = this.get('result');
			var codeList = [];
			$.each(result.data, function (i, item) {
				codeList.push(item['code']);
			});

			return codeList.join(tag);
		},
		fixQuoteData : function (callback) {
			var self = this;
			var result = self.get('result');
			if (undefined === result.data || result.data.length <= 0) {
				callback();
				return ;
			}
			var param = {
				code : result.data.join(','),
				type : 'zqmc,new,zhangdiefu'
			};
			var data = [];
			var quoteCallback = function (res) {
				for (var i in result.data) {
					var sortZhangdiefu = '--';
					if (
						undefined === res[result.data[i]]['zhangdiefu'] ||
						isNaN(res[result.data[i]]['zhangdiefu'])
					) {
						sortZhangdiefu = '--';
					} else {
						sortZhangdiefu = parseFloat(res[result.data[i]]['zhangdiefu']);
					}
					var newPrice = undefined !== res[result.data[i]]['new'] ? res[result.data[i]]['new'] : '--';
					var zhangdiefu = undefined !== res[result.data[i]]['zhangdiefu'] ? res[result.data[i]]['zhangdiefu'] : '--';
					data.push({
						'code' : result.data[i],
						'zqmc' : undefined !== res[result.data[i]]['zqmc'] ? 
							res[result.data[i]]['zqmc'] : '--',
						'newprice' : newPrice == '--' ? '--' : parseFloat(parseFloat(newPrice).toFixed(2)),
						'zhangdiefu' : zhangdiefu == '--' ? '--' : 	parseFloat(zhangdiefu).toFixed(2),
						'sortzdf' : sortZhangdiefu
					});
				}
				data = data.sort(self.sortTableFun('sortzdf', 'desc'));
				result.data = data;
				self.set('result', result);
				callback();
			};
			clientQuote.getStockMinData(param, quoteCallback);
		}
	});

	module.exports = new QuerySearchModel();
});

//@charset "utf-8";
//选中的股票代码
define("C:/gulp/customplates/js/static/models/codelist.js" ,["backbone"], function(require , exports , module){
	var Backbone = require('backbone');
	var CodeListModel = Backbone.Model.extend({
		codelist:{},
		getCodeList : function () {
			return this.codelist;
		},
		//@return "60000,600001,600020"
		getCodeListStr : function () {
			var str = '';
			$.each(this.codelist,function(attr,value){
				str = str + attr + ',';
			});
			str = str.substring(0,str.length-1);
			return str;
		},
		//@return [60000,600001]
		getCodeListArr: function(){
			var arr = [];
			$.each(this.codelist,function(attr,value){
				arr.push(parseInt(attr));
			});
			return arr;
		},
		//@param [600000,600001,600002]
		addCodeList: function(codes){
			var self = this;

			$.each(codes,function(i,code){
				self.codelist[code.toString()] = 1;
			});
		},
		clearCodeList: function(){
			this.codelist = {};
		},
		//@param  [600000,600001,600002]
		setCodeList: function(codes){
			var self = this;

			this.codelist = {};
			$.each(codes,function(i,code){
				self.codelist[code.toString()] = 1;
			});
		},
		// @param  [600000,600001,600002]
		removeCodeList: function(codes){
			var self = this;
			for (var i in codes) {
				delete self.codelist[codes[i]];
			}
		},
		// 对当前页进行的股票代码进行覆盖
		coverCodeList: function(){
			var self = this;

			var $doms = $('.data-stock');
			$.each($doms,function(i,dom){
				var code = $(dom).attr('data-stock').toString();
				if($(dom).hasClass('data-stock-select')){
					self.codelist[code] = 1;
				}else {
					delete self.codelist[code];
				}
			});

			// alert(JSON.stringify(self.codelist));
		}
	});

	module.exports = new CodeListModel();
});

//@charset "utf-8";
// PlateListView 与 FormView 间通信
define("C:/gulp/customplates/js/static/views/base.js" ,["backbone","C:/gulp/customplates/js/static/models/platelist.js"], function(require , exports , module){
	var Backbone = require('backbone');
	var plateListModel = require("C:/gulp/customplates/js/static/models/platelist.js");

	var BaseView = Backbone.View.extend({
		el: '',
		// isMove: false,
		initialize: function() {
		},
		endDragPlate: function(e){
		
			var $dom = $(e.currentTarget); 
			$dom.removeClass('item-highlight');
		},
		savePlateAdd: function(id,codelist,$dom){
			var self = this;
			if($.isArray(codelist)){
				codelist = codelist.join(',');
			}
			plateListModel.requestAdd(id,codelist,function(num){

				if($dom){
					if(num >= 600 &&　$dom.attr('data-type') === 'optional'){
						self.showtip("自选股上限为600个!");
					}else if( num >= 300 &&　$dom.attr('data-type') !== 'optional'){
						self.showtip("板块股上限为300个!");
					} else {
						self.showtip("添加成功");
					}
					var $num = $dom.find('.num');
					$num.hide().addClass('new').text('(' + num + ')').fadeIn();
					setTimeout(function(){
						$num.fadeOut().removeClass('new').fadeIn('fast');
					},2000);
				}
			});
		},
		// 板块操作提示
		showtip: function(content){			
			$('#sidebar-tipbox').text(content);
			$('#sidebar-tipbox').fadeIn('fast');
			setTimeout(function(){
				$('#sidebar-tipbox').fadeOut();
			},1000);
		}
	});
	module.exports = BaseView;
});
// @charset "utf-8";
define("backbone" ,["_"], function(require , exports , module){
    var previousUnderscore = this._;
    var previousJQuery = this.jQuery;
	this._ = require("_");
    this.jQuery = $;
    //     Backbone.js 1.0.0
    //     (c) 2010-2013 Jeremy Ashkenas, DocumentCloud Inc.
    //     Backbone may be freely distributed under the MIT license.
    //     For all details and documentation:
    //     http://backbonejs.org
    (function() {
        // Initial Setup
        // -------------
        // Save a reference to the global object (`window` in the browser, `exports`
        // on the server).
        var root = this;
        // Save the previous value of the `Backbone` variable, so that it can be
        // restored later on, if `noConflict` is used.
        var previousBackbone = root.Backbone;
        // Create local references to array methods we'll want to use later.
        var array = [];
        var push = array.push;
        var slice = array.slice;
        var splice = array.splice;
        // The top-level namespace. All public Backbone classes and modules will
        // be attached to this. Exported for both the browser and the server.
        var Backbone;
        if (typeof exports !== "undefined") {
            Backbone = exports;
        } else {
            Backbone = root.Backbone = {};
        }
        // Current version of the library. Keep in sync with `package.json`.
        Backbone.VERSION = "1.0.0";
        // Require Underscore, if we're on the server, and it's not already present.
        var _ = root._;
        if (!_ && typeof require !== "undefined") _ = require("_");
        // For Backbone's purposes, jQuery, Zepto, Ender, or My Library (kidding) owns
        // the `$` variable.
        Backbone.$ = root.jQuery || root.Zepto || root.ender || root.$;
        // Runs Backbone.js in *noConflict* mode, returning the `Backbone` variable
        // to its previous owner. Returns a reference to this Backbone object.
        Backbone.noConflict = function() {
            root.Backbone = previousBackbone;
            return this;
        };
        // Turn on `emulateHTTP` to support legacy HTTP servers. Setting this option
        // will fake `"PUT"` and `"DELETE"` requests via the `_method` parameter and
        // set a `X-Http-Method-Override` header.
        Backbone.emulateHTTP = false;
        // Turn on `emulateJSON` to support legacy servers that can't deal with direct
        // `application/json` requests ... will encode the body as
        // `application/x-www-form-urlencoded` instead and will send the model in a
        // form param named `model`.
        Backbone.emulateJSON = false;
        // Backbone.Events
        // ---------------
        // A module that can be mixed in to *any object* in order to provide it with
        // custom events. You may bind with `on` or remove with `off` callback
        // functions to an event; `trigger`-ing an event fires all callbacks in
        // succession.
        //
        //     var object = {};
        //     _.extend(object, Backbone.Events);
        //     object.on('expand', function(){ alert('expanded'); });
        //     object.trigger('expand');
        //
        var Events = Backbone.Events = {
            // Bind an event to a `callback` function. Passing `"all"` will bind
            // the callback to all events fired.
            on: function(name, callback, context) {
                if (!eventsApi(this, "on", name, [ callback, context ]) || !callback) return this;
                this._events || (this._events = {});
                var events = this._events[name] || (this._events[name] = []);
                events.push({
                    callback: callback,
                    context: context,
                    ctx: context || this
                });
                return this;
            },
            // Bind an event to only be triggered a single time. After the first time
            // the callback is invoked, it will be removed.
            once: function(name, callback, context) {
                if (!eventsApi(this, "once", name, [ callback, context ]) || !callback) return this;
                var self = this;
                var once = _.once(function() {
                    self.off(name, once);
                    callback.apply(this, arguments);
                });
                once._callback = callback;
                return this.on(name, once, context);
            },
            // Remove one or many callbacks. If `context` is null, removes all
            // callbacks with that function. If `callback` is null, removes all
            // callbacks for the event. If `name` is null, removes all bound
            // callbacks for all events.
            off: function(name, callback, context) {
                var retain, ev, events, names, i, l, j, k;
                if (!this._events || !eventsApi(this, "off", name, [ callback, context ])) return this;
                if (!name && !callback && !context) {
                    this._events = {};
                    return this;
                }
                names = name ? [ name ] : _.keys(this._events);
                for (i = 0, l = names.length; i < l; i++) {
                    name = names[i];
                    if (events = this._events[name]) {
                        this._events[name] = retain = [];
                        if (callback || context) {
                            for (j = 0, k = events.length; j < k; j++) {
                                ev = events[j];
                                if (callback && callback !== ev.callback && callback !== ev.callback._callback || context && context !== ev.context) {
                                    retain.push(ev);
                                }
                            }
                        }
                        if (!retain.length) delete this._events[name];
                    }
                }
                return this;
            },
            // Trigger one or many events, firing all bound callbacks. Callbacks are
            // passed the same arguments as `trigger` is, apart from the event name
            // (unless you're listening on `"all"`, which will cause your callback to
            // receive the true name of the event as the first argument).
            trigger: function(name) {
                if (!this._events) return this;
                var args = slice.call(arguments, 1);
                if (!eventsApi(this, "trigger", name, args)) return this;
                var events = this._events[name];
                var allEvents = this._events.all;
                if (events) triggerEvents(events, args);
                if (allEvents) triggerEvents(allEvents, arguments);
                return this;
            },
            // Tell this object to stop listening to either specific events ... or
            // to every object it's currently listening to.
            stopListening: function(obj, name, callback) {
                var listeners = this._listeners;
                if (!listeners) return this;
                var deleteListener = !name && !callback;
                if (typeof name === "object") callback = this;
                if (obj) (listeners = {})[obj._listenerId] = obj;
                for (var id in listeners) {
                    listeners[id].off(name, callback, this);
                    if (deleteListener) delete this._listeners[id];
                }
                return this;
            }
        };
        // Regular expression used to split event strings.
        var eventSplitter = /\s+/;
        // Implement fancy features of the Events API such as multiple event
        // names `"change blur"` and jQuery-style event maps `{change: action}`
        // in terms of the existing API.
        var eventsApi = function(obj, action, name, rest) {
            if (!name) return true;
            // Handle event maps.
            if (typeof name === "object") {
                for (var key in name) {
                    obj[action].apply(obj, [ key, name[key] ].concat(rest));
                }
                return false;
            }
            // Handle space separated event names.
            if (eventSplitter.test(name)) {
                var names = name.split(eventSplitter);
                for (var i = 0, l = names.length; i < l; i++) {
                    obj[action].apply(obj, [ names[i] ].concat(rest));
                }
                return false;
            }
            return true;
        };
        // A difficult-to-believe, but optimized internal dispatch function for
        // triggering events. Tries to keep the usual cases speedy (most internal
        // Backbone events have 3 arguments).
        var triggerEvents = function(events, args) {
            var ev, i = -1, l = events.length, a1 = args[0], a2 = args[1], a3 = args[2];
            switch (args.length) {
              case 0:
                while (++i < l) (ev = events[i]).callback.call(ev.ctx);
                return;

              case 1:
                while (++i < l) (ev = events[i]).callback.call(ev.ctx, a1);
                return;

              case 2:
                while (++i < l) (ev = events[i]).callback.call(ev.ctx, a1, a2);
                return;

              case 3:
                while (++i < l) (ev = events[i]).callback.call(ev.ctx, a1, a2, a3);
                return;

              default:
                while (++i < l) (ev = events[i]).callback.apply(ev.ctx, args);
            }
        };
        var listenMethods = {
            listenTo: "on",
            listenToOnce: "once"
        };
        // Inversion-of-control versions of `on` and `once`. Tell *this* object to
        // listen to an event in another object ... keeping track of what it's
        // listening to.
        _.each(listenMethods, function(implementation, method) {
            Events[method] = function(obj, name, callback) {
                var listeners = this._listeners || (this._listeners = {});
                var id = obj._listenerId || (obj._listenerId = _.uniqueId("l"));
                listeners[id] = obj;
                if (typeof name === "object") callback = this;
                obj[implementation](name, callback, this);
                return this;
            };
        });
        // Aliases for backwards compatibility.
        Events.bind = Events.on;
        Events.unbind = Events.off;
        // Allow the `Backbone` object to serve as a global event bus, for folks who
        // want global "pubsub" in a convenient place.
        _.extend(Backbone, Events);
        // Backbone.Model
        // --------------
        // Backbone **Models** are the basic data object in the framework --
        // frequently representing a row in a table in a database on your server.
        // A discrete chunk of data and a bunch of useful, related methods for
        // performing computations and transformations on that data.
        // Create a new model with the specified attributes. A client id (`cid`)
        // is automatically generated and assigned for you.
        var Model = Backbone.Model = function(attributes, options) {
            var defaults;
            var attrs = attributes || {};
            options || (options = {});
            this.cid = _.uniqueId("c");
            this.attributes = {};
            _.extend(this, _.pick(options, modelOptions));
            if (options.parse) attrs = this.parse(attrs, options) || {};
            if (defaults = _.result(this, "defaults")) {
                attrs = _.defaults({}, attrs, defaults);
            }
            this.set(attrs, options);
            this.changed = {};
            this.initialize.apply(this, arguments);
        };
        // A list of options to be attached directly to the model, if provided.
        var modelOptions = [ "url", "urlRoot", "collection" ];
        // Attach all inheritable methods to the Model prototype.
        _.extend(Model.prototype, Events, {
            // A hash of attributes whose current and previous value differ.
            changed: null,
            // The value returned during the last failed validation.
            validationError: null,
            // The default name for the JSON `id` attribute is `"id"`. MongoDB and
            // CouchDB users may want to set this to `"_id"`.
            idAttribute: "id",
            // Initialize is an empty function by default. Override it with your own
            // initialization logic.
            initialize: function() {},
            // Return a copy of the model's `attributes` object.
            toJSON: function(options) {
                return _.clone(this.attributes);
            },
            // Proxy `Backbone.sync` by default -- but override this if you need
            // custom syncing semantics for *this* particular model.
            sync: function() {
                return Backbone.sync.apply(this, arguments);
            },
            // Get the value of an attribute.
            get: function(attr) {
                return this.attributes[attr];
            },
            // Get the HTML-escaped value of an attribute.
            escape: function(attr) {
                return _.escape(this.get(attr));
            },
            // Returns `true` if the attribute contains a value that is not null
            // or undefined.
            has: function(attr) {
                return this.get(attr) != null;
            },
            // Set a hash of model attributes on the object, firing `"change"`. This is
            // the core primitive operation of a model, updating the data and notifying
            // anyone who needs to know about the change in state. The heart of the beast.
            set: function(key, val, options) {
                var attr, attrs, unset, changes, silent, changing, prev, current;
                if (key == null) return this;
                // Handle both `"key", value` and `{key: value}` -style arguments.
                if (typeof key === "object") {
                    attrs = key;
                    options = val;
                } else {
                    (attrs = {})[key] = val;
                }
                options || (options = {});
                // Run validation.
                if (!this._validate(attrs, options)) return false;
                // Extract attributes and options.
                unset = options.unset;
                silent = options.silent;
                changes = [];
                changing = this._changing;
                this._changing = true;
                if (!changing) {
                    this._previousAttributes = _.clone(this.attributes);
                    this.changed = {};
                }
                current = this.attributes, prev = this._previousAttributes;
                // Check for changes of `id`.
                if (this.idAttribute in attrs) this.id = attrs[this.idAttribute];
                // For each `set` attribute, update or delete the current value.
                for (attr in attrs) {
                    val = attrs[attr];
                    if (!_.isEqual(current[attr], val)) changes.push(attr);
                    if (!_.isEqual(prev[attr], val)) {
                        this.changed[attr] = val;
                    } else {
                        delete this.changed[attr];
                    }
                    unset ? delete current[attr] : current[attr] = val;
                }
                // Trigger all relevant attribute changes.
                if (!silent) {
                    if (changes.length) this._pending = true;
                    for (var i = 0, l = changes.length; i < l; i++) {
                        this.trigger("change:" + changes[i], this, current[changes[i]], options);
                    }
                }
                // You might be wondering why there's a `while` loop here. Changes can
                // be recursively nested within `"change"` events.
                if (changing) return this;
                if (!silent) {
                    while (this._pending) {
                        this._pending = false;
                        this.trigger("change", this, options);
                    }
                }
                this._pending = false;
                this._changing = false;
                return this;
            },
            // Remove an attribute from the model, firing `"change"`. `unset` is a noop
            // if the attribute doesn't exist.
            unset: function(attr, options) {
                return this.set(attr, void 0, _.extend({}, options, {
                    unset: true
                }));
            },
            // Clear all attributes on the model, firing `"change"`.
            clear: function(options) {
                var attrs = {};
                for (var key in this.attributes) attrs[key] = void 0;
                return this.set(attrs, _.extend({}, options, {
                    unset: true
                }));
            },
            // Determine if the model has changed since the last `"change"` event.
            // If you specify an attribute name, determine if that attribute has changed.
            hasChanged: function(attr) {
                if (attr == null) return !_.isEmpty(this.changed);
                return _.has(this.changed, attr);
            },
            // Return an object containing all the attributes that have changed, or
            // false if there are no changed attributes. Useful for determining what
            // parts of a view need to be updated and/or what attributes need to be
            // persisted to the server. Unset attributes will be set to undefined.
            // You can also pass an attributes object to diff against the model,
            // determining if there *would be* a change.
            changedAttributes: function(diff) {
                if (!diff) return this.hasChanged() ? _.clone(this.changed) : false;
                var val, changed = false;
                var old = this._changing ? this._previousAttributes : this.attributes;
                for (var attr in diff) {
                    if (_.isEqual(old[attr], val = diff[attr])) continue;
                    (changed || (changed = {}))[attr] = val;
                }
                return changed;
            },
            // Get the previous value of an attribute, recorded at the time the last
            // `"change"` event was fired.
            previous: function(attr) {
                if (attr == null || !this._previousAttributes) return null;
                return this._previousAttributes[attr];
            },
            // Get all of the attributes of the model at the time of the previous
            // `"change"` event.
            previousAttributes: function() {
                return _.clone(this._previousAttributes);
            },
            // Fetch the model from the server. If the server's representation of the
            // model differs from its current attributes, they will be overridden,
            // triggering a `"change"` event.
            fetch: function(options) {
                options = options ? _.clone(options) : {};
                if (options.parse === void 0) options.parse = true;
                var model = this;
                var success = options.success;
                options.success = function(resp) {
                    if (!model.set(model.parse(resp, options), options)) return false;
                    if (success) success(model, resp, options);
                    model.trigger("sync", model, resp, options);
                };
                wrapError(this, options);
                return this.sync("read", this, options);
            },
            // Set a hash of model attributes, and sync the model to the server.
            // If the server returns an attributes hash that differs, the model's
            // state will be `set` again.
            save: function(key, val, options) {
                var attrs, method, xhr, attributes = this.attributes;
                // Handle both `"key", value` and `{key: value}` -style arguments.
                if (key == null || typeof key === "object") {
                    attrs = key;
                    options = val;
                } else {
                    (attrs = {})[key] = val;
                }
                // If we're not waiting and attributes exist, save acts as `set(attr).save(null, opts)`.
                if (attrs && (!options || !options.wait) && !this.set(attrs, options)) return false;
                options = _.extend({
                    validate: true
                }, options);
                // Do not persist invalid models.
                if (!this._validate(attrs, options)) return false;
                // Set temporary attributes if `{wait: true}`.
                if (attrs && options.wait) {
                    this.attributes = _.extend({}, attributes, attrs);
                }
                // After a successful server-side save, the client is (optionally)
                // updated with the server-side state.
                if (options.parse === void 0) options.parse = true;
                var model = this;
                var success = options.success;
                options.success = function(resp) {
                    // Ensure attributes are restored during synchronous saves.
                    model.attributes = attributes;
                    var serverAttrs = model.parse(resp, options);
                    if (options.wait) serverAttrs = _.extend(attrs || {}, serverAttrs);
                    if (_.isObject(serverAttrs) && !model.set(serverAttrs, options)) {
                        return false;
                    }
                    if (success) success(model, resp, options);
                    model.trigger("sync", model, resp, options);
                };
                wrapError(this, options);
                method = this.isNew() ? "create" : options.patch ? "patch" : "update";
                if (method === "patch") options.attrs = attrs;
                xhr = this.sync(method, this, options);
                // Restore attributes.
                if (attrs && options.wait) this.attributes = attributes;
                return xhr;
            },
            // Destroy this model on the server if it was already persisted.
            // Optimistically removes the model from its collection, if it has one.
            // If `wait: true` is passed, waits for the server to respond before removal.
            destroy: function(options) {
                options = options ? _.clone(options) : {};
                var model = this;
                var success = options.success;
                var destroy = function() {
                    model.trigger("destroy", model, model.collection, options);
                };
                options.success = function(resp) {
                    if (options.wait || model.isNew()) destroy();
                    if (success) success(model, resp, options);
                    if (!model.isNew()) model.trigger("sync", model, resp, options);
                };
                if (this.isNew()) {
                    options.success();
                    return false;
                }
                wrapError(this, options);
                var xhr = this.sync("delete", this, options);
                if (!options.wait) destroy();
                return xhr;
            },
            // Default URL for the model's representation on the server -- if you're
            // using Backbone's restful methods, override this to change the endpoint
            // that will be called.
            url: function() {
                var base = _.result(this, "urlRoot") || _.result(this.collection, "url") || urlError();
                if (this.isNew()) return base;
                return base + (base.charAt(base.length - 1) === "/" ? "" : "/") + encodeURIComponent(this.id);
            },
            // **parse** converts a response into the hash of attributes to be `set` on
            // the model. The default implementation is just to pass the response along.
            parse: function(resp, options) {
                return resp;
            },
            // Create a new model with identical attributes to this one.
            clone: function() {
                return new this.constructor(this.attributes);
            },
            // A model is new if it has never been saved to the server, and lacks an id.
            isNew: function() {
                return this.id == null;
            },
            // Check if the model is currently in a valid state.
            isValid: function(options) {
                return this._validate({}, _.extend(options || {}, {
                    validate: true
                }));
            },
            // Run validation against the next complete set of model attributes,
            // returning `true` if all is well. Otherwise, fire an `"invalid"` event.
            _validate: function(attrs, options) {
                if (!options.validate || !this.validate) return true;
                attrs = _.extend({}, this.attributes, attrs);
                var error = this.validationError = this.validate(attrs, options) || null;
                if (!error) return true;
                this.trigger("invalid", this, error, _.extend(options || {}, {
                    validationError: error
                }));
                return false;
            }
        });
        // Underscore methods that we want to implement on the Model.
        var modelMethods = [ "keys", "values", "pairs", "invert", "pick", "omit" ];
        // Mix in each Underscore method as a proxy to `Model#attributes`.
        _.each(modelMethods, function(method) {
            Model.prototype[method] = function() {
                var args = slice.call(arguments);
                args.unshift(this.attributes);
                return _[method].apply(_, args);
            };
        });
        // Backbone.Collection
        // -------------------
        // If models tend to represent a single row of data, a Backbone Collection is
        // more analagous to a table full of data ... or a small slice or page of that
        // table, or a collection of rows that belong together for a particular reason
        // -- all of the messages in this particular folder, all of the documents
        // belonging to this particular author, and so on. Collections maintain
        // indexes of their models, both in order, and for lookup by `id`.
        // Create a new **Collection**, perhaps to contain a specific type of `model`.
        // If a `comparator` is specified, the Collection will maintain
        // its models in sort order, as they're added and removed.
        var Collection = Backbone.Collection = function(models, options) {
            options || (options = {});
            if (options.url) this.url = options.url;
            if (options.model) this.model = options.model;
            if (options.comparator !== void 0) this.comparator = options.comparator;
            this._reset();
            this.initialize.apply(this, arguments);
            if (models) this.reset(models, _.extend({
                silent: true
            }, options));
        };
        // Default options for `Collection#set`.
        var setOptions = {
            add: true,
            remove: true,
            merge: true
        };
        var addOptions = {
            add: true,
            merge: false,
            remove: false
        };
        // Define the Collection's inheritable methods.
        _.extend(Collection.prototype, Events, {
            // The default model for a collection is just a **Backbone.Model**.
            // This should be overridden in most cases.
            model: Model,
            // Initialize is an empty function by default. Override it with your own
            // initialization logic.
            initialize: function() {},
            // The JSON representation of a Collection is an array of the
            // models' attributes.
            toJSON: function(options) {
                return this.map(function(model) {
                    return model.toJSON(options);
                });
            },
            // Proxy `Backbone.sync` by default.
            sync: function() {
                return Backbone.sync.apply(this, arguments);
            },
            // Add a model, or list of models to the set.
            add: function(models, options) {
                return this.set(models, _.defaults(options || {}, addOptions));
            },
            // Remove a model, or a list of models from the set.
            remove: function(models, options) {
                models = _.isArray(models) ? models.slice() : [ models ];
                options || (options = {});
                var i, l, index, model;
                for (i = 0, l = models.length; i < l; i++) {
                    model = this.get(models[i]);
                    if (!model) continue;
                    delete this._byId[model.id];
                    delete this._byId[model.cid];
                    index = this.indexOf(model);
                    this.models.splice(index, 1);
                    this.length--;
                    if (!options.silent) {
                        options.index = index;
                        model.trigger("remove", model, this, options);
                    }
                    this._removeReference(model);
                }
                return this;
            },
            // Update a collection by `set`-ing a new list of models, adding new ones,
            // removing models that are no longer present, and merging models that
            // already exist in the collection, as necessary. Similar to **Model#set**,
            // the core operation for updating the data contained by the collection.
            set: function(models, options) {
                options = _.defaults(options || {}, setOptions);
                if (options.parse) models = this.parse(models, options);
                if (!_.isArray(models)) models = models ? [ models ] : [];
                var i, l, model, attrs, existing, sort;
                var at = options.at;
                var sortable = this.comparator && at == null && options.sort !== false;
                var sortAttr = _.isString(this.comparator) ? this.comparator : null;
                var toAdd = [], toRemove = [], modelMap = {};
                // Turn bare objects into model references, and prevent invalid models
                // from being added.
                for (i = 0, l = models.length; i < l; i++) {
                    if (!(model = this._prepareModel(models[i], options))) continue;
                    // If a duplicate is found, prevent it from being added and
                    // optionally merge it into the existing model.
                    if (existing = this.get(model)) {
                        if (options.remove) modelMap[existing.cid] = true;
                        if (options.merge) {
                            existing.set(model.attributes, options);
                            if (sortable && !sort && existing.hasChanged(sortAttr)) sort = true;
                        }
                    } else if (options.add) {
                        toAdd.push(model);
                        // Listen to added models' events, and index models for lookup by
                        // `id` and by `cid`.
                        model.on("all", this._onModelEvent, this);
                        this._byId[model.cid] = model;
                        if (model.id != null) this._byId[model.id] = model;
                    }
                }
                // Remove nonexistent models if appropriate.
                if (options.remove) {
                    for (i = 0, l = this.length; i < l; ++i) {
                        if (!modelMap[(model = this.models[i]).cid]) toRemove.push(model);
                    }
                    if (toRemove.length) this.remove(toRemove, options);
                }
                // See if sorting is needed, update `length` and splice in new models.
                if (toAdd.length) {
                    if (sortable) sort = true;
                    this.length += toAdd.length;
                    if (at != null) {
                        splice.apply(this.models, [ at, 0 ].concat(toAdd));
                    } else {
                        push.apply(this.models, toAdd);
                    }
                }
                // Silently sort the collection if appropriate.
                if (sort) this.sort({
                    silent: true
                });
                if (options.silent) return this;
                // Trigger `add` events.
                for (i = 0, l = toAdd.length; i < l; i++) {
                    (model = toAdd[i]).trigger("add", model, this, options);
                }
                // Trigger `sort` if the collection was sorted.
                if (sort) this.trigger("sort", this, options);
                return this;
            },
            // When you have more items than you want to add or remove individually,
            // you can reset the entire set with a new list of models, without firing
            // any granular `add` or `remove` events. Fires `reset` when finished.
            // Useful for bulk operations and optimizations.
            reset: function(models, options) {
                options || (options = {});
                for (var i = 0, l = this.models.length; i < l; i++) {
                    this._removeReference(this.models[i]);
                }
                options.previousModels = this.models;
                this._reset();
                this.add(models, _.extend({
                    silent: true
                }, options));
                if (!options.silent) this.trigger("reset", this, options);
                return this;
            },
            // Add a model to the end of the collection.
            push: function(model, options) {
                model = this._prepareModel(model, options);
                this.add(model, _.extend({
                    at: this.length
                }, options));
                return model;
            },
            // Remove a model from the end of the collection.
            pop: function(options) {
                var model = this.at(this.length - 1);
                this.remove(model, options);
                return model;
            },
            // Add a model to the beginning of the collection.
            unshift: function(model, options) {
                model = this._prepareModel(model, options);
                this.add(model, _.extend({
                    at: 0
                }, options));
                return model;
            },
            // Remove a model from the beginning of the collection.
            shift: function(options) {
                var model = this.at(0);
                this.remove(model, options);
                return model;
            },
            // Slice out a sub-array of models from the collection.
            slice: function(begin, end) {
                return this.models.slice(begin, end);
            },
            // Get a model from the set by id.
            get: function(obj) {
                if (obj == null) return void 0;
                return this._byId[obj.id != null ? obj.id : obj.cid || obj];
            },
            // Get the model at the given index.
            at: function(index) {
                return this.models[index];
            },
            // Return models with matching attributes. Useful for simple cases of
            // `filter`.
            where: function(attrs, first) {
                if (_.isEmpty(attrs)) return first ? void 0 : [];
                return this[first ? "find" : "filter"](function(model) {
                    for (var key in attrs) {
                        if (attrs[key] !== model.get(key)) return false;
                    }
                    return true;
                });
            },
            // Return the first model with matching attributes. Useful for simple cases
            // of `find`.
            findWhere: function(attrs) {
                return this.where(attrs, true);
            },
            // Force the collection to re-sort itself. You don't need to call this under
            // normal circumstances, as the set will maintain sort order as each item
            // is added.
            sort: function(options) {
                if (!this.comparator) throw new Error("Cannot sort a set without a comparator");
                options || (options = {});
                // Run sort based on type of `comparator`.
                if (_.isString(this.comparator) || this.comparator.length === 1) {
                    this.models = this.sortBy(this.comparator, this);
                } else {
                    this.models.sort(_.bind(this.comparator, this));
                }
                if (!options.silent) this.trigger("sort", this, options);
                return this;
            },
            // Figure out the smallest index at which a model should be inserted so as
            // to maintain order.
            sortedIndex: function(model, value, context) {
                value || (value = this.comparator);
                var iterator = _.isFunction(value) ? value : function(model) {
                    return model.get(value);
                };
                return _.sortedIndex(this.models, model, iterator, context);
            },
            // Pluck an attribute from each model in the collection.
            pluck: function(attr) {
                return _.invoke(this.models, "get", attr);
            },
            // Fetch the default set of models for this collection, resetting the
            // collection when they arrive. If `reset: true` is passed, the response
            // data will be passed through the `reset` method instead of `set`.
            fetch: function(options) {
                options = options ? _.clone(options) : {};
                if (options.parse === void 0) options.parse = true;
                var success = options.success;
                var collection = this;
                options.success = function(resp) {
                    var method = options.reset ? "reset" : "set";
                    collection[method](resp, options);
                    if (success) success(collection, resp, options);
                    collection.trigger("sync", collection, resp, options);
                };
                wrapError(this, options);
                return this.sync("read", this, options);
            },
            // Create a new instance of a model in this collection. Add the model to the
            // collection immediately, unless `wait: true` is passed, in which case we
            // wait for the server to agree.
            create: function(model, options) {
                options = options ? _.clone(options) : {};
                if (!(model = this._prepareModel(model, options))) return false;
                if (!options.wait) this.add(model, options);
                var collection = this;
                var success = options.success;
                options.success = function(resp) {
                    if (options.wait) collection.add(model, options);
                    if (success) success(model, resp, options);
                };
                model.save(null, options);
                return model;
            },
            // **parse** converts a response into a list of models to be added to the
            // collection. The default implementation is just to pass it through.
            parse: function(resp, options) {
                return resp;
            },
            // Create a new collection with an identical list of models as this one.
            clone: function() {
                return new this.constructor(this.models);
            },
            // Private method to reset all internal state. Called when the collection
            // is first initialized or reset.
            _reset: function() {
                this.length = 0;
                this.models = [];
                this._byId = {};
            },
            // Prepare a hash of attributes (or other model) to be added to this
            // collection.
            _prepareModel: function(attrs, options) {
                if (attrs instanceof Model) {
                    if (!attrs.collection) attrs.collection = this;
                    return attrs;
                }
                options || (options = {});
                options.collection = this;
                var model = new this.model(attrs, options);
                if (!model._validate(attrs, options)) {
                    this.trigger("invalid", this, attrs, options);
                    return false;
                }
                return model;
            },
            // Internal method to sever a model's ties to a collection.
            _removeReference: function(model) {
                if (this === model.collection) delete model.collection;
                model.off("all", this._onModelEvent, this);
            },
            // Internal method called every time a model in the set fires an event.
            // Sets need to update their indexes when models change ids. All other
            // events simply proxy through. "add" and "remove" events that originate
            // in other collections are ignored.
            _onModelEvent: function(event, model, collection, options) {
                if ((event === "add" || event === "remove") && collection !== this) return;
                if (event === "destroy") this.remove(model, options);
                if (model && event === "change:" + model.idAttribute) {
                    delete this._byId[model.previous(model.idAttribute)];
                    if (model.id != null) this._byId[model.id] = model;
                }
                this.trigger.apply(this, arguments);
            }
        });
        // Underscore methods that we want to implement on the Collection.
        // 90% of the core usefulness of Backbone Collections is actually implemented
        // right here:
        var methods = [ "forEach", "each", "map", "collect", "reduce", "foldl", "inject", "reduceRight", "foldr", "find", "detect", "filter", "select", "reject", "every", "all", "some", "any", "include", "contains", "invoke", "max", "min", "toArray", "size", "first", "head", "take", "initial", "rest", "tail", "drop", "last", "without", "indexOf", "shuffle", "lastIndexOf", "isEmpty", "chain" ];
        // Mix in each Underscore method as a proxy to `Collection#models`.
        _.each(methods, function(method) {
            Collection.prototype[method] = function() {
                var args = slice.call(arguments);
                args.unshift(this.models);
                return _[method].apply(_, args);
            };
        });
        // Underscore methods that take a property name as an argument.
        var attributeMethods = [ "groupBy", "countBy", "sortBy" ];
        // Use attributes instead of properties.
        _.each(attributeMethods, function(method) {
            Collection.prototype[method] = function(value, context) {
                var iterator = _.isFunction(value) ? value : function(model) {
                    return model.get(value);
                };
                return _[method](this.models, iterator, context);
            };
        });
        // Backbone.View
        // -------------
        // Backbone Views are almost more convention than they are actual code. A View
        // is simply a JavaScript object that represents a logical chunk of UI in the
        // DOM. This might be a single item, an entire list, a sidebar or panel, or
        // even the surrounding frame which wraps your whole app. Defining a chunk of
        // UI as a **View** allows you to define your DOM events declaratively, without
        // having to worry about render order ... and makes it easy for the view to
        // react to specific changes in the state of your models.
        // Creating a Backbone.View creates its initial element outside of the DOM,
        // if an existing element is not provided...
        var View = Backbone.View = function(options) {
            this.cid = _.uniqueId("view");
            this._configure(options || {});
            this._ensureElement();
            this.initialize.apply(this, arguments);
            this.delegateEvents();
        };
        // Cached regex to split keys for `delegate`.
        var delegateEventSplitter = /^(\S+)\s*(.*)$/;
        // List of view options to be merged as properties.
        var viewOptions = [ "model", "collection", "el", "id", "attributes", "className", "tagName", "events" ];
        // Set up all inheritable **Backbone.View** properties and methods.
        _.extend(View.prototype, Events, {
            // The default `tagName` of a View's element is `"div"`.
            tagName: "div",
            // jQuery delegate for element lookup, scoped to DOM elements within the
            // current view. This should be prefered to global lookups where possible.
            $: function(selector) {
                return this.$el.find(selector);
            },
            // Initialize is an empty function by default. Override it with your own
            // initialization logic.
            initialize: function() {},
            // **render** is the core function that your view should override, in order
            // to populate its element (`this.el`), with the appropriate HTML. The
            // convention is for **render** to always return `this`.
            render: function() {
                return this;
            },
            // Remove this view by taking the element out of the DOM, and removing any
            // applicable Backbone.Events listeners.
            remove: function() {
                this.$el.remove();
                this.stopListening();
                return this;
            },
            // Change the view's element (`this.el` property), including event
            // re-delegation.
            setElement: function(element, delegate) {
                if (this.$el) this.undelegateEvents();
                this.$el = element instanceof Backbone.$ ? element : Backbone.$(element);
                this.el = this.$el[0];
                if (delegate !== false) this.delegateEvents();
                return this;
            },
            // Set callbacks, where `this.events` is a hash of
            //
            // *{"event selector": "callback"}*
            //
            //     {
            //       'mousedown .title':  'edit',
            //       'click .button':     'save'
            //       'click .open':       function(e) { ... }
            //     }
            //
            // pairs. Callbacks will be bound to the view, with `this` set properly.
            // Uses event delegation for efficiency.
            // Omitting the selector binds the event to `this.el`.
            // This only works for delegate-able events: not `focus`, `blur`, and
            // not `change`, `submit`, and `reset` in Internet Explorer.
            delegateEvents: function(events) {
                if (!(events || (events = _.result(this, "events")))) return this;
                this.undelegateEvents();
                for (var key in events) {
                    var method = events[key];
                    if (!_.isFunction(method)) method = this[events[key]];
                    if (!method) continue;
                    var match = key.match(delegateEventSplitter);
                    var eventName = match[1], selector = match[2];
                    method = _.bind(method, this);
                    eventName += ".delegateEvents" + this.cid;
                    if (selector === "") {
                        this.$el.on(eventName, method);
                    } else {
                        this.$el.on(eventName, selector, method);
                    }
                }
                return this;
            },
            // Clears all callbacks previously bound to the view with `delegateEvents`.
            // You usually don't need to use this, but may wish to if you have multiple
            // Backbone views attached to the same DOM element.
            undelegateEvents: function() {
                this.$el.off(".delegateEvents" + this.cid);
                return this;
            },
            // Performs the initial configuration of a View with a set of options.
            // Keys with special meaning *(e.g. model, collection, id, className)* are
            // attached directly to the view.  See `viewOptions` for an exhaustive
            // list.
            _configure: function(options) {
                if (this.options) options = _.extend({}, _.result(this, "options"), options);
                _.extend(this, _.pick(options, viewOptions));
                this.options = options;
            },
            // Ensure that the View has a DOM element to render into.
            // If `this.el` is a string, pass it through `$()`, take the first
            // matching element, and re-assign it to `el`. Otherwise, create
            // an element from the `id`, `className` and `tagName` properties.
            _ensureElement: function() {
                if (!this.el) {
                    var attrs = _.extend({}, _.result(this, "attributes"));
                    if (this.id) attrs.id = _.result(this, "id");
                    if (this.className) attrs["class"] = _.result(this, "className");
                    var $el = Backbone.$("<" + _.result(this, "tagName") + ">").attr(attrs);
                    this.setElement($el, false);
                } else {
                    this.setElement(_.result(this, "el"), false);
                }
            }
        });
        // Backbone.sync
        // -------------
        // Override this function to change the manner in which Backbone persists
        // models to the server. You will be passed the type of request, and the
        // model in question. By default, makes a RESTful Ajax request
        // to the model's `url()`. Some possible customizations could be:
        //
        // * Use `setTimeout` to batch rapid-fire updates into a single request.
        // * Send up the models as XML instead of JSON.
        // * Persist models via WebSockets instead of Ajax.
        //
        // Turn on `Backbone.emulateHTTP` in order to send `PUT` and `DELETE` requests
        // as `POST`, with a `_method` parameter containing the true HTTP method,
        // as well as all requests with the body as `application/x-www-form-urlencoded`
        // instead of `application/json` with the model in a param named `model`.
        // Useful when interfacing with server-side languages like **PHP** that make
        // it difficult to read the body of `PUT` requests.
        Backbone.sync = function(method, model, options) {
            var type = methodMap[method];
            // Default options, unless specified.
            _.defaults(options || (options = {}), {
                emulateHTTP: Backbone.emulateHTTP,
                emulateJSON: Backbone.emulateJSON
            });
            // Default JSON-request options.
            var params = {
                type: type,
                dataType: "json"
            };
            // Ensure that we have a URL.
            if (!options.url) {
                params.url = _.result(model, "url") || urlError();
            }
            // Ensure that we have the appropriate request data.
            if (options.data == null && model && (method === "create" || method === "update" || method === "patch")) {
                params.contentType = "application/json";
                params.data = JSON.stringify(options.attrs || model.toJSON(options));
            }
            // For older servers, emulate JSON by encoding the request into an HTML-form.
            if (options.emulateJSON) {
                params.contentType = "application/x-www-form-urlencoded";
                params.data = params.data ? {
                    model: params.data
                } : {};
            }
            // For older servers, emulate HTTP by mimicking the HTTP method with `_method`
            // And an `X-HTTP-Method-Override` header.
            if (options.emulateHTTP && (type === "PUT" || type === "DELETE" || type === "PATCH")) {
                params.type = "POST";
                if (options.emulateJSON) params.data._method = type;
                var beforeSend = options.beforeSend;
                options.beforeSend = function(xhr) {
                    xhr.setRequestHeader("X-HTTP-Method-Override", type);
                    if (beforeSend) return beforeSend.apply(this, arguments);
                };
            }
            // Don't process data on a non-GET request.
            if (params.type !== "GET" && !options.emulateJSON) {
                params.processData = false;
            }
            // If we're sending a `PATCH` request, and we're in an old Internet Explorer
            // that still has ActiveX enabled by default, override jQuery to use that
            // for XHR instead. Remove this line when jQuery supports `PATCH` on IE8.
            if (params.type === "PATCH" && window.ActiveXObject && !(window.external && window.external.msActiveXFilteringEnabled)) {
                params.xhr = function() {
                    return new ActiveXObject("Microsoft.XMLHTTP");
                };
            }
            // Make the request, allowing the user to override any Ajax options.
            var xhr = options.xhr = Backbone.ajax(_.extend(params, options));
            model.trigger("request", model, xhr, options);
            return xhr;
        };
        // Map from CRUD to HTTP for our default `Backbone.sync` implementation.
        var methodMap = {
            create: "POST",
            update: "PUT",
            patch: "PATCH",
            "delete": "DELETE",
            read: "GET"
        };
        // Set the default implementation of `Backbone.ajax` to proxy through to `$`.
        // Override this if you'd like to use a different library.
        Backbone.ajax = function() {
            return Backbone.$.ajax.apply(Backbone.$, arguments);
        };
        // Backbone.Router
        // ---------------
        // Routers map faux-URLs to actions, and fire events when routes are
        // matched. Creating a new one sets its `routes` hash, if not set statically.
        var Router = Backbone.Router = function(options) {
            options || (options = {});
            if (options.routes) this.routes = options.routes;
            this._bindRoutes();
            this.initialize.apply(this, arguments);
        };
        // Cached regular expressions for matching named param parts and splatted
        // parts of route strings.
        var optionalParam = /\((.*?)\)/g;
        var namedParam = /(\(\?)?:\w+/g;
        var splatParam = /\*\w+/g;
        var escapeRegExp = /[\-{}\[\]+?.,\\\^$|#\s]/g;
        // Set up all inheritable **Backbone.Router** properties and methods.
        _.extend(Router.prototype, Events, {
            // Initialize is an empty function by default. Override it with your own
            // initialization logic.
            initialize: function() {},
            // Manually bind a single named route to a callback. For example:
            //
            //     this.route('search/:query/p:num', 'search', function(query, num) {
            //       ...
            //     });
            //
            route: function(route, name, callback) {
                if (!_.isRegExp(route)) route = this._routeToRegExp(route);
                if (_.isFunction(name)) {
                    callback = name;
                    name = "";
                }
                if (!callback) callback = this[name];
                var router = this;
                Backbone.history.route(route, function(fragment) {
                    var args = router._extractParameters(route, fragment);
                    callback && callback.apply(router, args);
                    router.trigger.apply(router, [ "route:" + name ].concat(args));
                    router.trigger("route", name, args);
                    Backbone.history.trigger("route", router, name, args);
                });
                return this;
            },
            // Simple proxy to `Backbone.history` to save a fragment into the history.
            navigate: function(fragment, options) {
                Backbone.history.navigate(fragment, options);
                return this;
            },
            // Bind all defined routes to `Backbone.history`. We have to reverse the
            // order of the routes here to support behavior where the most general
            // routes can be defined at the bottom of the route map.
            _bindRoutes: function() {
                if (!this.routes) return;
                this.routes = _.result(this, "routes");
                var route, routes = _.keys(this.routes);
                while ((route = routes.pop()) != null) {
                    this.route(route, this.routes[route]);
                }
            },
            // Convert a route string into a regular expression, suitable for matching
            // against the current location hash.
            _routeToRegExp: function(route) {
                route = route.replace(escapeRegExp, "\\$&").replace(optionalParam, "(?:$1)?").replace(namedParam, function(match, optional) {
                    return optional ? match : "([^/]+)";
                }).replace(splatParam, "(.*?)");
                return new RegExp("^" + route + "$");
            },
            // Given a route, and a URL fragment that it matches, return the array of
            // extracted decoded parameters. Empty or unmatched parameters will be
            // treated as `null` to normalize cross-browser behavior.
            _extractParameters: function(route, fragment) {
                var params = route.exec(fragment).slice(1);
                return _.map(params, function(param) {
                    return param ? decodeURIComponent(param) : null;
                });
            }
        });
        // Backbone.History
        // ----------------
        // Handles cross-browser history management, based on either
        // [pushState](http://diveintohtml5.info/history.html) and real URLs, or
        // [onhashchange](https://developer.mozilla.org/en-US/docs/DOM/window.onhashchange)
        // and URL fragments. If the browser supports neither (old IE, natch),
        // falls back to polling.
        var History = Backbone.History = function() {
            this.handlers = [];
            _.bindAll(this, "checkUrl");
            // Ensure that `History` can be used outside of the browser.
            if (typeof window !== "undefined") {
                this.location = window.location;
                this.history = window.history;
            }
        };
        // Cached regex for stripping a leading hash/slash and trailing space.
        var routeStripper = /^[#\/]|\s+$/g;
        // Cached regex for stripping leading and trailing slashes.
        var rootStripper = /^\/+|\/+$/g;
        // Cached regex for detecting MSIE.
        var isExplorer = /msie [\w.]+/;
        // Cached regex for removing a trailing slash.
        var trailingSlash = /\/$/;
        // Has the history handling already been started?
        History.started = false;
        // Set up all inheritable **Backbone.History** properties and methods.
        _.extend(History.prototype, Events, {
            // The default interval to poll for hash changes, if necessary, is
            // twenty times a second.
            interval: 50,
            // Gets the true hash value. Cannot use location.hash directly due to bug
            // in Firefox where location.hash will always be decoded.
            getHash: function(window) {
                var match = (window || this).location.href.match(/#(.*)$/);
                return match ? match[1] : "";
            },
            // Get the cross-browser normalized URL fragment, either from the URL,
            // the hash, or the override.
            getFragment: function(fragment, forcePushState) {
                if (fragment == null) {
                    if (this._hasPushState || !this._wantsHashChange || forcePushState) {
                        fragment = this.location.pathname;
                        var root = this.root.replace(trailingSlash, "");
                        if (!fragment.indexOf(root)) fragment = fragment.substr(root.length);
                    } else {
                        fragment = this.getHash();
                    }
                }
                return fragment.replace(routeStripper, "");
            },
            // Start the hash change handling, returning `true` if the current URL matches
            // an existing route, and `false` otherwise.
            start: function(options) {
                if (History.started) throw new Error("Backbone.history has already been started");
                History.started = true;
                // Figure out the initial configuration. Do we need an iframe?
                // Is pushState desired ... is it available?
                this.options = _.extend({}, {
                    root: "/"
                }, this.options, options);
                this.root = this.options.root;
                this._wantsHashChange = this.options.hashChange !== false;
                this._wantsPushState = !!this.options.pushState;
                this._hasPushState = !!(this.options.pushState && this.history && this.history.pushState);
                var fragment = this.getFragment();
                var docMode = document.documentMode;
                var oldIE = isExplorer.exec(navigator.userAgent.toLowerCase()) && (!docMode || docMode <= 7);
                // Normalize root to always include a leading and trailing slash.
                this.root = ("/" + this.root + "/").replace(rootStripper, "/");
                if (oldIE && this._wantsHashChange) {
                    this.iframe = Backbone.$('<iframe src="javascript:0" tabindex="-1" />').hide().appendTo("body")[0].contentWindow;
                    this.navigate(fragment);
                }
                // Depending on whether we're using pushState or hashes, and whether
                // 'onhashchange' is supported, determine how we check the URL state.
                if (this._hasPushState) {
                    Backbone.$(window).on("popstate", this.checkUrl);
                } else if (this._wantsHashChange && "onhashchange" in window && !oldIE) {
                    Backbone.$(window).on("hashchange", this.checkUrl);
                } else if (this._wantsHashChange) {
                    this._checkUrlInterval = setInterval(this.checkUrl, this.interval);
                }
                // Determine if we need to change the base url, for a pushState link
                // opened by a non-pushState browser.
                this.fragment = fragment;
                var loc = this.location;
                var atRoot = loc.pathname.replace(/[^\/]$/, "$&/") === this.root;
                // If we've started off with a route from a `pushState`-enabled browser,
                // but we're currently in a browser that doesn't support it...
                if (this._wantsHashChange && this._wantsPushState && !this._hasPushState && !atRoot) {
                    this.fragment = this.getFragment(null, true);
                    this.location.replace(this.root + this.location.search + "#" + this.fragment);
                    // Return immediately as browser will do redirect to new url
                    return true;
                } else if (this._wantsPushState && this._hasPushState && atRoot && loc.hash) {
                    this.fragment = this.getHash().replace(routeStripper, "");
                    this.history.replaceState({}, document.title, this.root + this.fragment + loc.search);
                }
                if (!this.options.silent) return this.loadUrl();
            },
            // Disable Backbone.history, perhaps temporarily. Not useful in a real app,
            // but possibly useful for unit testing Routers.
            stop: function() {
                Backbone.$(window).off("popstate", this.checkUrl).off("hashchange", this.checkUrl);
                clearInterval(this._checkUrlInterval);
                History.started = false;
            },
            // Add a route to be tested when the fragment changes. Routes added later
            // may override previous routes.
            route: function(route, callback) {
                this.handlers.unshift({
                    route: route,
                    callback: callback
                });
            },
            // Checks the current URL to see if it has changed, and if it has,
            // calls `loadUrl`, normalizing across the hidden iframe.
            checkUrl: function(e) {
                var current = this.getFragment();
                if (current === this.fragment && this.iframe) {
                    current = this.getFragment(this.getHash(this.iframe));
                }
                if (current === this.fragment) return false;
                if (this.iframe) this.navigate(current);
                this.loadUrl() || this.loadUrl(this.getHash());
            },
            // Attempt to load the current URL fragment. If a route succeeds with a
            // match, returns `true`. If no defined routes matches the fragment,
            // returns `false`.
            loadUrl: function(fragmentOverride) {
                var fragment = this.fragment = this.getFragment(fragmentOverride);
                var matched = _.any(this.handlers, function(handler) {
                    if (handler.route.test(fragment)) {
                        handler.callback(fragment);
                        return true;
                    }
                });
                return matched;
            },
            // Save a fragment into the hash history, or replace the URL state if the
            // 'replace' option is passed. You are responsible for properly URL-encoding
            // the fragment in advance.
            //
            // The options object can contain `trigger: true` if you wish to have the
            // route callback be fired (not usually desirable), or `replace: true`, if
            // you wish to modify the current URL without adding an entry to the history.
            navigate: function(fragment, options) {
                if (!History.started) return false;
                if (!options || options === true) options = {
                    trigger: options
                };
                fragment = this.getFragment(fragment || "");
                if (this.fragment === fragment) return;
                this.fragment = fragment;
                var url = this.root + fragment;
                // If pushState is available, we use it to set the fragment as a real URL.
                if (this._hasPushState) {
                    this.history[options.replace ? "replaceState" : "pushState"]({}, document.title, url);
                } else if (this._wantsHashChange) {
                    this._updateHash(this.location, fragment, options.replace);
                    if (this.iframe && fragment !== this.getFragment(this.getHash(this.iframe))) {
                        // Opening and closing the iframe tricks IE7 and earlier to push a
                        // history entry on hash-tag change.  When replace is true, we don't
                        // want this.
                        if (!options.replace) this.iframe.document.open().close();
                        this._updateHash(this.iframe.location, fragment, options.replace);
                    }
                } else {
                    return this.location.assign(url);
                }
                if (options.trigger) this.loadUrl(fragment);
            },
            // Update the hash location, either replacing the current entry, or adding
            // a new one to the browser history.
            _updateHash: function(location, fragment, replace) {
                if (replace) {
                    var href = location.href.replace(/(javascript:|#).*$/, "");
                    location.replace(href + "#" + fragment);
                } else {
                    // Some browsers require that `hash` contains a leading #.
                    location.hash = "#" + fragment;
                }
            }
        });
        // Create the default Backbone.history.
        Backbone.history = new History();
        // Helpers
        // -------
        // Helper function to correctly set up the prototype chain, for subclasses.
        // Similar to `goog.inherits`, but uses a hash of prototype properties and
        // class properties to be extended.
        var extend = function(protoProps, staticProps) {
            var parent = this;
            var child;
            // The constructor function for the new subclass is either defined by you
            // (the "constructor" property in your `extend` definition), or defaulted
            // by us to simply call the parent's constructor.
            if (protoProps && _.has(protoProps, "constructor")) {
                child = protoProps.constructor;
            } else {
                child = function() {
                    return parent.apply(this, arguments);
                };
            }
            // Add static properties to the constructor function, if supplied.
            _.extend(child, parent, staticProps);
            // Set the prototype chain to inherit from `parent`, without calling
            // `parent`'s constructor function.
            var Surrogate = function() {
                this.constructor = child;
            };
            Surrogate.prototype = parent.prototype;
            child.prototype = new Surrogate();
            // Add prototype properties (instance properties) to the subclass,
            // if supplied.
            if (protoProps) _.extend(child.prototype, protoProps);
            // Set a convenience property in case the parent's prototype is needed
            // later.
            child.__super__ = parent.prototype;
            return child;
        };
        // Set up inheritance for the model, collection, router, view and history.
        Model.extend = Collection.extend = Router.extend = View.extend = History.extend = extend;
        // Throw an error when a URL is needed, and none is supplied.
        var urlError = function() {
            throw new Error('A "url" property or function must be specified');
        };
        // Wrap an optional error callback with a fallback error event.
        var wrapError = function(model, options) {
            var error = options.error;
            options.error = function(resp) {
                if (error) error(model, resp, options);
                model.trigger("error", model, resp, options);
            };
        };
    }).call(this);
    this._ = previousUnderscore;
    this.jQuery = previousJQuery;
});

// @charset "utf-8"
/**
 * 股票代码键盘精灵实现类
 * author 梁威<liangwei@myhexin.com>
 * create 2009-11-26
 * refactor 2013-05-09 修正了DIV内部滚动条滚动时，键盘精灵无法自动重新定位的问题
 * refactor 2013-05-09 将初始化参数修改为对象
 */
define("C:/gulp/customplates/js/static/lib/jpjl.js" ,[], function(require , exports , module){
	var JpjlModel;
	
	// create by John Resig(Jquery 创始人)
	// Inspired by base2 and Prototype
	(function(){
	  var initializing = false, fnTest = /xyz/.test(function(){xyz;}) ? /\b_super\b/ : /.*/;

	  // The base Class implementation (does nothing)
	  this.Class = function(){};
	 
	  // Create a new Class that inherits from this class
	  Class.extend = function(prop) {
		var _super = this.prototype;
	   
		// Instantiate a base class (but only create the instance,
		// don't run the init constructor)
		initializing = true;
		var prototype = new this();
		initializing = false;
	   
		// Copy the properties over onto the new prototype
		for (var name in prop) {
		  // Check if we're overwriting an existing function
		  prototype[name] = typeof prop[name] == "function" &&
			typeof _super[name] == "function" && fnTest.test(prop[name]) ?
			(function(name, fn){
			  return function() {
				var tmp = this._super;
			   
				// Add a new ._super() method that is the same method
				// but on the super-class
				this._super = _super[name];
			   
				// The method only need to be bound temporarily, so we
				// remove it when we're done executing
				var ret = fn.apply(this, arguments);       
				this._super = tmp;
			   
				return ret;
			  };
			})(name, prop[name]) :
			prop[name];
		}
	   
		// The dummy class constructor
		function Class() {
		  // All construction is actually done in the init method
		  if ( !initializing && this.init )
			this.init.apply(this, arguments);
		}
	   
		// Populate our constructed prototype object
		Class.prototype = prototype;
	   
		// Enforce the constructor to be what we expect
		Class.constructor = Class;

		// And make this class extendable
		Class.extend = arguments.callee;
	   
		return Class;
	  };
	})();

	JpjlModel = Class.extend({
	    /**
	     * 构造函数
	     * @param JSON	options 包含如下内容
	     * @param {String}  inputSelector   	<必填>股票代码输入框选择符
	     * @param {String}  scrollDivSelector  	<可选>键盘精灵所处的滚动DIV选择符
	     * @param {String}  addBtnSelector  	<必填>股票代码添加按钮选择符
	     * @param {Integer} showListNum     	<可选>用于提示的代码数量
	     */
	     init : function(options) {
	        this._inputSelector     = options.inputSelector || null;
	        this._autocompleteSelector = '.autocomplete';
	        this._scrollDivSelector = options.scrollDivSelector || null;
	        this._addBtnSelector    = options.addBtnSelector || null;
	        this._showListNum       = options.showListNum || 10;
	        this._appendToSelector 	= options.appendToSelector || 'body';
	        
	        try {
	        	this._thsUtil       = external.createObject('Util');
	        } catch(e) {
	        	return;
	        }
	        this._windowResize      = null;
	        
	        
	        var self = this;
	       
	        if (this._scrollDivSelector) {
	        	 $(this._scrollDivSelector).scroll(function () {
	        		 $(self._autocompleteSelector).hide();
	             });
	        }
	    }
	
	    ,destroy : function() {
	        this._inputSelector     = null;
	        this._addBtnSelector    = null;
	        this._showListNum       = null;
	        this._thsUtil           = null;
	        this._windowResize      = null;
	    }
	    
	    /**
	     * 用于渲染股票代码的键盘精灵
	     */
	    ,render : function(params) {
			var params = params || {};

			var top = params.top || '';
			var left = params.left || '';
	        var $autocomplete = $('<ul class="autocomplete br" style="'+('' != left ? "left:"+left+"px;" : '')+('' != top ? "top:"+top+"px;" : '')+'"></ul>').hide()
					.appendTo(this._appendToSelector);
	        
	        var self = this;
	        var selectedItem = null;
	        var setSelectedItem = function(item) {
	            selectedItem = item;
	            if (selectedItem === null) {
	                $autocomplete.hide();
					$('#view_search_options_relation').hide();
	                return;
	            }
	            if (selectedItem < 0) {
	                selectedItem = 0;
	            }
	            var maxLength = $autocomplete.find('li').length - 1;
	            if (selectedItem > maxLength) {
	                selectedItem = maxLength;
	            }
	            $autocomplete.find('li').removeClass('selected')
	                    .eq(selectedItem).addClass('selected');
				if (self.position && self.position == 'up') {
					var $inputEl	= $(self._inputSelector);
					var inputTop	= $inputEl.offset().top;
					var num			= $autocomplete.find('li').length;
					var top			= inputTop - num * 20 - 5;
					$autocomplete.css({top: top});
				}
	            $autocomplete.show();
	        };
	
	        var populateSearchField = function() {
	            var str = $autocomplete.find('li').eq(selectedItem).find('strong').text();
				var name = $autocomplete.find('li').eq(selectedItem).find('span').text();
	            $(self._inputSelector).val(str);
				$(self._inputSelector).attr('stockName',str+'.'+name);
	            setSelectedItem(null);

				$('#view_searchbtn').click();
	        };
	
	        $(this._inputSelector).keyup(function(event) {
	            // Keys with codes 40 and below are special (enter, arrow keys, escape, etc.).
	            // Key code 8 is backspace.
	            if ((event.keyCode > 40 || event.keyCode == 8 || event.keyCode == 32)) {
	                var val = $(this).val();
	                if(val.length > 0 && val.length < 7){
	                    var data = self._thsUtil.filterStock({filter : val, count : self._showListNum, markets : '17,33', stockclass : '1'});
	                    data = data.replace(/(\w)'(\w)/g, "$1\\'$2");
	                    data = eval('(' + data + ')');
	//                    alert(data);return;
	                    if (data && data.length) {
	                        $autocomplete.empty();
	                        $.each(data, function(index) {
	                            var elCnt = '<strong>' + this.stock + '</strong><span>' + this.name + '</span>' + this.py;
	                            $('<li></li>').html(elCnt).appendTo($autocomplete).mouseover(function() {
	                                setSelectedItem(index);
	                            }).click(populateSearchField);
	                            var maxLiWidth = 300;
	                            $autocomplete.find('li').css('width', 'auto').each(function() {
	                                var liWidth = $(this).width();
	                                if (liWidth > maxLiWidth) {
	                                    maxLiWidth = liWidth;
	                                }
	                            });
	                            $autocomplete.find('li').css('width', maxLiWidth + 'px');
	                        });
	                        setSelectedItem(0);
	                    } else {
	                        setSelectedItem(null);
	                    }
	                } else {
	                    setSelectedItem(null);
	                }
	            } else if (event.keyCode == 38 && selectedItem !== null) {// User pressed up arrow.
	                setSelectedItem(selectedItem - 1);
	                event.preventDefault();
	            } else if (event.keyCode == 40 && selectedItem !== null) {// User pressed down arrow.
	                setSelectedItem(selectedItem + 1);
	                event.preventDefault();
	            } else if (event.keyCode == 27 && selectedItem !== null) {// User pressed escape key.
	                setSelectedItem(null);
	            } else if (event.keyCode == 38 && selectedItem === null) {
					//扩展代码，无需需要，请删除-LXD
					if ('block' === $('#view_search_options_relation').css('display')) {
						var $nowActive = $('.active.view_relation_query_item');
						if (null === $nowActive.html()) {
							$('.view_relation_query_item').eq(0).addClass('active');
							return false;
						}
						if (!$nowActive.prev().hasClass('view_relation_query_item')) {
							return false;
						}
						$nowActive.removeClass('active');
						$nowActive.prev().addClass('active');
						return false;
					}
				} else if (event.keyCode == 40 && selectedItem === null) {
					//扩展代码，无需需要，请删除-LXD
					if ('block' === $('#view_search_options_relation').css('display')) {
						var $nowActive = $('.active.view_relation_query_item');
						if (null === $nowActive.html()) {
							$('.view_relation_query_item').eq(0).addClass('active');
							return false;
						}
						if (!$nowActive.next().hasClass('view_relation_query_item')) {
							return false;
						}
						$nowActive.removeClass('active');
						$nowActive.next().addClass('active');
						return false;
					}
				}
	        }).keydown(function(event) {
	            if (event.keyCode == 13) {// User pressed enter key.
					//扩展代码，无需需要，请删除-LXD
					if ('block' === $('#view_search_options_relation').css('display')) {
						var $nowActive = $('.active.view_relation_query_item');
						if (null !== $nowActive.html()) {
							$('#view_searchinput').val($nowActive.text());
						}	
					}
	                if (selectedItem !== null) {
	                    populateSearchField();
	                    event.preventDefault();
	                } else {
	                    if (self._addBtnSelector) {
	                        $(self._addBtnSelector).trigger('click');
	                    }
	                    var rel = $(self._inputSelector).get(0);
	                    var rng = rel.createTextRange();
	                    rng.moveStart('character', 0);
	                    // rng.select();
	                    delete rng; rng = null;
	                    delete rel; rel = null;
	                }
	            }
	        }).blur(function(event) {
	            setTimeout(function() {
	                setSelectedItem(null);
	            }, 250);
	        });
	    }
	
	    /**
	     * 用于获得股票代码输入框内所属如代码的详细信息对象
	     * @return {Object}
	     */
	    ,getInputCodeData : function() {
	        var  val = $(this._inputSelector).val();
	        if (!val.length) {
	            return null;
	        }
	        var data = this._thsUtil.filterStock({filter : val, count : 1, markets : '17,33', stockclass : '1'});
	        data = eval('(' + data + ')');
	        if (data && data.length == 1) {
	            return {stock : data[0].stock, name : data[0].name};
	        }
	        return null;
	    }
	});
	module.exports = JpjlModel;
});
//@charset "utf-8";
//问句数据 
define("C:/gulp/customplates/js/static/views/querysearch.js" ,["backbone","_","C:/gulp/customplates/js/static/lib/clientjump.js","C:/gulp/customplates/js/static/models/querysearch.js","C:/gulp/customplates/js/static/models/historyquery.js","C:/gulp/customplates/js/static/models/codelist.js","C:/gulp/customplates/js/static/views/secondsearch.js"], function(require , exports , module){
	var Backbone = require('backbone');
	var _ = require('_');

	var clientJump = require("C:/gulp/customplates/js/static/lib/clientjump.js");

	var querySearchModel = require("C:/gulp/customplates/js/static/models/querysearch.js");
	var historyQueryModel = require("C:/gulp/customplates/js/static/models/historyquery.js");
	var codelistModel = require("C:/gulp/customplates/js/static/models/codelist.js");

	var secondSearchView = require("C:/gulp/customplates/js/static/views/secondsearch.js");

	var QuerySearchView = Backbone.View.extend({
		el : '#view_result_condition',
		query : '',
		pageSize : 10,
		initialize : function() {
			secondSearchView.querySearchView = this;
		},
		events : {
			'dblclick [view_dbl_query_search]' : 'jumpClientMLine',
			'click .view_td_sort' : 'stockSort'
		},
		request : function (query) {
			$('#noResultView').hide();
			$('#view_result_condition').hide();

			var self = this;

			self.query = query;
			codelistModel.clearCodeList();
			query = secondSearchView.getSelectedOptions(query);
			querySearchModel.getQueryResult(query, function () {
				$('#view_searchinput').val(query);
				self.render();
			});
		},
		render : function () {
			var self = this;
			if (self.renderEmpty()) {
				return ;
			}

			$('#view_result_condition_second').hide();
			historyQueryModel.saveHistoryData(self.query);
			
			var result = querySearchModel.get('result');
			var qid = result.qid;
			var token = result.token;
			var total = result.total;
			var page = 1;
			var conditionNumStr = '选出结果:<span class="cbla">'+total+'</span>个';
			self.pageSize = 10;

			$('#view_result_condition_create').show();
			$("#view_select_choose").show();
			if (qid !== '' && token !== '') {
				$('#view_result_condition_second').show();
				self.pageSize = 6;
				conditionNumStr += ',超出300个限定,继续优化 ↓';
				secondSearchView.request(qid, token, self.query);
				$(".result-table").height('317px');
				$("#div_headfixed").addClass("table-headfixed-second");
			} else {
				$(".result-table").height('355px');
				$("#div_headfixed").removeClass("table-headfixed-second");
			}
			if ($('.view_second_option.selected').length >= 1) {
				$('#view_result_condition_second').show();
				self.pageSize = 6;
				$(".result-table").height('317px');
				$("#div_headfixed").addClass("table-headfixed-second");
			}

			$('#view_result_condition_num').html(conditionNumStr);
			self.renderData(page);
			$('#operate').show();
			self.$el.show();
			$('.result-table').scrollTop(0);
		},
		renderData : function (page) {
			var self = this;
			var result = querySearchModel.get('result');
			var num = (page - 1) * self.pageSize + 1;
			var selectedCodeList = codelistModel.getCodeList();
			var html = [];
			for (var i in result.data) {
				var isSelected = false;
				if (1 === selectedCodeList[result.data[i]['code']]) {
					isSelected = true;
				}
				var zdfStr = '';
				if(result.data[i]['zhangdiefu'] === '--'){
					zdfStr = '<td class="green">--</td>';
				}else {
					zdfStr = '<td class="'+(result.data[i]['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+result.data[i]['zhangdiefu']+'%</td>';
				}
				var row = [
					'<tr view_click_stat="cop_581208fa_505" class="data-stock '+(isSelected ? 'data-stock-select' : '')+(num % 2 == 0 ? 'bggray':'')+' '+'" ',
					'data-index="'+num+'" data-stock="'+result.data[i]['code']+'" ',
					'view_dbl_query_search="'+result.data[i]['code']+'">',
					'<td style=" text-align: right;"><input type="checkbox" class="selectAll selectRows" '+(isSelected ? 'checked' : '')+' value_code="'+result.data[i]['code']+'"></td>',
					'<td>'+num+'</td>',
					'<td>'+result.data[i]['code']+'</td>',	
					'<td>'+result.data[i]['zqmc']+'</td>',
					zdfStr,
					'<td class="'+(result.data[i]['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+result.data[i]['newprice']+'</td>',
					'</tr>'
				];
				num++;

				html.push(row.join(''));
			}
			$('#view_result_condition_table_tbody').html(html.join(''));
		},
		renderEmpty : function () {
			var errorCode = querySearchModel.get('errorcode');
			var result = querySearchModel.get('result');
			// alert(JSON.stringify(result));
			var isSecond = false;

			if ($('.view_second_option.selected').length >= 1) {
				isSecond = true;
			}
			if (errorCode !== 0 || result === '' || undefined === result.data || result.data.length <= 0) {
				if (isSecond) {
					$('#view_result_condition_num').html('选出结果:<span class="cbla">0</span>个');
					$('#view_result_condition_table_tbody').html('<tr><td colspan="4">筛选结果为空</tr>');
					this.$el.show();
					return true;
				}

				$('#view_result_condition').hide();
				$('#noResultView').show();
				$('#defaultView').show();
				$('#view_result_condition_create').show();
				$('#view_result_condition_num').html('选出结果:<span class="cbla">0</span>个');
				$('#operate').show();
				return true;
			}
			return false;
		},
		hideEl : function () {
			this.$el.hide();
		},
		jumpClientMLine : function (e) {
			e = e || window.event;
			var code = $(e.currentTarget).attr('view_dbl_query_search');
			var stockList = querySearchModel.getQueryResultStr('|');
			clientJump.jumpClientStockPage(379, code, stockList);
		},
		//股票列表排序
		stockSort : function(e) {
			var self = this;
			e = e ||window.event;
			var $dom = $(e.currentTarget);
			var type = $dom.attr("type");	//asc||desc
			var field = $dom.attr("field");
			var result = querySearchModel.get("result");
			var data = querySearchModel.sortData(field, type, result.data, 1);

			self.renderData(1, data);
			$(".sort").each(function(){
				$(this).html("");
			});
			if (type === 'asc') {
				$dom.attr("type", "desc");
				$dom.find(".sort").html("↑");
			} else {
				$dom.attr("type", "asc");
				$dom.find(".sort").html("↓");
			}
		}
	});
	module.exports = new QuerySearchView();
});
//@charset "utf-8";
//选股数据
define("C:/gulp/customplates/js/static/views/stocksearch.js" ,["backbone","_","C:/gulp/customplates/js/static/lib/clientjump.js","C:/gulp/customplates/js/static/models/stocksearch.js","C:/gulp/customplates/js/static/models/codelist.js"], function(require , exports , module){
	var Backbone = require('backbone');
	var _ = require('_');

	var clientJump = require("C:/gulp/customplates/js/static/lib/clientjump.js");

	var stockSearchModel = require("C:/gulp/customplates/js/static/models/stocksearch.js");
	var codelistModel = require("C:/gulp/customplates/js/static/models/codelist.js");

	var StockSearchView = Backbone.View.extend({
		el: '#resultStockView',
		initialize: function() {
			//
		},
		events : {
			'click .view_td_sort' : 'stockSort',
			'dblclick [view_dbl_stock_search]' : 'jumpClientMLine'
		},
		pageSize : 5000,
		request : function (stockCode) {
			$('#noResultView').hide();
			$('#resultStockView').hide();

			var self = this;
			codelistModel.clearCodeList();
			stockSearchModel.getStockList(stockCode, function () {
				self.render();
			});
		},
		render : function () {
			var self = this;
			var page = 1;

			var result = stockSearchModel.get('result');
			var total = result.total;
			var code = result.code;
			var block = result.block;
			var isSelected = false;
			isSelected = true;
			
			var zdfStr = '';
			if(code['zhangdiefu'] === '--'){
				zdfStr = '<td class="green">--</td>';
			}else {
				zdfStr = '<td class="'+(code['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+code['zhangdiefu']+'%</td>';
			}
			var codeHtml = [
				'<tr view_click_stat="cop_581208fa_505" class="data-stock '+(isSelected ? 'data-stock-select' : '')+'" data-index="0" data-stock="'+code['code']+'" ',
				'view_dbl_stock_search="'+code['code']+'">',
				'<td style=" text-align: right;"><input type="checkbox" class="selectAll selectRows" '+(isSelected ? 'checked' : '')+' value_code="'+code['code']+'"></td>',
				'<td>00</td>',
				'<td>'+code['code']+'</td>',	
				'<td>'+code['zqmc']+'</td>',
				zdfStr,
				'<td class="'+(code['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+code['new']+'</td>',
				'</tr>'
			];
			$('#view_result_condition_create').hide();
			$('#view_result_condition_num').html("选出结果：1个");
			$('#view_cur_stock').html(codeHtml.join(''));
			$('#view_cur_block').html(block['zqmc']+"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"+total+"只股票");
			$("#resultStockView").height(390);
			self.renderData(page);

			$('#operate').show();
			$('#resultStockView').show();
			$("#view_select_choose_name").removeClass("add-plate-lock");
			$('.result-table').scrollTop(0);
		},
		renderData : function (page) {
			var self = this;
			var result = stockSearchModel.get('result');

			var codelist = result.codelist;
			var pageData = stockSearchModel.getPageData(page, self.pageSize, codelist);

			var num = (page - 1) * self.pageSize + 1;
			var html = [];
			for (var i in pageData.data) {
				var isSelected = false;
				var zdfStr = '';
				if(pageData.data[i]['zhangdiefu'] === '--'){
					zdfStr = '<td class="green">--</td>';
				}else {
					zdfStr = '<td class="'+(pageData.data[i]['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+pageData.data[i]['zhangdiefu']+'%</td>';
				}
				var row = [
					'<tr view_click_stat="cop_581208fa_505" class="data-stock '+(isSelected ? 'data-stock-select' : '')+(num % 2 == 0 ? 'bggray':'')+'" ',
					'data-index="'+num+'" data-stock="'+pageData.data[i]['code']+'" ',
					'view_dbl_stock_search="'+pageData.data[i]['code']+'">',
					'<td style=" text-align: right;"><input type="checkbox" class="selectAll selectRows"></td>',
					'<td>'+(num < 10 ? '0'+num : num)+'</td>',
					'<td>'+pageData.data[i]['code']+'</td>',	
					'<td>'+pageData.data[i]['zqmc']+'</td>',
					zdfStr,
					'<td class="'+(pageData.data[i]['zhangdiefu'] > 0 ? 'red' : 'green')+'">'+pageData.data[i]['newprice']+'</td>',
					'</tr>'
				];
				num++;

				html.push(row.join(''));
			}

			$('#view_code_list').html(html.join(''));
		},
		hideEl : function () {
			this.$el.hide();
		},
		jumpClientMLine : function (e) {
			e = e || window.event;
			var code = $(e.currentTarget).attr('view_dbl_stock_search');
			var stockList = stockSearchModel.getStockListStr('|');
			clientJump.jumpClientStockPage(379, code, stockList);
		},
		//股票列表排序
		stockSort : function(e) {
			var self = this;
			e = e ||window.event;
			var $dom = $(e.currentTarget);
			var type = $dom.attr("type");	//asc||desc
			var field = $dom.attr("field");
			var result = stockSearchModel.get("result");
			var data = stockSearchModel.sortData(field, type, result.codelist, 1);

			self.renderData(1, data);
			$(".sort").each(function(){
				$(this).html("");
			});
			if (type === 'asc') {
				$dom.attr("type", "desc");
				$dom.find(".sort").html("↑");
			} else {
				$dom.attr("type", "asc");
				$dom.find(".sort").html("↓");
			}
		}
	});
	module.exports = new StockSearchView();
});
//@charset "utf-8";
//选股数据
define("C:/gulp/customplates/js/static/views/relationquery.js" ,["backbone","C:/gulp/customplates/js/static/models/relationquery.js"], function(require , exports , module){
	var Backbone = require('backbone');
	var relationQueryModel = require("C:/gulp/customplates/js/static/models/relationquery.js");

	var RelationQueryView = Backbone.View.extend({
		el: '#view_search_options_relation',
		initialize: function() {
			//
		},
		events : {
			'click .view_relation_query_item' : 'changeSearchInput',
			'mouseenter .view_relation_query_item' : 'addActiveClass'
		},
		request : function (query) {
			var self = this;
			relationQueryModel.getRelationQuery(query, function () {
				var relationQueryList = relationQueryModel.get('result');
				self.render(relationQueryList);
			});
		},
		render : function (relationQueryList) {
			if (relationQueryList.length <= 0) {
				this.$el.hide();

				return ;
			}

			var html = [];
			var index = 1;
			for (var i in relationQueryList) {
				var relationQueryItem = relationQueryList[i];
				html.push('<a href="###" view_click_stat="cop_58120ab6_458" class="search-option view_relation_query_item">'+relationQueryItem+'</a>');

				if (index++ >= 3) {
					break;
				}
			}

			this.$el.html(html.join(''));
			this.$el.show();
		},
		changeSearchInput : function (e) {
			e = e || window.event;
			var str = $(e.currentTarget).text();
			$('#view_searchinput').val(str);
			this.$el.hide();

			$('#view_searchbtn').click();
		},
		addActiveClass : function (e) {
			e = e || window.event;
			if ($(e.currentTarget).hasClass('active')) {
				return ;
			}

			$('.active.view_relation_query_item').removeClass('active');
			$(e.currentTarget).addClass('active');
		},
		hideEl : function () {
			this.$el.hide();
		}
	});

	module.exports = new RelationQueryView();
});
//@charset "utf-8";
// 热门问句
define("C:/gulp/customplates/js/static/models/hotquery.js" ,["C:/gulp/customplates/js/static/models/ajaxbase.js"], function(require , exports , module){
	var BaseModel = require("C:/gulp/customplates/js/static/models/ajaxbase.js");
	var HotQueryModel = BaseModel.extend({
		url:'http://zx.10jqka.com.cn/i/index/index/app/8/',
		dataparse : function (result) {
			if (result.errorcode >= 0) {
				return result['result'];
			}
		}
	});
  
	module.exports = new HotQueryModel();
});

//@charset "utf-8";
// 搜索历史
define("C:/gulp/customplates/js/static/models/historyquery.js" ,["C:/gulp/customplates/js/static/models/clientbase.js"], function(require , exports , module){
	var ClientBaseModel = require("C:/gulp/customplates/js/static/models/clientbase.js");
	var HistoryModel = ClientBaseModel.extend({
		file : 'historyquery.log',
		saveHistoryData : function (query) {
			var onceHistoryQueryList = this.getData();
			var nowHistoryQueryList = [];

			nowHistoryQueryList.push(query);

			if (false !== onceHistoryQueryList) {
				var index = 1;
				for (var i in onceHistoryQueryList) {
					var onceHistoryQueryItem = onceHistoryQueryList[i];
					if (onceHistoryQueryItem === query) {
						continue;
					}
					if (index++ >= 6) {
						break;
					}
					
					nowHistoryQueryList.push(onceHistoryQueryItem);
				}
			}

			this.saveData(nowHistoryQueryList);
		}
	});
  
	module.exports = new HistoryModel();
});

//@charset "utf-8";
//选股 - 数据
define("C:/gulp/customplates/js/static/models/stocksearch.js" ,["C:/gulp/customplates/js/static/models/clientbase.js","C:/gulp/customplates/js/static/lib/clientquote.js","C:/gulp/customplates/js/static/models/ajaxbase.js"], function(require , exports , module){
	var ClientBaseModel = require("C:/gulp/customplates/js/static/models/clientbase.js");
	var clientQuote = require("C:/gulp/customplates/js/static/lib/clientquote.js");
	var AjaxBaseModel = require("C:/gulp/customplates/js/static/models/ajaxbase.js");
	var ajaxBaseModel = new AjaxBaseModel();

	var thsUtil = null;
	try {
		thsUtil = external.createObject('Util');
	} catch(e) {
		//alert(e.message);
	}
	var StockSearchModel = ClientBaseModel.extend({
		getStockListStr : function (tag) {
			var result = this.get('result');
			var codeList = [];
			codeList.push(result['code']['code']);
			$.each(result.codelist, function (i, item) {
				codeList.push(item['code']);
			});

			return codeList.join(tag);
		},
		getStockList : function (stockCode, callback) {
			var self = this;
			if (null === thsUtil) {
				self.set('result', {
					'block' : {
						'code' : '--',
						'zqmc' : '--'
					},
					'code' : {
						'code' : stockCode,
						'zqmc' : '--',
						'zhangdiefu' : '--',
						'new' : '--'
					},
					'codelist' : [],
					'total' : 0
				});

				callback();
			}
			var blockList = thsUtil.getStockConceptBlock(stockCode);
			
			var param = {
				code : blockList,
				type : 'new,zhangdiefu,zqmc'
			};

			var quoteCallback = function (res) {
				var maxZhangdiefu = null;
				var maxZhangdiefuBlock = null;

				for (var i in res) {
					if (null === maxZhangdiefuBlock) {
						maxZhangdiefu = res[i]['zhangdiefu'];
						maxZhangdiefuBlock = i;
						continue;
					}
					if (res[i]['zhangdiefu'] > maxZhangdiefu) {
						maxZhangdiefu = res[i]['zhangdiefu'];
						maxZhangdiefuBlock = i;
					}
				}

				var allCodeList = thsUtil.getBlockStockByCode(maxZhangdiefuBlock);
				
				allCodeList = allCodeList.split(',');
				var needCodeList = [];
				for (var j in allCodeList) {
					if (stockCode === allCodeList[j]) {
						continue;
					}
					needCodeList.push({
						'code' : allCodeList[j],
						'zqmc' : '--',
						'zhangdiefu' : '--',
						'new' : '--'
					});
				}

				self.set('result', {
					'block' : {
						'code' : maxZhangdiefuBlock,
						'zqmc' : res[maxZhangdiefuBlock]['zqmc']
					},
					'code' : {
						'code' : stockCode,
						'zqmc' : '--',
						'zhangdiefu' : '--',
						'new' : '--'
					},
					'codelist' : needCodeList,
					'total' : needCodeList.length
				});

				self.fixQuoteData(allCodeList, callback);
			};

			clientQuote.getStockMinData(param, quoteCallback);
		},
		fixQuoteData : function (allCodeList, callback) {
			var self = this;
			var result = self.get('result');
			if (undefined === result.codelist || result.codelist.length <= 0) {
				callback();
				return ;
			}

			var param = {
				code : allCodeList.join(','),
				type : 'zqmc,new,zhangdiefu'
			};
			var quoteCallback = function (res) {
				try {
					result.code['zqmc'] = undefined !== res[result.code['code']]['zqmc'] ? 
						res[result.code['code']]['zqmc'] : '--';
					result.code['zhangdiefu'] = undefined !== res[result.code['code']]['zhangdiefu'] ? 
						res[result.code['code']]['zhangdiefu'] : '--';
					result.code['new'] = undefined !== res[result.code['code']]['new'] ? 
						res[result.code['code']]['new'] : '--';

					for (var j in result.codelist) {
						var sortZhangdiefu = '--';
						if (
							undefined === res[result.codelist[j]['code']]['zhangdiefu'] ||
							isNaN(res[result.codelist[j]['code']]['zhangdiefu'])
						) {
							sortZhangdiefu = '--';
						} else {
							sortZhangdiefu = parseFloat(res[result.codelist[j]['code']]['zhangdiefu']);
						}
						var newPrice = undefined !== res[result.codelist[j]['code']]['new'] ? res[result.codelist[j]['code']]['new'] : '--';
						var zhangdiefu = undefined !== res[result.codelist[j]['code']]['zhangdiefu'] ? res[result.codelist[j]['code']]['zhangdiefu'] : '--';
						result.codelist[j]['zqmc'] = undefined !== res[result.codelist[j]['code']]['zqmc'] ? 
							res[result.codelist[j]['code']]['zqmc'] : '--';
						result.codelist[j]['zhangdiefu'] = zhangdiefu == '--' ? '--' : 	parseFloat(zhangdiefu).toFixed(2);
						result.codelist[j]['newprice'] = newPrice == '--' ? '--' : parseFloat(parseFloat(newPrice).toFixed(2));
						result.codelist[j]['sortzdf'] = sortZhangdiefu;
					}
					
					result.codelist = result.codelist.sort(self.sortTableFun('sortzdf', 'desc'));
					self.set('result', result);
				} catch (e) {
					callback();
					return ;
				}
				
				callback();
			};
			clientQuote.getStockMinData(param, quoteCallback);
		},
		sortData : function(sortBy, sortWay, list, page) {
			return ajaxBaseModel.sortData(sortBy, sortWay, list, page);
		}
	});

	module.exports = new StockSearchModel();
});

// @charset "utf-8";
define("C:/gulp/customplates/js/static/models/clientbase.js" ,["backbone","C:/gulp/customplates/js/static/lib/clientdata.js"], function(require , exports , module){
	var Backbone = require('backbone');
	var clientData = require("C:/gulp/customplates/js/static/lib/clientdata.js");

	var ClientBaseModel = Backbone.Model.extend({
		filePath : '',
		file : '',
		getData : function () {
			var self = this;
			return clientData.getFileContent(('' === self.filePath ? self.file : self.filePath+'\\'+self.file));
		},
		saveData : function (data) {
			var self = this;
			var file = ('' === self.filePath ? self.file : self.filePath+'\\'+self.file);
			clientData.writeFileContent(file, data);
		},
		sortData : function (sortBy, sortWay, list, page) {
			var self = this;
			list = list.sort(self.sortTableFun(sortBy, sortWay));
			return self.getPageData(page, list);
		},
		sortTableFun : function (sortBy, srotWay) {
			var ordAlpah = (srotWay == 'asc') ? '>' : '<';
			// var sortFun = new Function('a', 'b', 'return a.' + sortBy + ordAlpah + 'b.' + sortBy + ' ? 1 : -1');
			var sortFun = new Function('a', 'b', 'if(isNaN(parseFloat(a.' + sortBy + '))){return 1;}if(isNaN(parseFloat(b.' + sortBy + '))){return -1;} return parseFloat(a.' + sortBy + ')' + ordAlpah + 'parseFloat(b.' + sortBy + ') ? 1 : -1');

			return sortFun;
		},
		getPageData : function (page, pageSize, list) {
			var index = 1;
			var pageData = [];

			for (var i in list) {
				if (page === Math.ceil(index/pageSize)) {
					pageData.push(list[i]);
				}
				if (page < Math.ceil(index/pageSize)) {
					index++;
					break;
				}
				index++;
			}

			return {
				data : pageData,
				length : list.length
			};
		},
		searchData : function (keywords, searchBy, list) {
			var result = [];
			for (var i in list) {
				if ('all' === keywords || -1 !== (''+list[i][searchBy]).indexOf(keywords)) {
					result.push(list[i]);
				}
			}

			return result;
		}
	});

	module.exports = ClientBaseModel;
});
// @charset "utf-8";
// ajax
define("C:/gulp/customplates/js/static/models/ajaxbase.js" ,["backbone"], function(require , exports , module){
	var Backbone = require('backbone');
	var AjaxBaseModel = Backbone.Model.extend({
		defaults : {
			errorcode : '',
			errormsg : '',
			result : ''
		},
		url : '',
		callback : '',
		type : 'get',
		dataType : 'json',
		dataparse : '',

		request : function (data) {
			var self = this;
			data = data || {};
			self._request(data, self.url, self.callback);
		},
		requestEx : function (data, url, callback) {
			var self = this;
			data = data || {};
			self._request(data, url, callback);
		},
		_request : function (data, url, callback) {
			$.support.cors = true;
			var self = this;

			$.ajax({
				url : url,
				data : data,
				type : self.type,
				dataType : self.dataType,
				success : function (result) {
					if ('' !== self.dataparse) {
						result = self.dataparse(result);
					}
					self.set(result);
					if ('' !== callback) {
						callback(result);
					}
				},
				error : function () {
					self.set({
						errorcode : -777,
						errormsg : '请求失败，请稍后再试',
						result : ''
					});
					if ('' !== callback) {
						callback();
					}
				}
			});
		},
		sortData : function (sortBy, sortWay, list, page) {
			var self = this;
			list = list.sort(self.sortTableFun(sortBy, sortWay));
			return self.getPageData(page, 4000, list);
		},
		sortTableFun : function (sortBy, srotWay) {
			var ordAlpah = (srotWay == 'asc') ? '>' : '<';
			// var sortFun = new Function('a', 'b', 'return a.' + sortBy + ordAlpah + 'b.' + sortBy + ' ? 1 : -1');
			var sortFun = new Function('a', 'b', 'if(isNaN(parseFloat(a.' + sortBy + '))){return 1;}if(isNaN(parseFloat(b.' + sortBy + '))){return -1;} return parseFloat(a.' + sortBy + ')' + ordAlpah + 'parseFloat(b.' + sortBy + ') ? 1 : -1');
			return sortFun;
		},
		getPageData : function (page, pageSize, list) {
			var index = 1;
			var pageData = [];

			for (var i in list) {
				if (page === Math.ceil(index/pageSize)) {
					pageData.push(list[i]);
				}
				if (page < Math.ceil(index/pageSize)) {
					index++;
					break;
				}
				index++;
			}

			return {
				data : pageData,
				length : list.length
			};
		},
		searchData : function (keywords, searchBy, list) {
			var result = [];
			for (var i in list) {
				if ('all' === keywords || -1 !== (''+list[i][searchBy]).indexOf(keywords)) {
					result.push(list[i]);
				}
			}

			return result;
		}
	});

	module.exports = AjaxBaseModel;
});
// @charset "utf-8";
/**
 * 请求行情数据类
 */
define("C:/gulp/customplates/js/static/lib/clientquote.js" ,["C:/gulp/customplates/js/static/lib/time.js"], function(require , exports , module){
	var Time = require("C:/gulp/customplates/js/static/lib/time.js");

	var gHexinApiQuote = '';
	try {
		gHexinApiQuote = external.createObject('Quote');
	} catch (exp) {
		//
	}

	var ClientQuote = function () {
		this.request = function (params, callback) {
			var self = this;
			var req = params;
			req.onready = function() {
				if (16384 == params.period) {
					self.dayResponse(params, callback);
				}

				if (12288 === params.period) {

					self.minLineResponse(params, callback);
				}
				if (0 === params.period) {
					self.minResponse(params, callback);
				}
			};

			try {
				gHexinApiQuote.request(req);
			} catch (exp) {
				//alert(exp.message);
				return;
			}
		};
		this.dayResponse = function (params, callback) {
			var self = this;

			var dataType = params.type.split(',');
			var result = {};


			for (var date = params.begin; date <= params.end; date++) {
				if (date % 100 > 31) {
					continue;
				}
				var row = {};
				for (var type in dataType) {
					if (isNaN(type)) {
						continue;
					}
					var ret = {
						code : params.code,
						type : dataType[type],
						period : params.period,
						time : date
					};

					try {
						var data = gHexinApiQuote.getData(ret);
						if('({})' == data){
							row = false;
							continue;
						}
						data = eval(data);

						if (self.isStringType(ret.type)) {
							row[ret.type] = data[ret.code][ret.type];
						} else {
							if (isNaN(data[ret.code][ret.type])) {
								row[ret.type] = '--';
								continue;
							}
							row[ret.type] = parseFloat(data[ret.code][ret.type]).toFixed(2);
						}
					} catch (exp) {
						continue;
					}
				}

				if (false !== row) {
					result[date] = row;
				}
			}
			callback(result);
		};
		this.minResponse = function (params, callback) {
			var self = this;
			var dataType = params.type.split(',');
			var result = {};

			for (var type in dataType) {
				if (isNaN(type)) {
					continue;
				}
				var ret = {
					code : params.code,
					type : dataType[type]
				};

				try {
					var data = gHexinApiQuote.getData(ret);
					data = eval(data);
					for (var i in data) {
						if (undefined === result[i]) {
							result[i] = {};
						}

						if (self.isStringType(ret.type)) {
							result[i][ret.type] = data[i][ret.type];
						} else {
							if (isNaN(data[i][ret.type])) {
								result[i][ret.type] = '--';
								continue;
							}
							result[i][ret.type] = parseFloat(data[i][ret.type]).toFixed(2);
						}
					}
				} catch (exp) {
					continue;
				}
			}
			callback(result);
		};
		this.minLineResponse = function (params, callback) {
			var result = {};
			var dateDay = params.dateDay;
			var timeArr = [];
			var time = new Time();
			for (var i = 9; i <= 15; i++) {
				if (i === 12) {
					continue;
				}
				var hour = i+'';
				if (i <= 9) {
					hour = '0'+i;
				}

				for (var j = 0; j <= 59; j++) {
					if (i === 9 && j <= 29) {
						continue;
					}
					if (i === 11 && j > 30) {
						continue;
					}
					if (i === 15 && j > 0) {
						continue;
					}
					if (j % 5 !== 0) {
						continue;
					}
					var min = j;
					if (j <= 9) {
						min = '0'+j;
					}
					timeArr.push(time.formatDateTime(dateDay+' '+hour+':'+min, 12288));

				}
			}

			var dataType = [];
			var preTime = '';
			for (var m in timeArr) {
				if (undefined === result[timeArr[m]]) {
					result[timeArr[m]] = {};
				}

				dataType = params.type.split(',');
				for (var type in dataType) {
					var ret = {
						code : params.code,
						type : dataType[type],
						mode : 'beforecalclast',
						period : 12288,
						time : timeArr[m]
					};

					var data = gHexinApiQuote.getData(ret);
					data = eval(data);
					if (undefined === data[params.code]) {
						continue;
					}

					if (dataType[type]  === 'close') {
						if (preTime === data[params.code]['time']) {
							result[timeArr[m]][dataType[type]] = null;
							break;
						} else {
							preTime = data[params.code]['time'];
						}
					}

					result[timeArr[m]][dataType[type]] = data[params.code][dataType[type]];
				}
			}

			var chartData = [];
			var chartRes = {};
			var step = 0;
			var closeSubPre = 0;
			for (var a in timeArr) {
				if (undefined === chartRes['pre']) {
					chartRes['pre'] = parseFloat(result[timeArr[a]]['pre']);
				}

				var close = result[timeArr[a]]['close'] === null ? null : parseFloat(result[timeArr[a]]['close']);
				if (close === null) {
					continue;
				}
				closeSubPre = Math.abs(close-chartRes['pre']);
				if (0 === step) {
					step = closeSubPre;
				}
				if (closeSubPre > step) {
					step = closeSubPre;
				}
				chartData.push(close);
			}

			chartRes['step'] = step;
			chartRes['chartData'] = chartData;
			callback(chartRes);
		};
		this.getStockDayData = function (params, callback) {
			params.period = 16384;
			this.request(params, callback);
		};
		this.getStockMinData = function (params, callback) {
			params.period = 0;
			this.request(params, callback);
		};
		this.formatForCandlestick = function (OHLCData) {
			var result = [];

			for (var date in OHLCData) {
				if (isNaN(date)) {
					continue;
				}
				var row = [];

				var time = date.replace(/(\d{4})(\d{2})(\d{2})/, '$1/$2/$3');
				row.push(Date.parse(time));

				for (var type in OHLCData[date]) {
					if (undefined === OHLCData[date][type]) {
						continue;
					}
					row.push(parseFloat(OHLCData[date][type]));
				}
				result.push(row);
			}

			return result;
		};
		this.isStringType = function (type) {
			if ('zqmc' == type) {
				return true;
			}
			if ('industry' == type) {
				return true;
			}

			return;
		};
	};

	module.exports = new ClientQuote();
});
// @charset "utf-8";
/**
 * 客户端跳转类
 */
define("C:/gulp/customplates/js/static/lib/clientjump.js" ,[], function(require , exports , module){
	var gHexinApiQuote = '';
	try {
		gHexinApiQuote = external.createObject('Quote');
	} catch (exp) {
		//
	}

	var ClientJump = function () {
		this.jumpClientStockPage = function (pid, code, stockList) {
			try {
				if ('' === gHexinApiQuote) {
					return;
				}

				gHexinApiQuote.syncStockList({
					'id' : pid,
					'code' : code,
					'period' : "16384",
					'stocklist' : stockList
				});
			} catch (e) {
				alert(e.message);
			}
		};
	};

	module.exports = new ClientJump();
});
//@charset "utf-8";
//问句   超过300条
define("C:/gulp/customplates/js/static/views/secondsearch.js" ,["backbone","C:/gulp/customplates/js/static/models/secondsearch.js"], function(require , exports , module){
	var Backbone = require('backbone');

	var secondSearchModel = require("C:/gulp/customplates/js/static/models/secondsearch.js");

	var SecondSearchView = Backbone.View.extend({
		el : '#view_result_condition_second',
		query : '',
		initialize : function() {
			//
		},
		events : {
			'click .view_second_option' : 'changeSecondOption'
		},
		querySearchView : null,
		request : function (qid, token, query) {
			this.query = query;
			var self  = this;
			secondSearchModel.getConditionList(qid, token, query, function () {
				self.render();
			});
		},
		render : function () {
			var errorCode = secondSearchModel.get('errorcode');
			
			if (errorCode === 0) {
				var result = secondSearchModel.get('result');
				var html = ['<div class="condition-arrow"></div>'];
				var index = 1;
				for (var i in result) {
					var name = i;
					var data = [];
					for (var j in result[i]) {
						data.push(result[i][j][0]);
					}

					var row = [
						'<div class="condition">'+
						'<span class="condition-title">'+name+'：</span>'
					];
					var inIndex = 1;
					
					for (var h in data) {
						row.push('<span class="keyword view_second_option" title="'+data[h]+'">'+data[h]+'</span>');
						if (inIndex++ >= 3) {
							break;
						}
					}
					row.push('</div>');
					html.push(row.join(''));
					if (index++ >= 3) {
						break;
					}
				}
				this.$el.html(html.join('')).show();
			}
		},
		changeSecondOption : function (e) {
			TA.log({id : '57909949_314'});
			e = e || window.event;
			var $currDom = $(e.currentTarget);
			if ($currDom.hasClass('selected')) {
				$currDom.removeClass('selected');
				this.querySearchView.request(this.query);
				return ;
			}

			// $currDom.parent().find('.selected').removeClass('selected');
			$currDom.addClass('selected');
			
			this.querySearchView.request(this.query);
		},
		getSelectedOptions : function (query) {
			var secondList = [];
			secondList.push(query);
			$('.view_second_option.selected').each(function () {
				secondList.push($(this).html());
			});
			return secondList.join('，');
		}
	});

	module.exports = new SecondSearchView;
});
//@charset "utf-8";
// 问句 - 搜索
define("C:/gulp/customplates/js/static/models/relationquery.js" ,["C:/gulp/customplates/js/static/models/ajaxbase.js"], function(require , exports , module){	
	var AjaxBaseModel = require("C:/gulp/customplates/js/static/models/ajaxbase.js");
	var RelationQueryModel = AjaxBaseModel.extend({
		url : 'http://zx.10jqka.com.cn/i/index/index/app/7/',
		query : '',
		getRelationQuery : function (query, callback) {
			var self = this;
			self.callback = callback;

			if (query === self.query) {
				callback();
				return ;
			}
			self.query = query;
			self.request({
				q : query
			});
		}
	});

	module.exports = new RelationQueryModel();
});

// @charset "utf-8";
define("C:/gulp/customplates/js/static/lib/clientdata.js" ,[], function(require , exports , module){
	var userPath = null;
	var thsPath = null;
	var fis = null;
	var fos = null;
	try {
		userPath = external.getUserPath();
		thsPath = userPath+'ths_customplates\\';
		fis = external.createObject('FileInputStream');
		fos = external.createObject('FileOutputStream');
	} catch (exp) {
		//
	}

	var ClientData = function () {
		this.getFileContent = function (file) {
			if (null === fis) {
				return false;
			}
			var str = false;
			if (fis.open(thsPath+file)) {
				try {
					str = fis.readDes();
				} catch (exp) {
					//
				}

				fis.close();
			}

			if (false === str || '' === str) {
				return false;
			}

			return eval('('+str+')');
		};
		this.writeFileContent = function (file, jsonObj) {
			var str = '';
			if (null === fos) {
				return false;
			}

			if (fos.open(thsPath+file)) {
				try {
					str = fos.writeDes(JSON.stringify(jsonObj));
				} catch (exp) {
					//alert(exp.message);
				}

				fos.close();
			}
		};
	};

	module.exports = new ClientData();
});


//@charset "utf-8";
/**
 * 取客户端数据会用到的一些时间处理函数
 */
 define("C:/gulp/customplates/js/static/lib/time.js" ,[], function(require , exports , module){
	var Period = {};
	Period.REAL_TIME = 0;
	Period.CLOSING_DETAILS = 4096;
	Period.MINUTE_TENDENCY = 8192;
	Period.ONE_MINUTE = 12289;
	Period.FIVE_MINUTES = 12293;
	Period.FIFTEEN_MINUTES = 12303;
	Period.THIRTY_MINUTES = 12318;
	Period.ONE_HOUR = 12348;
	Period.DAY = 16384;
	Period.WEEK = 20480;
	Period.MONTH = 24576;
	Period.YEAR = 28672;

	Period.getName = function (period) {
		period = parseInt(period);
		switch (period) {
			case Period.REAL_TIME :
				return '实时';
			case Period.CLOSING_DETAILS :
				return '成交明细';	
			case Period.MINUTE_TENDENCY :
				return '分钟走势';
			case Period.ONE_MINUTE :
				return '1分钟线';
			case Period.FIVE_MINUTES :
				return '5分钟线';
			case Period.FIFTEEN_MINUTES :
				return '15分钟线';
			case Period.THIRTY_MINUTES :
				return '30分钟线';
			case Period.ONE_HOUR :
				return '60分钟线';
			case Period.DAY :
				return '日线';
			case Period.WEEK :
				return '周线';
			case Period.MONTH :
				return '月线';
			case Period.YEAR :
				return '年线';
		}
	};
	var Time = function () {};

	/**
	 * 格式化"datetime"参数
	 * 分钟周期的时间格式，因为长度范围的原因，采用了特殊的位运算
	 * 
	 * @param 	Integer|String	time	20121010|201210101130|2012-11-20 11:30
	 * @param 	Integer|String	period	16384|12348
	 * @return	String	20121010|118117086
	 */
	Time.prototype.formatDateTime = function (time, period) {
		period = period || Period.DAY;
		var timeStr = String(time);
		var formatedTime = false;
		if (Period.REAL_TIME <= period && Period.CLOSING_DETAILS >= period) {
			// TO DO
		} else if (Period.MINUTE_TENDENCY <= period && Period.ONE_HOUR >= period) {
			var minute, hour, day, month, year;
			timeStr = timeStr.replace(/(-|:|\s)/g, '');
			year = parseInt(timeStr.substr(0, 4), 10);
			month = parseInt(timeStr.substr(4, 2), 10);
			day = parseInt(timeStr.substr(6, 2), 10);
			hour = parseInt(timeStr.substr(8, 2), 10);
			minute = parseInt(timeStr.substr(10, 2), 10);
			year = year - 1900;
			formatedTime = (year << 20) + (month << 16) + (day << 11)  + (hour << 6) + (minute << 0);
		} else if (Period.DAY <= period) {
			return timeStr;
		}
		
		return formatedTime;
	};

	/**
	 * 解析"datetime"参数
	 * @param 	Integer|String	time	20121010|118117086
	 * @param 	Integer|String	period	16384|12348
	 * @return	String	2012-10-10|2012-10-10 11:30
	 */
	Time.prototype.parseDateTime = function (time, period, format) {
		// TO DO format操作
		period = period || Period.DAY;
		var easilyReadTime = '';
		if (Period.REAL_TIME <= period && Period.CLOSING_DETAILS >= period) {
			// TO DO
		} else if (Period.MINUTE_TENDENCY <= period && Period.ONE_HOUR >= period) {
			var year, month, day, hour, minute;
			year = time >> 20;
			time = time - (year << 20);
			month = time >> 16;
			time = time - (month << 16);
			day = time >> 11;
			time = time - (day << 11);
			hour = time >> 6;
			time = time - (hour << 6);
			minute = time >> 0;
			year += 1900;
			easilyReadTime = year + '-' + this.repair(month) + '-' + this.repair(day) + ' ' + this.repair(hour) + ':' + this.repair(minute);
		} else if (Period.DAY <= period) {
			var timeStr, day, month, year;
			timeStr = String(time);
			day = timeStr.substring(6,8);
			month = timeStr.substring(4,6);
			year = timeStr.substring(0,4);
			easilyReadTime = year + '-' + month + '-' + day;
		}
		
		return easilyReadTime;
	};

	/**
	 * 生成上一个小时时间
	 * @param String dateTime 格式为YYYYmmddHHii的时间
	 */
	Time.prototype.getPreHour = function (dateTime) {
		// 避免number类型变量调用substring方法
		dateTime += '';
		var year = dateTime.substring(0, 4);
		var month = dateTime.substring(4, 6);
		var day = dateTime.substring(6, 8);
		var hour = dateTime.substring(8, 10);
		if (hour <= 10) {
			day --;
			hour = 15;
		} else if (hour > 15) {
			hour = 15;
		} else if (hour <= 14 && hour > 11) {
			hour = 11;
		} else {
			hour --;
		}
		if (hour >= 10 && hour <= 11) {
			minute = 30;
		} else {
			minute = 0;
		}
		month = month - 1;
		dateTime = new Date(year, month, day, hour, minute);
		var strYear = dateTime.getFullYear();   
		var strDay = dateTime.getDate();   
		var strMonth = dateTime.getMonth() + 1; 
		var strHour = dateTime.getHours();
		var strMinute = dateTime.getMinutes();  
		if(strMonth < 10) {   
			strMonth = "0" + strMonth;   
		} 
		if(strDay < 10) {   
			strDay = "0" + strDay;   
		}  
		if(strHour < 10) {   
			strHour = "0" + strHour;   
		} 
		if(strMinute < 10) {   
			strMinute = "0" + strMinute;   
		}    
		var strYesterday = strYear + '' + strMonth + '' + strDay + '' + strHour + '' + strMinute;  
		return strYesterday;
	};


	/**
	 * 获取前一天的日期
	 * @param String date 日期格式为yyyymmdd
	 */
	Time.prototype.getPreDay = function (date) {
		date += '';
		var year = date.substring(0, 4);
		var month = date.substring(4, 6);
		var day = date.substring(6, 8);
		month = month - 1;
		var dateTime = new Date(year, month, day);
		var preDateTime = dateTime.getTime() - 1000 * 60 * 60 * 24;
		var preDate = new Date();
		preDate.setTime(preDateTime);    
		var strYear = preDate.getFullYear();   
		var strDay = preDate.getDate();   
		var strMonth = preDate.getMonth()+1;   
		if(strMonth < 10) {   
			strMonth = "0" + strMonth;   
		} 
		if(strDay < 10) {   
			strDay = "0" + strDay;   
		}   
		var strYesterday = strYear + '' + strMonth + '' + strDay;  
		return strYesterday;
	};

	/**
	 * 获取上一个周期的日期
	 * @param String date 日期格式为yyyymmddHHii
	 */
	Time.prototype.getPreTime = function (time, period) {
		period = period || Period.DAY;
		if (Period.REAL_TIME <= period && Period.CLOSING_DETAILS >= period) {
			// TO DO
		} else if (Period.MINUTE_TENDENCY <= period && Period.ONE_HOUR >= period) {
			return this.getPreHour(time);
		} else if (Period.DAY <= period) {
			return this.getPreDay(time);
		}
	};

	Time.prototype.repair = function (val) {
		if (val < 10) {
			val = '0' + val;
		}
		return val;
	};

	/**
	 * 反转日期
	 * @param 	Integer|String	time	20121010|118117086
	 * @param 	Integer|String	period	Period.DAY|Period.ONE_HOUR
	 * @return	String	2012-10-10|2012-10-10 11:30
	 */
	Time.prototype.simplify = function (time, period) {
		period = period || Period.DAY;
		var easilyReadTime = '';
		if (Period.REAL_TIME <= period && Period.CLOSING_DETAILS >= period) {
			// TO DO
		} else if (Period.MINUTE_TENDENCY <= period && Period.ONE_HOUR >= period) {
			var year, month, day, hour, minute;
			year = time >> 20;
			time = time - (year << 20);
			month = time >> 16;
			time = time - (month << 16);
			day = time >> 11;
			time = time - (day << 11);
			hour = time >> 6;
			time = time - (hour << 6);
			minute = time >> 0;
			year += 1900;
			easilyReadTime = year + '-' + this.repair(month) + '-' + this.repair(day) + ' ' + this.repair(hour) + ':' + this.repair(minute);
		} else if (Period.DAY <= period) {
			var timeStr, day, month, year;
			timeStr = String(time);
			day = timeStr.substring(6,8);
			month = timeStr.substring(4,6);
			year = timeStr.substring(0,4);
			easilyReadTime = year + '-' + month + '-' + day;
		}
		
		return easilyReadTime;
	};

	module.exports = Time;
});
//@charset "utf-8";
// 问句-二次搜索数据
define("C:/gulp/customplates/js/static/models/secondsearch.js" ,["C:/gulp/customplates/js/static/models/ajaxbase.js"], function(require , exports , module){	
	var AjaxBaseModel = require("C:/gulp/customplates/js/static/models/ajaxbase.js");

	var SecondSearchModel = AjaxBaseModel.extend({
		url : 'http://zx.10jqka.com.cn/i/index/index/app/6/',
		getConditionList : function (qid, token, query, callback) {
			var self = this;

			self.callback = callback;
			self.request({
				qid : qid,
				token : token,
				q : query
			});
		}
	});
  
	module.exports = new SecondSearchModel();
});

