/**
 * 标的UI
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2014-05-08
 */
var Symbol = Panel.extend({
	// 期权Panel对象
	option: null,
	// 标的选择器
	symbolCls: null,
	/*
	 * 渲染标的
	 * @param symbols Array 接口返回的
	 */
	renderSymbol: function(ss){
		var html = [];
		for(var i=0; i<ss.length; i++){
			var item = ss[i];
			html.push('<option value="', item.code, '" market="', item.market, '" isetf="', item.isetf, '">', item.name, '</option>');
		}
		$(this.baseCls).find('select').html(html.join(''));
		if(ss.length>0){
			this.option = new Option
			({
				code: ss[0].code,
				market: ss[0].market,
				isetf: ss[0].isetf,
				baseCls: '.boxtable',
				addCls: '.addoption',
				delCls: '.ictrash',
				delsCls: '.dels',
				optionsCls: '#options',
				stockCls: '#stockoption',
				nowCls: '#stocknow',
				actckCls: '.actck',
				dealCls: '.deal',
				qtyCls: '.qty',
				qqtyCls: '.qqty', //update
				priCls: '.pri',
				dateCls: '.expiry',
				strikeCls: '.strike',
				cpCls: '.cp',
				totalCls: '#total',
				portfolioCls: '#portfolio'
			});
			// alert($.toJSON(this.option));
		}
	},
	
	_bindEvent: function(){
		var me = this;
		// 切换买卖背景
		$(this.baseCls).on('change', this.symbolCls, function(e) {
			var option = this.options[this.selectedIndex];
			// alert(option.innerHTML)
			me.option.changeCode(option.getAttribute('value'), option.getAttribute('market'), option.getAttribute('isetf'));
		});
	},
	_request: function(){
		// 获取标的代码
		var me = this;
		/*  var xml = thsOptionRisk.getInitParam();
		 // alert(xml)
	    	// log.log(xml);
		    if(Global.debug){
	    	xml = '<target_param><item market="17" code="600000" name="浦发银行" price="9.70"/><item market="17" code="600104" name="上汽集团"  /></target_param>';
		    }
		     var data = $.xml2json(xml);
	
		    this.renderSymbol([].concat(data.item || []));  */
		  var initdataready = thsOptionRisk.getInitDataReady({
			func:function(initdataready){
				//alert(initdataready)
				me.getInitCallback(initdataready);
			}
		});
		// if (initdataready){
			// me.getInitCallback(initdataready);	
		// } 
		
	},
	getInitCallback: function(initdataready){
		var num = initdataready.split('=')[1];
		var that = this;
		
		if (num==1)
		{
			$('.boxtable').unbind();
			var xml = thsOptionRisk.getInitParam();
			// alert(xml)
	    	log.log(xml);
		    if(Global.debug){
			/*
				<target_param>
					<item market="17" code="600000" name="浦发银行" price="9.70"/>
					<item market="17" code="600104" name="上汽集团"  />
				</target_param>
			*/
	    	xml = '<target_param><item market="17" code="600000" name="浦发银行" price="9.70"/><item market="17" code="600104" name="上汽集团"  /></target_param>';
		    }
		     var data = $.xml2json(xml);
			 that.renderSymbol([].concat(data.item || []));
		} 
	}
});