/**
 * IM启动文件
 * @author 卢海宁<luhaining@myhexin.com>
 * @create 2013-11-11
 */
$(document).ready(function() {
	//禁止部分特殊键
	// Alt + F4 因IE6/7/8的特殊性无法禁止，由客户端控制
	document.onmousedown = function(event) {
		event = event || window.event;
		if(event.button == 4){ //  鼠标中键 放大/缩小
			event.returnValue = false;
		}
	};
	document.onmousewheel = function(event) {
		event = event || window.event;
		if(!event.shiftKey && event.ctrlKey && !event.altKey){ //  Ctrl + 滚轮 放大/缩小
			event.returnValue = false;
		}
	};
	$(document).keydown(function(e){
		//e.stopPropagation();
		if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 70) { // Ctrl + F
			e.originalEvent.keyCode = 0; // 针对IE6/7/8阻止
			e.preventDefault();
		} else if (!e.shiftKey && !e.ctrlKey && !e.altKey && e.keyCode == 116 && !Global.F5) { // F5
			e.originalEvent.keyCode = 0;
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 116 && !Global.F5) { // Ctrl + F5
			e.originalEvent.keyCode = 0;
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 78) { // Ctrl + N
			e.preventDefault();
		} else if (!e.shiftKey && !e.ctrlKey && !e.altKey && e.keyCode == 27) { // Esc
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 187) { //  Ctrl + + 放大
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 189) { //  Ctrl + - 缩小
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 38) { //  Ctrl + ↑ 放大
			e.preventDefault();
		} else if (!e.shiftKey && e.ctrlKey && !e.altKey && e.keyCode == 40) { //  Ctrl + ↓ 缩小
			e.preventDefault();
		}
	});
	//窗体内可选元素过滤 根据class ".selectable" input和textarea不在此列
	document.onselectstart = function(){
		var tagName = (event.srcElement.tagName || event.srcElement.parentNode.tagName).toLowerCase();
		if(tagName == 'input' || tagName == 'textarea' ){
			return true;
		}
		var className = event.srcElement.className || event.srcElement.parentNode.className;
		if(className.indexOf('selectable') > -1){
			return true;
		}else{
			return false;
		}
	}
	try{
		window.thsOption = external.createObject('TradeStrategy');
	}catch(e){
		window.thsOption = {
			getInitParam: function(){},
			switchWndSize: function(){},
			getTrgateInfo: function(){},
			regOptionCallBack: function(){},
			calcTipInfo: function(){},
			calcStrategyChartData: function(){},
			callxiadan: function(){}
		};
		Global.inWeb = true; // 浏览器模式
	}
	$.support.cors = true; // 开启jQuery跨域访问
	window.log = new Log(); // 声明全局日志对象
	
	// log.open(); // 开启日志
	
	if(Global.debug){
		if(Global.inWeb){
			log = new WebLog();
		}else{ // 客户端
			log = new FileLog();
		}
		log.open();
		Global.F5 = true; // 允许F5刷新
	}
	if(Global.isIE6 && Global.inWeb){
		/*
		 * 当IE6浏览器模式运行App时
		 * 部分用户首次打开App会在网页上部显示“提示是否启用JavaScript脚本的状态栏”
		 * 占用了部分body高度，用户选择启用后，导致Layout初始化异常，延时加载可避免body计算错误
		 */
		setTimeout('app();', 10);
	}else{
		app();
	}
});
/*
 * IM启动入口函数
 */
var app = function(){
	// 控制布局（针对IE6）
	new Layout({
		config: [
			{selector: '.app', fixX:0, fixY:0 },
			{selector: '.loading', fixX:0, fixY:0 }
		]
	});
	new Symbol({
		baseCls: '.head',
		symbolCls: '#mcode',
		toggleCls: '.btn_toggle'
	});
}
