/**
 * UI面板类
 * @author: 卢海宁<luhaining@myhexin.com>
 * @create: 2013-11-29
 */
var Panel = Base.extend({
	/* 父类Panel */
	superPanel: null,
	/* 容器基类 */
	baseCls: null,
	
	init: function(cfg){
		this._super(cfg);
		// _render和_request没有必然关系，如需在请求成功后重绘界面，请自行添加function关联请求回调函数
		this._initialize(cfg);
		this._render();
		this._bindEvent();
		if(Global.isIE6){
			this._bindEvent4IE6();
		}
		this._request();
		// 当含有父面板时，为当前面板添加sub样式标致
		if(!!this.superPanel){
			$(this.baseCls).addClass('sub');
		}
	},
	//TODO 公共的初始化方法
	_initialize: function(cfg){},
	//TODO 渲染界面，也可做预处理界面
	_render: function(){},
	//TODO 绑定事件
	_bindEvent: function(){},
	//TODO 绑定事件给IE6
	_bindEvent4IE6: function(){},
	//TODO 发送请求
	_request: function(){}
});