//@charset "utf-8";
﻿/**
 * @Author 冯涛涛
 * @Data 2011.7.11
 * @Note 第三方委托页面JS
 */

var getUrlParam = function(item) {
	var value = location.search.match(new RegExp("[\?\&]" + item + "=([^\&]*)(\&?)", "i"));
	//return 'HK0001';
	return value ? value[1] : value;
};

var us = getUrlParam('us');


$(document).ready(function(){
	$('#1067').live('click', function() {
		TA.log('577f6100_252');
	});
	var _mainClass = "all",
		_topClass = "topbox",
		_middleClass = "contentbox",
		_bottomClass = "footer",
		_searchBoxClass = "searchbox",
		_fixSearchBoxClass = "fix_searchbox",
		_searchInputClass = "searchinput",
		_inputAttachClass = "searchAttach",
		_searchAttachTableClass = "st",
		_matchResultItemClass = "ml",
		_qsListClass = "qslist",
		_buttonClass = "add1",
		_buttonInvalClass = "add3",
		_buttonFrClass = "fr_ml8",
		_tipClass = "tips-yybox",
		_butConfirmClass = "add",
		_butCancelClass = "cancel",
		_itemClass = "item",
		_itemDftClass = "bn_default",
		_itemHasTipClass = "bn_default_r",
		_itemDftCurClass = "current_rd",
		_itemHasTipCurClass = "current_rd",
		_hasTipClass = "fontb",
		_topTitle = "选择开户券商:",
		_inputInitText = "拼音缩写/关键字搜索，如：海通证券/htzq/ht",
		_packInfoRequestUrl = "http://dsfwt.10jqka.com.cn/default/index/dealerpacket/?jsoncallback=?",
		_hotTipInfoRequestUrl = "http://dsfwt.10jqka.com.cn/default/index/dealerinfor/?jsoncallback=?",

		_adscript = "<script id='thsad_script_7-7' type='text/javascript'>ThsAd.create('7-7');</script>",//增加广告的
		/**
		 * @Author jinjian2@myhexin.com
		 * @var	{JSON} 券商列表数据
		 */
		_dataStore = null,
		_hexin = null,
		_loadDealerListUrl = "http://dsfwt.10jqka.com.cn/dealerlist/index2.html",
		_loadDealerListUrl2 = "http://dsfwt.10jqka.com.cn/dealerlist/rzrq.html", //融资融券委托
		_loadDealerListUrl3 = "http://dsfwt.10jqka.com.cn/dealerlist/ggmg.html", //港股美股委托
		_$input,
		_$itemCont,
		_$hotItem,
		_$hotInfoTip,
		_$confirmBtn,
		_$cancelBtn,
		_$inputSuggestTip,
		_keyWords,
		_searchResult,
		_addedList,
		_ggyyTip = [],
		_tipH,
		_midDivH,
		_sortData;

	var _inputLimitNum = 24,
		_debug = false,
		_inited = false;

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.11
	 * @Note 添加事件侦听器，包括搜索框和搜索确认按钮等
	 */
	function attachListener(){
		if(_inited)
			return;
		itemListener();
		hotInforListener();
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 搜索框侦听器，监听focus和keyup事件
	 */
	function inputListener(){
		_$input.focus(function(e){
			if(_$input.attr("value") == _inputInitText){
				_$input.addClass("inputFocus").attr("value", "");
			}
		});

		_$input.blur(function(e){
			if(_$input.attr("value") == ""){
				_$input.removeClass("inputFocus").attr("value", _inputInitText);
			}

		})

		_$input.keyup(function(e){
			if(_keyWords != _$input.attr("value")){
				_keyWords = _$input.attr("value");
				_keyWords = _keyWords.replace(/[^(\u4E00-\u9FA5a-zA-Z)]/g,'');
				updataMaxLength(_keyWords);
				_$input.attr("value", _keyWords);
				if(_keyWords && _keyWords != _inputInitText && _keyWords != ''){
					doSearch(_keyWords);
				}else{
					sortRender(_sortData);
				}

				$(getSelector4Class(_butConfirmClass)).addClass(_buttonInvalClass).removeClass(_buttonClass);
			}
		});
	}

	/**
	 * 更新输入框字数限制
	 * @param  {String} value 输入框文本
	 */
	function updataMaxLength(value){
		var valueArr = value.split('');
		var limitNum = _inputLimitNum;
		_$input.attr("maxlength", _inputLimitNum);
		for(var i in valueArr){
			if(!(("a"<=valueArr[i] && valueArr[i]<="z") || ("A"<=valueArr[i] && valueArr[i]<="Z"))){
				_$input.attr("maxlength", (--limitNum));
			}
		}

	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 广告营运信息标志侦听器，控制tip框的显示与隐藏
	 */
	function hotInforListener(){
		var t;
		_$hotItem.delegate(".bn_default_r", "mouseover", function(e){
			var that = this;
			var flag = true;
			var id = $(that).attr("id");
			for(var i in _ggyyTip){
				if(id == _ggyyTip[i].id){
					flag = false;
					var htmlArr = [];
					var tipName = getTipName(id);
					htmlArr.push(
						'<p><strong>', tipName ,'</strong>', _ggyyTip[i].infor, '</p>'
					);
					_$hotInfoTip.html(htmlArr.join(''));
				}
			};
			if(flag){
				loadGGYY(id)
			}
			var offset = $(this).offset();

			t = setTimeout(function(){
				_$hotInfoTip.attr("style", "top:" + (_midDivH + 46) + "px");
				_$hotInfoTip.show("slow");
				_tipH = $(getSelector4Class(_tipClass)).height();
				_midDivH = $(getSelector4Class(_middleClass)).height();
				if(offset.top < 160){
					_$hotInfoTip.attr("style", "top:" + (_midDivH - _tipH + 46) + "px");
				}else{
					_$hotInfoTip.attr("style", "top:67px");
				}
			}, 300);

			flag = true;
		});

		_$hotItem.delegate(".bn_default_r", "mouseout", function(e){
			if(t){
				clearTimeout(t);
			}
			_$hotInfoTip.hide();
		});

		_$hotInfoTip.mouseover(function(e){
			_$hotInfoTip.show();
		});

		_$hotInfoTip.mouseout(function(e){
			_$hotInfoTip.hide();
		});
	}

	/**
	 * 事件绑定
	 */
	function itemListener(){
		_$itemCont.delegate(getSelector4Class(_itemClass), "click", function(e){
			if(!$(this).children().hasClass(_hasTipClass)){
				$.each($(this).siblings(), function(i, obj){
					if($(obj).hasClass(_itemDftCurClass)){
						$(obj).removeClass(_itemDftCurClass);
					}else if($(obj).hasClass(_itemHasTipCurClass)){
						$(obj).removeClass(_itemHasTipCurClass);
					}
				});
				$.each($(this).parent().parent().siblings(), function(i, obj){
					$.each($(obj).children().children(), function(j, item){
						if($(item).hasClass(_itemDftCurClass)){
							$(item).removeClass(_itemDftCurClass);
						}else if($(item).hasClass(_itemHasTipCurClass)){
							$(item).removeClass(_itemHasTipCurClass);
						}
					})
				})

				$(this).hasClass(_itemHasTipClass) ? $(this).addClass(_itemHasTipCurClass) : $(this).addClass(_itemDftCurClass);
				$(getSelector4Class(_butConfirmClass)).addClass(_buttonClass).removeClass(_buttonInvalClass);
			}
		});

		_$itemCont.delegate(getSelector4Class(_itemClass), "dblclick", function(e){
			e.preventDefault();
			if(!($(this).children().hasClass(_hasTipClass))){
				requestPackInfo($(this).attr("id"));
			}
		});

		_$confirmBtn.click(function(e){
			e.preventDefault();
			var target = e.currentTarget;
			if($(".item").hasClass(_itemDftCurClass) && _$confirmBtn.hasClass("add1")){
				requestPackInfo($("." + _itemDftCurClass).attr("id"));
			}else if($(".item").hasClass(_itemHasTipCurClass) && _$confirmBtn.hasClass("add1")){
				requestPackInfo($("." + _itemHasTipCurClass).attr("id"));
			}

		})

	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 检索函数
	 * @param key 输入框的值
	 */
	function doSearch(key){
		if(_dataStore){
			var result = [];//记录正则表达式匹配结果
			var flag;//判断是否符合匹配
			var tempDataStore = _hexin.concat(_dataStore);
			parse_url = new RegExp(key,"i");
			_searchResult = [];

			$.each(tempDataStore, function(i, obj){
				$.each(obj, function(j, value){
					if(!flag){
						result = (parse_url.exec(value));
						if(result){
							flag = true;
						}
					}
				})
				if(flag){
					_searchResult.push(tempDataStore[i]);
					flag = false;
				}
			})
			render(_searchResult);
		}
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.11
	 * @params dataStore 需要渲染的数据
	 * @Note 页面渲染函数，此时的数据没有按字母分类
	 */
	function render(dataStore){
		if(!dataStore) return;
		var htmlArr = [];
		var dataNum = dataStore.length;

		$.each(dataStore, function(i, obj){
			if(i == 0){
				htmlArr.push(
					'<dd class="list_dh">',
					'<h5>&nbsp</h5>',
					'<p>',
					'<a href="#" id="', obj.qsid ,'" class="', ((obj.infor == "0") ? _itemDftClass : _itemHasTipClass),' ', _itemClass, ' ', (isAdded(obj.qsid) ? "unhover":""), '"><span class="',(isAdded(obj.qsid) ? _hasTipClass:""),'">', obj.key1, '</span></a>'
				);
			}else if(i == (dataNum - 1)){
				htmlArr.push(
					'<a href="#" id="', obj.qsid ,'" class="', ((obj.infor == "0") ? _itemDftClass : _itemHasTipClass),' ', _itemClass, ' ', (isAdded(obj.qsid) ? "unhover":""), '"><span class="',(isAdded(obj.qsid) ? _hasTipClass:""),'">', obj.key1, '</span></a></p></dd>'
				);
			}else{
				htmlArr.push(
					'<a href="#" id="', obj.qsid ,'" class="', ((obj.infor == "0") ? _itemDftClass : _itemHasTipClass),' ', _itemClass, ' ', (isAdded(obj.qsid) ? "unhover":""), '"><span class="',(isAdded(obj.qsid) ? _hasTipClass:""),'">', obj.key1, '</span></a>'
				);
			}
		});

		_$itemCont.html(htmlArr.join(''));
	}

	/**
	 * 将数据按字母分类
	 * @param  {Array} dataStore 原始数据
	 */
	function dosort(dataStore){
		_sortData = {};
		var initLetter = null;
		$.each(dataStore, function(i, obj){
			firstLetter=obj.key3.split('')[0];
			if(firstLetter != initLetter){
				initLetter = firstLetter;
				_sortData[initLetter] = [];
				_sortData[initLetter].push(obj);
			}else{
				_sortData[initLetter].push(obj);
			}
		});
		sortRender(_sortData);
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 分类渲染函数，当搜索框的值为空时调用该函数, 此时数据按字母分类
	 * @param dataStore 待渲染的数据
	 */
	function sortRender(sortData){
		var htmlArr = [];

		if(!sortData)
			return;

		if(_hexin && _hexin.length > 0){
			htmlArr.push(
				'<dd class="list_dh">',
				'<h5>其他</h5>',
				'<p>'
			);

			$.each(_hexin, function(j, item){
				htmlArr.push(
					'<a href="#" id="', item.qsid ,'" class="', (item.infor == "0" ? _itemDftClass : _itemHasTipClass), ' ', _itemClass, '"><span class="',(isAdded(item.qsid) ? _hasTipClass:""),'">', item.key1, '</span></a>'
				);
			});
			htmlArr.push(
				'</p>',
				'</dd>'
			);
		}

		$.each(sortData, function(i, obj){
			htmlArr.push(
				'<dd class="list_dh">',
				'<h5>', i.toUpperCase(), '</h5>',
				'<p>'
			);
			$.each(obj, function(j, item){
				htmlArr.push(
					'<a href="#" id="', item.qsid ,'" class="', ((item.infor == "0") ? _itemDftClass : _itemHasTipClass), ' ', _itemClass, ' ', (isAdded(item.qsid) ? "unhover":""), '"><span class="',(isAdded(item.qsid) ? _hasTipClass:""),'">', item.key1, '</span></a>'
				);
			});
			htmlArr.push(
				'</p>',
				'</dd>'
			);
		});

		_$itemCont = $(getSelector4Class(_qsListClass));
		_$itemCont.html(htmlArr.join(''));
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 搜索框字符数限制函数
	 */
	function inputLimit(num){
		_$input.attr("maxlength", num);
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 加载安装包信息并调用静默安装接口
	 * @param id 欲安装券商的id
	 */
	function requestPackInfo(id){
		if(id != undefined){
			//加载包信息
			$.getJSON(_packInfoRequestUrl,
				{
					op: "infor",
					type: "json",
					gid: id
				},
				function(data){
					packInfo = data[0];
					var installParams = {
						ID:Number(packInfo.qsid),
						INSTALLTYPE:packInfo.type,
						NAME:packInfo.name,
						DOWNLOADURL:packInfo.url,
						INSTALLKEY:packInfo.regedit,
						VERSION:packInfo.version,
						EXENAME:packInfo.setup,
						INSTALLCMD:'',
						WEITUOID:packInfo.wtid,
						XDTYPE:packInfo.xdtype
					}
					//进入安装
					if(!_debug){
						external.addUserBrokerage(installParams);
						$("." + _itemDftCurClass).removeClass(_itemDftCurClass).addClass("unhover").children().addClass(_hasTipClass);
						_addedList.push(id);
						resetConfirmBtn();
					}
				}
			);
		}
	};

	//加载广告运营信息
	function loadGGYY(id){
		$.getJSON(_hotTipInfoRequestUrl,
		{
			op: "infor",
			gid: id
		},function(data){
			_ggyyTip.push({"id": id, "infor": data[0].infor});
			tipInfor = data[0].infor;

			var htmlArr = [];
			var tipName = getTipName(id);
			htmlArr.push(
				'<p><strong>', tipName ,'</strong>', tipInfor, '</p>'
			);
			_$hotInfoTip.html(htmlArr.join(''));
		});
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note html框架的生成函数
	 */
	function generateBody(){
		var bodyHtmlArr = [];
		if (us == 1){
			bodyHtmlArr.push(
			'<div class="', _mainClass, '">',
				'<div class="', _topClass, '">',
					'<div class="ui-tab-wrap">',
						'<a href="###" class="bg2"><i class="bg2"></i>普通委托</a>',
						'<a href="###" class="bg2"><i class="bg2"></i>融资融券委托</a>',
						'<a href="###" class="bg2 selected"><i class="bg2"></i>港股美股委托</a>',
					'</div>',
					'<div class="', _searchBoxClass, ' ', _fixSearchBoxClass, '">',
						'<input type="text" value="', _inputInitText, '" class="', _searchInputClass, '"/>',
						'<div class="', _inputAttachClass, '" style="display:none;"></div>',
					'</div>',
				'</div>',
				'<div class="', _middleClass, '">',
					'<dl class="', _qsListClass, '"></dl>',
				'</div>',
				'<div class="', _bottomClass, '">',
					'',_adscript,'',
					'<a href="#" class="icons add add3"></a>',
				'</div>',
			'</div>',
			'<div class="', _tipClass, '"></div>'
			);
		} else {
			bodyHtmlArr.push(
			'<div class="', _mainClass, '">',
				'<div class="', _topClass, '">',
					'<div class="ui-tab-wrap">',
						'<a href="###" class="bg2 selected"><i class="bg2"></i>普通委托</a>',
						'<a href="###" class="bg2"><i class="bg2"></i>融资融券委托</a>',
						'<a href="###" class="bg2"><i class="bg2"></i>港股美股委托</a>',
					'</div>',
					'<div class="', _searchBoxClass, ' ', _fixSearchBoxClass, '">',
						'<input type="text" value="', _inputInitText, '" class="', _searchInputClass, '"/>',
						'<div class="', _inputAttachClass, '" style="display:none;"></div>',
					'</div>',
				'</div>',
				'<div class="', _middleClass, '">',
					'<dl class="', _qsListClass, '"></dl>',
				'</div>',
				'<div class="', _bottomClass, '">',
					'',_adscript,'',
					'<a href="#" class="icons add add3"></a>',
				'</div>',
			'</div>',
			'<div class="', _tipClass, '"></div>'
			);
		}
		
		$("body").html(bodyHtmlArr.join(''));
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 初始各选择器
	 */
	function initSelector(){
		_$input = $(getSelector4Class(_searchInputClass));
		_$itemCont = $(getSelector4Class(_qsListClass));
		_$hotItem = $(getSelector4Class(_middleClass));
		_$hotInfoTip = $(getSelector4Class(_tipClass));
		_$confirmBtn = $(getSelector4Class(_butConfirmClass));
		_$cancelBtn = $(getSelector4Class(_butCancelClass));
		_$inputSuggestTip = $(getSelector4Class(_inputAttachClass));
	}

	/**
	 * @Author 冯涛涛
	 * @Data 2011.7.26
	 * @Note 加载已安装列表
	 */
	function loadUserBrokerages(){
		var list = external.getUserBrokerages();
		list = list.split(",");

		return list;
	}

	function getTipName(id){
		var name;
		$.each(_dataStore, function(i, obj){
			if(obj.qsid == id){
				name = obj.key1;
			}
		})
		return name;
	}

	function isAdded(id){
		var flag = false;
		$.each(_addedList, function(i, obj){
			if(obj == id){
				flag = true;
			}
		})
		return flag;
	}

	function getSelector4Class(cls){
		return "." + cls;
	}

	function requestData(__url){
		//alert(_url);
		$.ajax({
				url: __url,
				dataType: 'jsonp',
				cache: true,
				jsonp: false,
				jsonpCallback: 'loadData',
				success: onAjaxSuccess,
				error: function(one,two,three){
					_$itemCont.html('<p style="padding-left:20px; font-size:12px; color:#999; line-height:28px;">网络连接异常，无法获取券商列表</p>');
				}
			}
		);
	};
	function onAjaxSuccess(data){
		//_dataStore = data;
		_dataStore = data["others"];
		_hexin = data["hexin"] || [];
		if(_dataStore){
			dosort(_dataStore);
			attachListener();
			_inited = true;
		} else {

		}
	}

	function changeCallBack(){
		_addedList = loadUserBrokerages();
		if(_keyWords && _keyWords != _inputInitText && _keyWords != ''){
			doSearch(_keyWords);
		}else{
			sortRender(_sortData);
			resetConfirmBtn();
		}
	}

	function resetConfirmBtn(){
		_$confirmBtn.removeClass("add3 add1").addClass("add3");
	}

	generateBody();
	initSelector();

	if(_debug){
		_addedList = [802, 803, 134];//调试数据
	}else{
		_addedList = loadUserBrokerages();
	}

	//请求券商列表数据
	if(us == 1){
		requestData(_loadDealerListUrl3);
	}else{
		requestData(_loadDealerListUrl);		
	}


	inputListener();
	inputLimit(_inputLimitNum);
	_$hotInfoTip.hide();

	if(!_debug){
		external.registerEvent("user_brokerages_changed", changeCallBack);
	}
	var _cIndex = 0;
	//tab点击事件代理
	$(document).delegate('.ui-tab-wrap a','click',function(){
		var target = $(this);
		var index = target.index();
		if(target.hasClass('selected')) return;
		target.addClass('selected').siblings().removeClass('selected');
		_$itemCont.html('<p style="padding-left:20px; font-size:12px; color:#999; line-height:28px;">正在加载数据...</p>');
		_cIndex = index;
		if(index == 0){
			//请求券商列表数据
			requestData(_loadDealerListUrl);
			toVaryWidth();
		} else if(index == 1) {
			//请求券商列表数据
			requestData(_loadDealerListUrl2);
			toVaryWidth();
		} else if(index == 2){
			requestData(_loadDealerListUrl3);
			toVaryWidth();
		}
	});
	//兼容大字体的列表
	var windowWidth = $(window).width();
	if (windowWidth > 464) {
		$('.contentbox').css('width',windowWidth-22);
		$('.qslist').css('width',windowWidth-22);
		$('.footer').css('width',windowWidth-20);
	}
	toVaryWidth();
	function toVaryWidth(){
		if (windowWidth > 464) {
			setTimeout(function(){$('.list_dh p').css('width',windowWidth-60);},2);
		}
	}
});
