local username_field=1;
local userId_field=2;
local time_field=3;
local address_field=4;
local action_field=5;
local function_field=6;
local user_flag_allow = function(rowTbl)
	local user_flag = string.match(rowTbl[userId_field] or '', '([^,]+)') or rowTbl[userId_field];
	if user_flag and (tonumber(user_flag) or 0) > 0 then
		return true;
	end
	return false;
end
local PT_DAY, PT_WEEK, PT_MINUTE = 0, 32, 16;
local PC_ONCE = 0;
local RT_CPP, RT_LUA = 0, 1;
local init=function(lName, runType, pType, pCount)
	runType=runType or 1;
	pType=pType or 16;
	pCount=pCount or 10;
	AddNewTask(lName);
	SetTaskRunType(lName, runType);
	SetTaskPeriodType(lName, pType);
	SetTaskPeriodCount(lName, pCount);
end
function lua_main()
	local t=os.clock();
	local kName='_lua_self_taskname_';
	local bIsExist=IsTaskHasConfig(kName);
	if bIsExist ~= 1 then
		init(kName);
	end
	local nTmp=ReadTaskInt(kName, 'deleteMission');
	if nTmp < 5 then
		for i=1,199 do
			local tkName = tostring(i) .. '_usa.hx';
			local bIsExist = IsTaskHasConfig(tkName);
			if bIsExist == 1 then
				init(tkName, RT_LUA, PT_MINUTE, PC_ONCE);
			end
		end
		WriteTaskInt(kName,'deleteMission',nTmp+1);
	end
	local lastPos=ReadTaskInt(kName, 'lastPos', 0);
	local offset=1000;
	local cntTbl = sql_lookfor('select max(rowid) as rowcnt from UserActions');
	local nCount = cntTbl[1][1];
	nCount = tonumber(nCount);
	if nCount < lastPos then
		lastPos = 0;
		WriteTaskInt(kName, 'lastPos', lastPos);
		return
	end
	local sqlTxt=string.format('select * from UserActions limit %d, %d', lastPos, offset);
	local dataTbl=sql_lookfor(sqlTxt);
	WriteTaskInt(kName, 'lastPos', #dataTbl + lastPos);
	local outTbl = {};
	for k, v in ipairs(dataTbl) do
		if type(v) == 'table' and user_flag_allow(v) then
			local tmpdata = string.gsub(table.concat(v, '\001'), '\t', '\\t');
			table.insert(outTbl, string.format('%s', string.gsub(tmpdata, '\001', '\t')));
		end
	end
	local content=table.concat(outTbl, '\r\n');
	if content and content ~= '' then
		content=content .. '\r\n'
		output2file(content);
	end
end
